module com_morgan

   !&E
   !&E ** common pour calcul en fonction du temps avec differentes reactions
   !&E
                                                   
use parametres        
logical                                   :: l_mode1c
                                                   
!---------------------------------------
!  caracteristiques du contaminant
!---------------------------------------
character(len=lchain)            :: name_conta,unite_conta,name_file_varmilsens
character(len=lchain)            :: name_file_res,name_fileconta,name_file_varmilfix
real(kind=rlg)                   :: c_conta_tot0,c_conta_air,conversunit
real(kind=rlg)                   :: pdmolec,henry,henry_adim,xnb_schmidt
real(kind=rlg)                   :: diffusivite,coefH_staudinger,cte_salt
real(kind=rlg),dimension(:),allocatable     :: cin_hydrol,cin_photo,cin_biodeg
integer                          :: nvar,nesp_diss,nespt,nesp_part_eq,ncat,nthiolp
integer                          :: nesp_part_ne,nesp_part_ci,nesp_part_tot
integer                          :: nespt_echeq,nesp_diss_eq,nesp_diss_ne
integer,dimension(:),allocatable :: n_dom_nl,isub_esp,iesp_assoc,ityp_part
integer,dimension(:),allocatable :: ichoix_ceqci
real(kind=rlg),dimension(:),allocatable     :: f_dom_l,finit,cmes_esp
real(kind=rlg),dimension(:,:),allocatable   :: f_dom_nl, sksc,cesp
character(len=lchain),dimension(:),allocatable :: name_esp,name_sub_esp
REAL(KIND=rlg),dimension(:),allocatable     :: c_conta_tot0_sens
REAL(KIND=rlg),dimension(:),allocatable     :: c_conta_tot_init
!---------------------------------------
!  caracteristiques du contaminant avec Iteration
!---------------------------------------
integer                                       :: ivar_esp
integer                                       :: nparv,isubvar,ncalcul
real(kind=rlg)                                :: henry_adimi
real(kind=rlg),dimension(:),allocatable       :: c_conta_ech
real(kind=rlg),dimension(:),allocatable       :: c_conta_tot,pdmolecv,cte_saltv
real(kind=rlg),dimension(:),allocatable       :: xnb_schmidtv,henryv
real(kind=rlg),dimension(:),allocatable       :: diffusivitev,henry_adimv
real(kind=rlg),dimension(:),allocatable       :: coefH_staudingerv
real(kind=rlg),dimension(:,:),allocatable     :: csub_v,xpart_espv
real(kind=rlg),dimension(:,:),allocatable     :: finitv,cin_hydrolv
real(kind=rlg),dimension(:,:),allocatable     :: cparamv,cin_biodegv,cte_vitv
real(kind=rlg),dimension(:,:),allocatable     :: ceq_civ,cin_max_rev,cpart_v
real(kind=rlg),dimension(:,:),allocatable     :: cin_photov,fpart_v
!!!!!real(kind=rlg),dimension(:,:),allocatable     :: f_dom_lv
!!!!!real(kind=rlg),dimension(:,:,:),allocatable   :: xpartnlv,f_dom_nlv,xsorptnlv

!---------------------------------------
! Caractristiques des reactions
!---------------------------------------
integer                                   :: nb_reac
integer,dimension(:),allocatable          :: ityp_arrh,nb_var_re
integer,dimension(:),allocatable          :: nb_flim1,nb_flim2
integer,dimension(:,:),allocatable        :: irkm_var_re,irkm_flim1,irkm_flim2
real(kind=rlg),dimension(:),allocatable   :: teta_arrh,tempref_arrh
real(kind=rlg),dimension(:),allocatable   :: xeta_sigma_arrh,cin_max_re
real(kind=rlg),dimension(:,:),allocatable :: cte_flim1,cte_flim2,coef_stochio
real(kind=rlg),dimension(:,:),allocatable :: expo_var
logical,dimension(:),allocatable          :: l_arrh
character(len=lchain),dimension(:),allocatable   :: name_reac
character(len=lchain),dimension(:,:),allocatable :: name_var_re
    
!---------------------------------------
! Resultats
!---------------------------------------
real(kind=rlg),dimension(:,:),allocatable :: pcent_cesp
real(kind=rlg),dimension(:),allocatable   :: xpartg

!---------------------------------------
! Sorption
!---------------------------------------
real(kind=rlg),dimension(:,:),allocatable :: xpartnl,xsorptnl
real(kind=rlg),dimension(:),allocatable   :: cte_vit,ceq_ci,xpart_esp
logical                                   :: l_langmuir,l_dom_nl

!---------------------------------------
! Volatilisation
!---------------------------------------
integer                                   :: ich_sco2_temp,iesp_volat

logical                                   :: l_volat,l_volkl_dif,l_volkl_sal
logical                                   :: l_volkl_cor,l_volkg_cor
integer                                   :: ich_volkl_wind
real(kind=rlg)                            :: cf_expvol_liq,cf_expvol_gas
real(kind=rlg)                            :: massmol_h2o,massmol_co2
real(kind=rlg)                            :: massmol_o2,cf_difwat_co2
real(kind=rlg)                            :: cf_difwat_o2,cf_difair_h2o
real(kind=rlg)                            :: cst_gas_univ,thick_volat
real(kind=rlg)                            :: xkol
      
!
end module com_morgan
