MODULE lectur_conta

   !!======================================================================
   !!                   ***  MODULE  lecture du contaminant  ***
   !!======================================================================
   !! * Modules used
USE parametres
USE com_morgan
USE com_varmilieu
#ifdef key_moco
  USE com_moco
#endif
IMPLICIT NONE
PRIVATE

   !! * Accessibility
PUBLIC lect_1conta     ! routine called by moco_morgan.F90
PUBLIC lect_contavar   ! routine called by moco_morgan.F90

   !! * Shared module variables
character(len=lchain)            :: nambid
character(len=4)                 :: choix_ceqci

   !! * Private variables

 CONTAINS

!!======================================================================
!
                SUBROUTINE lect_1conta
!&E---------------------------------------------------------------------
!          Lecture des caractristiques du contaminant
!       dans un fichier tir d'une bibliotheque de contaminant
!                   pour l_mode1c=.true. 
!     (un contaminant caractris par un seul jeu de parametres)
!&E---------------------------------------------------------------------
   !! * Modules used
   
   !! * Local declarations
 integer                          :: iesp,iupart_esp,ilig,iespmoc,isit
 integer                          :: inl,iupartnl,ici,il,iespl,ire,nb_reac_plus
 integer                          :: nb_reac0,it,iv,nfunct_limit,ityp_flim
 integer                          :: nfl1,nfl2,iflim,ixx,js,i,ninc
 integer                          :: pos1,pos2,pos3,pos4,pos5,pos6,pos7,pos8
 real(kind=rlg)                   :: cte_flim,xx
 character(len=lchain)            :: namelu,unite_xequ
 character(len=lchain)            :: namvar_flim,name_esp_assoc
 character(len=1)                 :: unitc
 logical                          :: l_var_sim

!****************************************************************************
      
 write(*,*)'vous lisez les caracteristiques du contaminant'
 write(*,*)'dans le fichier : ',TRIM(ADJUSTL(ADJUSTR(name_fileconta)))
 open(68,file='donconta/'//TRIM(ADJUSTL(ADJUSTR(name_fileconta))))
 read(68,*)
 read(68,*)
#ifdef MODTEST
   write(*,*)'lecture conta  :' 
#endif
 read(68,*)nambid,namelu
 if(TRIM(ADJUSTL(ADJUSTR(namelu))).ne.TRIM(ADJUSTL(ADJUSTR(name_conta))))then
     write(*,*)'ATTENTION'
     write(*,*)'vous lisez les caracteristiques d un contaminant'
     write(*,*)'qui s appelle : ',TRIM(ADJUSTL(ADJUSTR(namelu)))
     write(*,*)'ce n est pas le meme que vous avez demand'
     write(*,*)'qui s appellait : ',TRIM(ADJUSTL(ADJUSTR(name_conta)))
     stop
 endif 
 write(*,*)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,unite_conta
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,pdmolec
 write(*,*)'le poids moleculaire de ce contaminant est =',pdmolec
 
!  determination du facteur de conversion
!   besoin si on utilise MOCO seulement 
!    car les calculs se font en nmole/L (mole/m3)
! ========================================
 conversunit=1.d00
#ifdef key_moco
 pos1=index(unite_conta,'mole')
 pos2=index(unite_conta,'g')
 if(pos1/=0)then
    conversunit=1.d+00
 else if(pos2/=0)then
    conversunit=1.d+00/pdmolec
    pos1=pos2
 else
     write(*,*)'ATTENTION'
     write(*,*)'l unite indiquee pour le contaminant'
     write(*,*)'n est exprime ni en gramme, ni en mole'
     write(*,*)'bien note "g" ou "mole" ou "nmole" ou "kg" ..'
     stop
 endif
 if(pos1>1)then
   unitc=unite_conta(pos1-1:pos1-1)
   pos2=index(unite_conta,'micro')
   if(unitc=='n')then
      conversunit=conversunit*1.d-03
   else if (unitc==''.or.pos2/=0)then
      conversunit=conversunit*1.d+00
   else if (unitc=='m')then
      conversunit=conversunit*1.d+03
   else if (unitc=='k')then
      conversunit=conversunit*1.d+09
   endif
 endif
 write(*,*)'l unite de masse de ce contaminant etant :',   &
                 TRIM(ADJUSTL(ADJUSTR(unite_conta)))
 write(*,*)'le facteur de conversion pour les calculs en nmole/L =',conversunit   
#endif

#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,xnb_schmidt
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 write(*,*)'son nbre de Schmidt dans l eau  est =',xnb_schmidt
 read(68,*)nambid,diffusivite
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 write(*,*)'sa diffusivite dans l air est =',diffusivite
 read(68,*)nambid,henry
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,henry_adim
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,coefH_staudinger
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,cte_salt
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)
 if(henry.ne.0)then
     write(*,*)'on utilise la constante de Henry =',henry
 else
     write(*,*)'la Constante de Henry pour ce contaminant' 
     write(*,*)'est nulle (inconnue), on utilisera donc la'
     write(*,*)'constante de Henry adimensionnelle =',henry_adim
 endif

! les especes dissoutes comprennent ici les especes dissoutes liees
!   des ligands (ou substrats) organiques et inorganiques
!   (SANS COMPTER L'ESPECE LIBRE pour organique ou l ION LIBRE pour les metaux)
! il y a les especes dissoutes en equilibre (partage avec MOCO ou partage global)
! et les especes dissoutes qui ne subissent pas de partage
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_diss_ne
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_diss_eq
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_part_eq
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_part_ci
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_part_ne
#ifdef key_moco
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,l_group_espdmoc
 nesp_diss_moco=nesp_diss_eq
 if(l_group_espdmoc.and.nesp_diss_moco.ne.0)then
     nesp_diss=nesp_diss_ne+1
 else
     nesp_diss=nesp_diss_ne+nesp_diss_moco
 endif
#else
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)
 nesp_diss=nesp_diss_ne+nesp_diss_eq
#endif
           
 nesp_part_tot=nesp_part_eq+nesp_part_ci+nesp_part_ne
 nespt=nesp_diss+nesp_part_tot
! si echange cationique : 1 variable en plus du metal sur une phase echangeur
! si complexation avec sites thiols : 2 variables en plus du metal sur les monodentate et bidentate
#ifdef key_moco
 if(l_echgcat)then
  iesp_echgcat=nespt+1
  nespt=nespt+1
 endif
! if(l_thiolpart)then
!  iesp_thiol_mono=nespt+1
!  iesp_thiol_bi=nespt+2
!  nespt=nespt+2
! endif
#endif
!   nombre de variables totales (+dissoute libre qui sera la derniere)
 nvar=nespt+1
 write(*,*)
!

 write(*,*)'le nombre d especes dissoutes prises en compte'
 write(*,*)'(en + de l"ion "libre" pour metaux ou de l"espece libre pour organiques)' 
 write(*,*)'est egal  :',nesp_diss
 write(*,*)'dont ',nesp_diss_ne,' variables qui ne subissent pas de partage a l equilibre'
#ifdef key_moco
 if(l_group_espdmoc.and.nesp_diss_moco.ne.0)then
      write(*,*)'dont une variable dissoute globale qui regroupe '
      write(*,*)' les especes dissoutes en equilibre thermodynamique   '
      write(*,*)' prises en compte par MOCO pour les metaux  '
 else
      write(*,*)'dont ',nesp_diss_moco,' variables dissoutes '
      write(*,*)'correspondant aux especes dissoutes en equilibre  '
      write(*,*)'thermodynamique prises en compte par MOCO pour les metaux  '
 endif
#endif 
 write(*,*)
 write(*,*)'les nombres d especes particulaires prises en compte sont :'
 write(*,*)'   sorption a l equilibre:',nesp_part_eq
 write(*,*)'   sorption lineaire CINETIQUE:',nesp_part_ci
 write(*,*)'   NON ECHANGEABLES',nesp_part_ne
#ifdef key_moco
 if(l_echgcat)write(*,*)'   + phase echangeur de cation'
! if(l_thiolpart)write(*,*)'   + sites thiols particulaires monodentate et bidentate'
#endif 
     
 allocate(n_dom_nl(nespt))
 allocate(name_esp(nvar))
 allocate(isub_esp(nespt))
 allocate(name_sub_esp(nespt))
 allocate(xpart_esp(nespt))
 allocate(cin_hydrol(nvar))
 allocate(cin_photo(nvar))
 allocate(cin_biodeg(nvar))
 
 cin_hydrol(:)=0.
 cin_photo(:)=0.
 cin_biodeg(:)=0.
 
#ifdef MODTEST
   write(*,*)'lecture conta s avt esp.diss.libres:',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)
 read(68,*)
 read(68,*)
!!!!!!!!!!!!!!! especes dissoutes libres (en plus de l'ion libre a l equilibre)
!!!!!!!!! ET NON LIEES A UN SUBSTRAT ET NON EN EQUILIBRE
 do iesp=1,nesp_diss_ne
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)namelu,nambid
    name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
    name_sub_esp(iesp)=''
    write(*,*)'nom de l espece dissoute sans partage numero :',iesp,' = ', &
                             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))) 
    xpart_esp(iesp)=0.                     
#if ! defined key_moco
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_hydrol(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    cin_hydrol(iesp)=cin_hydrol(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_photo(iesp)
    cin_photo(iesp)=cin_photo(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_biodeg(iesp)
    cin_biodeg(iesp)=cin_biodeg(iesp)/86400          
#endif 
 enddo        
#ifdef MODTEST
   write(*,*)'lecture conta :  5 lignes avant esp diss eq :' 
#endif
 read(68,*)
 read(68,*)
 read(68,*)
 read(68,*)
 read(68,*)
 write(*,*)
 
!!!!!!!!!!!!!!! especes dissoutes autres que libre mais subissant partage
#ifdef key_moco
! partage calcule par resolution des equations en equilibre thermodynamique (MOCO)
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!  lecture de toutes les especes dissoutes liees aux ligands mineraux et organiques
!  regroupement ou pas dans une seule variable
if(l_echgcat .and. nesp_diss_moco==0)then
! allocation et initialisation  au moins une valeur
  allocate(nom_espdmoco(1))
  allocate(iespd_moco(1))
  allocate(xequ(1))
  allocate(nom_lig_esp(1))
  allocate(ichare(1))
  allocate(xfactl(1))
  allocate(xfacth_esp(1))
  allocate(ilig_esp(1))
  iespd_moco(1)=0
  xequ(1)=0.
  ichare(1)=0
  xfactl(1)=0.
  xfacth_esp(1)=0.
  ilig_esp(1)=0
else
  allocate(nom_espdmoco(nesp_diss_moco))
  allocate(iespd_moco(nesp_diss_moco))
  allocate(xequ(nesp_diss_moco))
  allocate(nom_lig_esp(nesp_diss_moco))
  allocate(ichare(nesp_diss_moco))
  allocate(xfactl(nesp_diss_moco))
  allocate(xfacth_esp(nesp_diss_moco))
  allocate(ilig_esp(nesp_diss_moco))
endif
do iesp=1,nesp_diss_moco
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,nom_espdmoco(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,nom_lig_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,unite_xequ,xx,xequ(iesp)
   ixx=nint(xx)
   if(ixx==10)then
          xequ(iesp)=10**xequ(iesp)
   endif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,ichare(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,xfactl(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,xfacth_esp(iesp)
   if(iesp==1)then
      nlig=1
   else if(nom_lig_esp(iesp) .ne. nom_lig_esp(iesp-1))then
     nlig=nlig+1     
   endif 
   ilig_esp(iesp)=nlig
enddo


if(l_group_espdmoc.and.nesp_diss_moco.ne.0)then
  iesp=nesp_diss_ne+1
  name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(name_conta)))//'_lig_moco'
  name_sub_esp(iesp)='ligand_moco'
  write(*,*)'nom de l espece dissoute numero :',iesp,' = ', &
                             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
  write(*,*)'nom du "substrat" de l espece diss numero :',iesp, &
                      ' = ',TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
  iespd_moco(1)=iesp                    
  xpart_esp(iesp)=0.
else
  do iesp=nesp_diss_ne+1,nesp_diss
    name_esp(iesp)=nom_espdmoco(iesp-nesp_diss_ne)
    name_sub_esp(iesp)=nom_lig_esp(iesp-nesp_diss_ne)
    write(*,*)'nom de l espece dissoute numero :',iesp,' = ', &
                             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
    write(*,*)'nom du "substrat" de l espece diss numero :',iesp, &
                      ' = ',TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
                      
    iespd_moco(iesp-nesp_diss_ne)=iesp                    
    xpart_esp(iesp)=xequ(iesp-nesp_diss_ne)
  enddo           
endif
 
#else
! partage calcule par relation globale
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
do iesp=nesp_diss_ne+1,nesp_diss
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)namelu,nambid
    name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)namelu,nambid
    name_sub_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
    write(*,*)'nom de l espece dissoute numero :',iesp,' = ', &
                             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
    write(*,*)'nom du "substrat" de l espece diss numero :',iesp, &
                      ' = ',TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
                      
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,unite_xequ,xx,xpart_esp(iesp)
    ixx=nint(xx)
    pos1=index(unite_xequ,'mL/g')
    pos2=index(unite_xequ,'ml/g')
    pos3=index(unite_xequ,'L/kg')
    pos4=index(unite_xequ,'l/kg')
    if(pos1/=0. .or. pos2/=0. .or. pos3/=0. .or. pos4/=0.)then
      if(ixx==10)then
         write(*,*)'coefs de partage donne en log10(mL/g)',xpart_esp(iesp)
         xpart_esp(iesp)=10**(xpart_esp(iesp))/1000
      else
         write(*,*)'coefs de partage donne en mL/g',xpart_esp(iesp)
         xpart_esp(iesp)=xpart_esp(iesp)/1000       
      endif
    else
      pos5=index(unite_xequ,'L/g')
      pos6=index(unite_xequ,'l/g')
      pos7=index(unite_xequ,'m3/kg')
      pos8=index(unite_xequ,'m3/Kg')
      if(pos5/=0. .or. pos6/=0. .or. pos7/=0. .or. pos8/=0.)then
         if(ixx==10)then
           write(*,*)'coefs de partage donne en log10(L/g)',xpart_esp(iesp)
           xpart_esp(iesp)=10**(xpart_esp(iesp))
         else
           write(*,*)'coefs de partage donne en L/g',xpart_esp(iesp)
         endif
       else
         write(*,*)'ATTENTION A L UNITE du coefs de partage ',xpart_esp(iesp)
         write(*,*)'il est utilise tel quel '
      endif
    endif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_hydrol(iesp)
    cin_hydrol(iesp)=cin_hydrol(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_photo(iesp)
    cin_photo(iesp)=cin_photo(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_biodeg(iesp)
    cin_biodeg(iesp)=cin_biodeg(iesp)/86400          
 enddo        
#endif
#ifdef MODTEST
   write(*,*)'lecture conta :  7 lignes avt esp part eq :'
#endif
 read(68,*)
 read(68,*)
 read(68,*)
 read(68,*)
 read(68,*)
 read(68,*)
 read(68,*)
 write(*,*)
!
 
!!!!!!!!!!! variables particulaires partage  l'EQUILIBRE 
!   2 cas possibles : MOCO (lire les charges, surfaces specifiques nmbre de sites etc..
!                 ou partage global : non lineaire posible
#ifdef key_moco
!   une espece correspondt  la somme des conc de chacun des sites sur une phase 
!   substrat particulaire ou phase :   surface specifique ssp (m2/g)
!      cte intrinseque xequa1 et 2 ;
!      nombre de sites de surface pour chaque substrat ou phase  : nsit
!      par phase  : nombre de sites actifs sitac (moles/g) par type de site
nphasp=nesp_part_eq
if(nphasp>0)then
  allocate(nom_phase(nphasp))
  allocate(iespp_moco(nphasp))
  allocate(xequa1(nsitmoco_max,nphasp))
  allocate(xequa2(nsitmoco_max,nphasp))
  allocate(xequms(nsitmoco_max,nphasp))
  allocate(ityp_sit(nsitmoco_max,nphasp))
  allocate(ssp(nphasp))
  allocate(sitac(nsitmoco_max,nphasp))
  allocate(nsit(nphasp))
  allocate(idchars(nsitmoco_max,nphasp,2))
  allocate(idcharm(nsitmoco_max,nphasp))
  allocate(idchar2m(nphasp))
  allocate(ika1(nsitmoco_max,nphasp))
endif
l_dom_nl=.false.
js=0
if(l_echgcat.and.nesp_part_eq==0)then
  ! initialisation  0
  allocate(iespp_moco(1))
  iespp_moco(1)=nesp_diss+1 
endif
!if(l_thiolpart.and.nesp_part_eq==0)then
!  ! initialisation  0
!  allocate(iespp_moco(1))
!  iespp_moco(1)=nesp_diss+1 
!endif
#else
allocate(f_dom_nl(nespt,2))
allocate(xpartnl(nespt,2))
allocate(xsorptnl(nespt,2))
#endif

do iesp=nesp_diss+1,nesp_diss+nesp_part_eq
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)namelu,nambid
   name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)namelu,nambid
   name_sub_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
   write(*,*)'nom de l espece particulaire Lin numero',iesp,' = ',   &
                              TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
   write(*,*)'nom du "substrat" de l espece part numero',iesp,' = ',  &
                              TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
#ifdef key_moco
  if(l_moco_op)then
     js=1
     nom_phase(js)='MESt'
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)nambid
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)nambid,ssp(js)
     nsit(js)=1
  else
     js=js+1
     nom_phase(js)=name_sub_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)nambid,nsit(js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
      read(68,*)nambid,ssp(js)
      write(*,*)
      write(*,*)'PHASE :',nom_phase(js)       
      write(*,*)'nombre de site sur cette phase :',nsit(js) 
  endif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)
  do isit=1,nsit(js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       read(68,*)nambid,ityp_sit(isit,js)
   ! sitac : nbre de site actif donne en micromol/m2, converti en mole/m2
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       read(68,*)nambid,sitac(isit,js)
      sitac(isit,js)=sitac(isit,js)*1.d-6
     if(ityp_sit(isit,js)==1)then
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,xx,xequa1(isit,js),idchars(isit,js,1)
          ixx=nint(xx)
          if(ixx==10)xequa1(isit,js)=10**xequa1(isit,js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,xx,xequa2(isit,js),idchars(isit,js,2)
          ixx=nint(xx)
          if(ixx==10)xequa2(isit,js)=10**xequa2(isit,js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,xx,xequms(isit,js),idcharm(isit,js)
          ixx=nint(xx)
          if(ixx==10)xequms(isit,js)=10**xequms(isit,js)
          ika1(isit,js)=1
     else if(ityp_sit(isit,js)==2)then
          ika1(isit,js)=0
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,xx,xequa2(isit,js),idchars(isit,js,2)
          ixx=nint(xx)
          if(ixx==10)xequa2(isit,js)=10**xequa2(isit,js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,xx,xequms(isit,js),idcharm(isit,js)
          ixx=nint(xx)
          if(ixx==10)xequms(isit,js)=10**xequms(isit,js)
     endif
  enddo
  iespp_moco(js)=iesp  
                              
#else
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,unite_xequ,xx,xpart_esp(iesp)
  ixx=nint(xx)
  pos1=index(unite_xequ,'mL/g')
  pos2=index(unite_xequ,'ml/g')
  pos3=index(unite_xequ,'L/kg')
  pos4=index(unite_xequ,'l/kg')
  if(pos1/=0. .or. pos2/=0. .or. pos3/=0. .or. pos4/=0.)then
      if(ixx==10)then
         write(*,*)'coefs de partage donne en log10(mL/g)',xpart_esp(iesp)
         xpart_esp(iesp)=10**(xpart_esp(iesp))/1000
      else
         write(*,*)'coefs de partage donne en mL/g',xpart_esp(iesp)
         xpart_esp(iesp)=xpart_esp(iesp)/1000       
      endif
  else
      pos5=index(unite_xequ,'L/g')
      pos6=index(unite_xequ,'l/g')
      pos7=index(unite_xequ,'m3/kg')
      pos8=index(unite_xequ,'m3/Kg')
      if(pos5/=0. .or. pos6/=0. .or. pos7/=0. .or. pos8/=0.)then
         if(ixx==10)then
           write(*,*)'coefs de partage donne en log10(L/g)',xpart_esp(iesp)
           xpart_esp(iesp)=10**(xpart_esp(iesp))
         else
           write(*,*)'coefs de partage donne en L/g',xpart_esp(iesp)
         endif
      else
         write(*,*)'ATTENTION A L UNITE du coefs de partage ',xpart_esp(iesp)
         write(*,*)'il est utilise tel quel '
      endif
  endif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,n_dom_nl(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)
   if(n_dom_nl(iesp).ne.0)then
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
      read(68,*)nambid,l_langmuir
      l_dom_nl=.true.
      if((l_langmuir).and.(n_dom_nl(iesp).gt.1.or.nesp_part_eq.gt.1))then
            write(*,*)'ATTENTION ::  si on choisit le modele DMM '
            write(*,*)'il ne peut y avoir qu UNE SEULE espece '
            write(*,*)'particulaire a l equilibre '
            write(*,*)' avec UN SEUL domaine non lineaire'
            stop
      endif
      do inl=1,n_dom_nl(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         read(68,*)nambid,f_dom_nl(iesp,inl)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         read(68,*)nambid,iupartnl,xpartnl(iesp,inl)         
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         read(68,*)nambid,xsorptnl(iesp,inl)         
         if(iupartnl.eq.10)then
            xpartnl(iesp,inl)=10**xpartnl(iesp,inl)
         endif
         if(l_langmuir)then
            write(*,*)' modele non lineaire DMM avec Langmuir ' 
            write(*,*)' KL= ',xpartnl(iesp,inl),' Qmax= ' ,xsorptnl(iesp,inl)
         else
           write(*,*)' modele non lineaire DRM avec Freundlich ' 
            write(*,*)' KF= ',xpartnl(iesp,inl),' n= ',xsorptnl(iesp,inl)
         endif
       enddo
    endif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_hydrol(iesp)
    cin_hydrol(iesp)=cin_hydrol(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_photo(iesp)
    cin_photo(iesp)=cin_photo(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid,cin_biodeg(iesp)
    cin_biodeg(iesp)=cin_biodeg(iesp)/86400          
#endif
enddo        
#ifdef key_moco
if(l_moco_op)then
    if(nesp_part_eq==0.and. .not.l_echgcat)then
      write(*,*)'ATTENTION : problme car si on a choisi d utiliser MOCO'
      write(*,*)'et echange cationique il faut qu il y ait au moins '
      write(*,*)'une espece particulaire en equilibre'
      stop
!    else if(nesp_part_eq==0.and. .not.l_thiolpart)then
!      write(*,*)'ATTENTION : problme car si on a choisi d utiliser MOCO'
!      write(*,*)'et sites thiols particulaires il faut qu il y ait au moins '
!      write(*,*)'une espece particulaire en equilibre'
!      stop
    else if(nesp_part_eq>1)then
      write(*,*)'ATTENTION : problme car si on a choisi d utiliser MOCO'
      write(*,*)'en mode operationnel, il ne faut pas qu il y ait plus'
      write(*,*)' d"une espece particulaire en equilibre'
      stop
    endif  
endif  
!  calcul du nombre indice pour chaque substrat en fonction du 
!                 nombre de substrat et du nombre de sites pas substrat 
!======================================================================
if(nphasp.ne.0)then
  allocate(nsubsi(nphasp))
  nsubsi(1)=0
  do js=2,nphasp
    nsubsi(js)=nsubsi(js-1)+nsit(js-1)
  enddo
  nsubsit=nsubsi(nphasp)+nsit(nphasp)
endif
#endif


#ifdef MODTEST
   write(*,*)'lecture conta :  3 lignes avt esp.part.cin :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)
read(68,*)
read(68,*)
        
!!!!!!!!!! variables particulaires avec sorption EN CINETIQUE
allocate(finit(nespt))
if(nesp_part_ci>0)then
   allocate(cte_vit(nesp_part_ci))
   allocate(ceq_ci(nesp_part_ci))
   allocate(ichoix_ceqci(nesp_part_ci))
   allocate(iesp_assoc(nespt))
endif
do ici=1,nesp_part_ci
   iesp=nesp_diss+nesp_part_eq+ici
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)namelu,nambid
   name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)namelu,nambid
   name_esp_assoc=TRIM(ADJUSTL(ADJUSTR(nambid)))
   write(*,*)'nom de l espece particulaire CIN numero',iesp,' = ',  &
                     TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
   write(*,*)'nom de l espece a l equilibre associe : ',   &
                      TRIM(ADJUSTL(ADJUSTR(name_esp_assoc)))
   do il=1,nesp_part_eq
      iespl=nesp_diss+il
      if(TRIM(ADJUSTL(ADJUSTR(name_esp(iespl))))==  &
         TRIM(ADJUSTL(ADJUSTR(name_esp_assoc))))then
         iesp_assoc(iesp)=iespl
      endif
   enddo
! fraction intiale par rapport  la conc. totale
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,finit(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,cte_vit(ici)
   
! choix de pouvoir donner la concentration  l'quilibre 
!    soit en masse/kg de particules ('M/kg')
!    soit en fraction de la concentration totale initiale de contaminant ('f/C0')
!    soit = conc equilibre de lespece associe /2 (Ceq2)
!      
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,ceq_ci(ici),choix_ceqci
   if(choix_ceqci=='M/kg')then
      ichoix_ceqci(ici)=0
   else if(choix_ceqci=='f/C0')then
      ichoix_ceqci(ici)=1
   elseif(choix_ceqci=='Ceq2')then
      ichoix_ceqci(ici)=2
       ! dans ce cas, on divise par 2 la constante de partage de l'espece associee
       !  pour avoir une conc  l'quilibre /2 et il y aura un transfert progressif
       !  de l'une vers l'autre jusqu' atteindre la conc total= 2*conc equilibre 
      xpart_esp(iesp_assoc(iesp))=xpart_esp(iesp_assoc(iesp))*0.5
   endif
   cte_vit(ici)=cte_vit(ici)/86400.
   name_sub_esp(iesp)=name_sub_esp(iesp_assoc(iesp))
   xpart_esp(iesp)=xpart_esp(iesp_assoc(iesp))
#if ! defined key_moco
   cin_hydrol(iesp)=cin_hydrol(iesp_assoc(iesp))
   cin_photo(iesp)=cin_photo(iesp_assoc(iesp))
   cin_biodeg(iesp)=cin_biodeg(iesp_assoc(iesp))
#endif
enddo
nespt_echeq= nesp_diss+nesp_part_eq       
#ifdef MODTEST
   write(*,*)'lecture conta :  3 lignes avat esp part NE :' 
#endif
read(68,*)
read(68,*)
read(68,*)
        
!!!!!!!!!!!! variables particulaires SANS sorption / desorption (NON ECHANGeable)
allocate(ityp_part(nespt))
do iesp=nesp_diss+nesp_part_tot-nesp_part_ne+1,nesp_diss+nesp_part_tot
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)namelu,nambid
   name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)namelu,ityp_part(iesp)
   write(*,*)'nom de l espece particulaire NE n',iesp,' = ',   &
                         TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
   write(*,*)'numero du type de particule associe',ityp_part(iesp)
   write(name_sub_esp(iesp),*)ityp_part(iesp)
   name_sub_esp(iesp)='NON ECHG SUR PART n'//TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
! fraction intiale par rapport  la conc. totale (part et dissoute)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,finit(iesp)
#if ! defined key_moco
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,cin_hydrol(iesp)
   cin_hydrol(iesp)=cin_hydrol(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,cin_photo(iesp)
   cin_photo(iesp)=cin_photo(iesp)/86400
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,cin_biodeg(iesp)
   cin_biodeg(iesp)=cin_biodeg(iesp)/86400          
#endif
enddo 
            
!!!!!!!!!!!!! variable dissoute libre
#ifdef MODTEST
   write(*,*)'lecture conta : 3 lignes avt esp diss.libre :'
#endif
read(68,*)
read(68,*)
read(68,*)
#ifdef key_moco
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)namelu,nambid,icharlib
name_esp(nvar)=TRIM(ADJUSTL(ADJUSTR(nambid)))
#else
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)namelu,nambid
name_esp(nvar)=TRIM(ADJUSTL(ADJUSTR(nambid)))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)nambid,cin_hydrol(nvar)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)nambid,cin_photo(nvar)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)nambid,cin_biodeg(nvar)
cin_hydrol(nvar)=cin_hydrol(nvar)/86400
cin_photo(nvar)=cin_photo(nvar)/86400
cin_biodeg(nvar)=cin_biodeg(nvar)/86400
#endif
!!!!!!!!!!!!!
!!!!!!!!!!!!!   parametres pour la volatilisation
!!!!!!!!!!!!!   =================================
#ifdef MODTEST
   write(*,*)'lecture conta : 3 lignes avt volat :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)
read(68,*)
read(68,*)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)nambid,l_volat
if(l_volat)then
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,namelu
  do iesp=1,nvar
    if(TRIM(ADJUSTL(ADJUSTR(namelu)))==TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))))then
      iesp_volat=iesp
       exit
     endif
  enddo
  write(*,*)
  write(*,*)'l espece qui se volatilise est l espece numero :',iesp_volat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,l_volkl_dif
! l_volkl_dif : choix de la formule pour coef de transfert phase liquide
!              par diffusion turbulente 
!              true pour Churchill ou false pour O'Connor 
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,l_volkl_sal
! l_volkl_sal : choix de la prise en compte de l'effet de sel (true si oui)
!              par formule de Wen  pour coef de transfert phase liquide
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,ich_volkl_wind
! ich_volkl_wind : choix de la formule pour coef de transfert phase liquide
!              par turbulence engendree par le vent 
!              1 pour Schwartzenbach 
!              2 pour Wanninkhof 
!              3 pour Nightingale 
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,l_volkl_cor
! l_volkl_cor : choix de la proprit pour correction du coefficient  
!               de transfert phase liquide
!               par nombre de Schmidt (true) ou par masse molaire (false) 
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,cf_expvol_liq
! cf_expvol_liq : exposant du rapport des proprits pour phase liquide 
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,l_volkg_cor
! l_volkg_cor : choix de la proprit pour correction du coefficient 
!               de transfert phase gazeuse
!               par diffusivite (true) ou par massse molaire (false) 
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,cf_expvol_gas
! cf_expvol_gas  : exposant du rapport des proprits pour phase gazeuse
    
else
!  pas de volatilisation ; on ne lit pas les paramtres
#ifdef MODTEST
   write(*,*)'lecture conta :  8 lignes volatilisation non lues '
#endif
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
endif
massmol_h2o=18.d00
massmol_co2=44.d00
massmol_o2=32.d00
cf_difwat_co2=1.77d-9
cf_difwat_o2=2.3d-9
cf_difair_h2o=0.25d-4
cst_gas_univ=8.314d00  

!!!!!!!!! autres ractions non spcifiques et gnriques
!!!!!!!!!   de TRANSFERT D'UNE ESPECE  L'AUTRE 
!!!!!!!!!   =================================================
      
ire=0
do iesp=1,nvar
   if(cin_hydrol(iesp).ne.0.)ire=ire+1
   if(cin_biodeg(iesp).ne.0.)ire=ire+1
   if(cin_photo(iesp).ne.0.)ire=ire+1
enddo      
nb_reac0=ire
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)      
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)      
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)nambid,nb_reac_plus
nb_reac=ire+nb_reac_plus

allocate(name_reac(nb_reac))
allocate(cin_max_re(nb_reac))
allocate(l_arrh(nb_reac))
allocate(ityp_arrh(nb_reac))
allocate(teta_arrh(nb_reac))
allocate(tempref_arrh(nb_reac))
allocate(xeta_sigma_arrh(nb_reac))
allocate(nb_var_re(nb_reac))
allocate(name_var_re(nb_reac,2))
allocate(irkm_var_re(nb_reac,2))
allocate(coef_stochio(nb_reac,2))
allocate(expo_var(nb_reac,2))
allocate(nb_flim1(nb_reac))
allocate(nb_flim2(nb_reac))

!!!!!!!!!   introduction des reactions de photolyse, biodeg et hydrolyse 
!!!!!!!!!   du premier ordre  dans ce cadre
ire=0
if(nb_reac0>0)then
  do iesp=1,nvar
    if(cin_hydrol(iesp).ne.0.or.cin_biodeg(iesp).ne.0.or.cin_photo(iesp).ne.0.)then
       write(nambid,"(i1)")iesp
       if(cin_hydrol(iesp).ne.0.)then
          ire=ire+1
          name_reac(ire)='HYDROLYSE DE L ESPECE '//TRIM(ADJUSTL(ADJUSTR(nambid)))
          cin_max_re(ire)=cin_hydrol(iesp)
       else if(cin_biodeg(iesp).ne.0.)then
          ire=ire+1
          name_reac(ire)='BIODEGRADATION DE L ESPECE '//TRIM(ADJUSTL(ADJUSTR(nambid)))
          cin_max_re(ire)=cin_biodeg(iesp)
       else if(cin_photo(iesp).ne.0.)then
          ire=ire+1
          name_reac(ire)='PHOTOLYSE DE L ESPECE '//TRIM(ADJUSTL(ADJUSTR(nambid)))
          cin_max_re(ire)=cin_photo(iesp)
       endif
       l_arrh(ire)=.false.
       nb_var_re(ire)=1
       name_var_re(ire,1)=name_esp(iesp)
       irkm_var_re(ire,1)=iesp
       coef_stochio(ire,1)=-1.
       expo_var(ire,1)=1
       nb_flim1(ire)=0
       nb_flim2(ire)=0
    endif
  enddo      
endif

!!!!!!!!!   autres reactions
do ire=nb_reac0+1,nb_reac
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,'(a)')nambid
  name_reac(ire)=TRIM(ADJUSTL(ADJUSTR(nambid)))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,cin_max_re(ire)
  cin_max_re(ire)=cin_max_re(ire)/86400.
! loi d arrhenius
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,l_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,ityp_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,teta_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,tempref_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,xeta_sigma_arrh(ire)
! variables reactives
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,nb_var_re(ire)
  do it=1,nb_var_re( ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    read(68,*)nambid, namelu
    name_var_re(ire,it)=TRIM(ADJUSTL(ADJUSTR(namelu)))
    l_var_sim=.false.
    do iv=1,nvar
       if(TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,it)))).eq.TRIM(ADJUSTL(ADJUSTR(name_esp(iv))))) then
              irkm_var_re(ire,it)=iv
              l_var_sim=.true.
        endif
    enddo
    if(.not.l_var_sim) then
!          si l_var_sim=.false.
           write(*,*)'ATTENTION'
           write(*,*)' la variable ',name_var_re(ire,it)
           write(*,*)' active dans la reaction numero ;',ire
           write(*,*)' N EXISTE PAS dans les especes du modele '
           stop
     endif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)nambid,coef_stochio(ire,it)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)nambid,expo_var(ire,it)
  enddo
! fonctions limitantes
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,nfunct_limit
  if(nfunct_limit==0) then
      nb_flim1(ire)=0
      nb_flim2(ire)=0
  else
      do iflim=1,nfunct_limit
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         read(68,*)nambid
         namvar_flim=TRIM(ADJUSTL(ADJUSTR(nambid)))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         read(68,*)nambid,ityp_flim
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         read(68,*)nambid,cte_flim
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         if(ityp_flim.eq.1) then
           nb_flim1(ire)=nb_flim1(ire)+1
           nfl1=nb_flim1(ire)
           cte_flim1(ire,nfl1)=cte_flim
           l_var_sim=.false.
           do iv=1,nvar
              if(namvar_flim.eq.name_esp(iv)) then
                  irkm_flim1(ire,nfl1)=iv
                  l_var_sim=.true.
              else if(namvar_flim.eq.'sal'.or.namvar_flim.eq.'salinite')then
                  irkm_flim1(ire,nfl1)=-1
                  l_var_sim=.true.
              else if(namvar_flim.eq.'MES')then
                  irkm_flim1(ire,nfl1)=-2
                  l_var_sim=.true.
              endif
           enddo
         else 
           nb_flim2(ire)=nb_flim2(ire)+1
           nfl2=nb_flim2(ire)
           cte_flim2(ire,nfl2)=cte_flim
           l_var_sim=.false.
           do iv=1,nvar
              if(namvar_flim.eq.name_esp(iv)) then
                  irkm_flim2(ire,nfl2)=iv
                  l_var_sim=.true.
              else if(namvar_flim.eq.'sal'.or.namvar_flim.eq.'salinite')then
                  irkm_flim2(ire,nfl2)=-1
                  l_var_sim=.true.
              else if(namvar_flim.eq.'MES')then
                  irkm_flim2(ire,nfl2)=-2
                  l_var_sim=.true.
              endif
            enddo
          endif
       enddo
       if(.not.l_var_sim) then
! l_var_sim=.false.
               write(*,*)'ATTENTION'
               write(*,*)' la variable limitante',namvar_flim
               write(*,*)' indiquee dans le fonction limitante'
               write(*,*)' numero ',iflim,' de la reaction numero ;',ire
               write(*,*)' N EXISTE PAS dans les variables du modele '
               stop
        endif
  endif
       
enddo

!!!!! pour MOCO : lecture des element pour l'echange cationique
!!!!!                                 pour l'initalisation des inconnues
!!!!!                             et  pour la complexation avec thiols particulaires 
ncat=0
!nthiolp=0
#ifdef key_moco

!  lecture des estimes initiaux
#ifdef MODTEST
   write(*,*)'lecture conta :   5 lignes estimes :' 
#endif
read(68,*)
read(68,*)
read(68,*)
read(68,*)
read(68,*)
read(68,*)nambid,ninc
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
allocate(xinit(ninc))
do i=1,ninc
   read(68,*)nambid,xinit(i)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
enddo   
      
!   lecture du cation competiteur et des constantes d'equilibre
!   d'echange cationique et de complexation 
!  meme si on n'en tient pas compte, on le lit pour avoir un seul fichier
if(l_competcat)then
    write(*,*)'competition avec cations pris en compte'
else
    write(*,*)'pas de competition avec cations'
endif
if(l_echgcat)then
    ncat=1
    write(*,*)'echange cationique pris en compte'
else
    write(*,*)'pas d echange cationique'
endif
allocate(idcharc(nsitmoco_max,nphasp))
allocate(xequcs(nsitmoco_max,nphasp))
idcharc(:,:)=0
xequcs(:,:)=0.
if(l_competcat .or. l_echgcat)then
#ifdef MODTEST
   write(*,*)'lecture conta :   4 lignes cation :' 
#endif
  read(68,*)
  read(68,*)
  read(68,*)
  read(68,*)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,nom_cat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,icharcat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,xequcat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,xequmet
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,cec
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,nambid
  name_sub_echcompcat=TRIM(ADJUSTL(ADJUSTR(nambid)))
  if(l_echgcat)then
    name_esp(iesp_echgcat)=  &
   'echg cation '//TRIM(ADJUSTL(ADJUSTR(nom_cat)))//'_sur_'//TRIM(ADJUSTL(ADJUSTR(nambid)))
    finit(iesp_echgcat)=0.
  endif
  do js=1,nphasp
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)
     do  isit=1,nsit(js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
        read(68,*)nambid,idcharc(isit,js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
        read(68,*)nambid,xequcs(isit,js)
     enddo      
  enddo      
endif
!
!   lecture des thiols particulaires et des constantes correspondantes
!   pour complexation du mercure par exemple
!if(l_thiolpart)then
!  write(*,*)'complexation avec des sites thiols particulaires'
!  nthiolp=2
!  read(68,*)
!  read(68,*)
!  read(68,*)
!  read(68,*)
! ! nom de la phase associe aux sites thiols
!  read(68,*)nambid,nambid
!  name_sub_thiol=TRIM(ADJUSTL(ADJUSTR(nambid)))
!  name_sub_esp(iesp_thiol_mono)=name_sub_thiol
!  name_esp(iesp_thiol_mono)=  &
!   'thiol_mono'//'_sur_'//TRIM(ADJUSTL(ADJUSTR(nambid)))
!  name_esp(iesp_thiol_bi)=  &
!   'thiol_bi'//'_sur_'//TRIM(ADJUSTL(ADJUSTR(nambid)))
!  name_sub_esp(iesp_thiol_bi)=name_sub_thiol
! ! nombre de sites totaux en thiols particulaires (mol/g)
!  read(68,*)nambid,cthiolpart
! ! conversion en nmole/g
!  cthiolpart=cthiolpart*1.d+09
! ! constante de complexation Kah pour fonction thiol particulaire
!  read(68,*)nambid,xx,xkathiolp
!  ixx=nint(xx)
!  if(ixx==10)xkathiolp=10**xkathiolp
!  write(*,*)'Cte equilibre reaction Thiol particulaire =',xkathiolp
! ! constante de complexation pour site thiol -Hg monodentate
!  read(68,*)nambid,xx,xequRSHg
!  ixx=nint(xx)
!  if(ixx==10)xequRSHg=10**xequRSHg
!  write(*,*)'Cte complexation  Thiol  -Hg monodentate =',xequRSHg
! ! constante de complexation pour site thiol -Hg bidentate
!  read(68,*)nambid,xx,xequR2SHg
!  ixx=nint(xx)
!  if(ixx==10)xequR2SHg=10**xequR2SHg
!  write(*,*)'Cte complexation  Thiol  -Hg bidentate =',xequR2SHg
!else
!    write(*,*)'pas de complexation avec des sites thiols particulaires'
!endif
!!
! verification de la charge du metal
 if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cd' .or.  &
    TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cadmium')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Cd a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Co' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cobalt')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Co a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cs' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cesium')then
     if(icharlib.ne.1)then
       icharlib=1
       write(*,*)'ATTENTION : la charge de l"ion Cs a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Hg' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Mercure')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Hg a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Pb' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Plomb')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Pb a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Ag' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Argent')then
     if(icharlib.ne.1)then
       icharlib=1
       write(*,*)'ATTENTION : la charge de l"ion Ag a t modifie'
     endif
 endif
#endif      
#ifdef MODTEST
   write(*,*)'FIN lecture conta '
#endif
  END SUBROUTINE lect_1conta

!****************************************************************************
                SUBROUTINE lect_contavar
!&E---------------------------------------------------------------------
!            Lecture des parametres a faire varier
!                  pour l_mode1c=.false. (plusieurs contaminants)
!&E---------------------------------------------------------------------
   !! * arguments 

   !! * Local declarations
 integer                          :: iesp,iupart_esp,ilig,i,ixnl,icin,nb_reac_var
 integer                          :: inl,iupartnl,ici,il,iespl,ire,nb_reac_plus,ii
 integer                          :: nb_reac0,it,iv,nfunct_limit,ityp_flim,ine
 integer                          :: nfl1,nfl2,ireh,ireb,irep,iflim,ip
 integer                          :: ical,ip1,ip2,ip3,ip4,ip5,ip6,ip7,nn,isit
 integer                          :: ips1,nfois1,ips2,nfois2,ips3,nfois3,ips4
#ifdef key_moco
 integer                          :: ips5,ips6,ips7,nfois4,nfois01,nfois02,nfois03
 integer,dimension(4)             :: nk
#endif
 integer                          :: ipc1,nfoisc0,nfoisc1,ipc2,ipe1,nfoisn1,nfoisn0,ipe2,ninc
 integer                          :: ir1,nfoisr0,nfoisr1,ir2,nfoisr2,ir3,nfoisr3,ir4
 integer                          :: nfoisr4,ir5,ncalcul_part,iespmoc,ixx,js
 integer                          :: npar_conta,nscalculmax,nparcal_avt,nparcal_aprs
 integer                          :: pos1,pos2,pos3,pos4,pos5,pos6,pos7,pos8
 integer,dimension(:),allocatable :: nscalcul,nscalre,nscalcin,in_reac_var
 real(kind=rlg)                   :: cte_flim,fmin0,fpas0,fmin1,fpas1,fmin2,fpas2
 real(kind=rlg)                   :: pmin,pas,xx
 character(len=lchain)            :: namelu,unite_xequ
 character(len=lchain)            :: namvar_flim,name_esp_assoc
 character(len=1)                 :: unitc
 logical                          :: l_var_sim,l_valdiscret,l_cinreac1
 character(len=lchain)            :: name_bibli
 character(len=1)                 :: z_nbesp
 character(len=2)                 :: z_nbesp2
 REAL(KIND=rlg),dimension(:,:),allocatable     :: parapartsens,paracontasens,paraespnesens
 REAL(KIND=rlg),dimension(:,:),allocatable     :: paraciresens
 REAL(KIND=rlg),dimension(:,:,:),allocatable   :: paracinsens,paraespcisens
 REAL(KIND=rlg),dimension(:,:,:,:),allocatable   :: paradomnlsens
#ifdef key_moco
 integer,dimension(:),allocatable           ::nscalmoco1
 integer,dimension(:,:),allocatable         ::nscalmoco2
 REAL(KIND=rlg),dimension(:,:),allocatable     :: ssp_sens
 REAL(KIND=rlg),dimension(:,:,:),allocatable   :: xequa1_sens,xequa2_sens,xequms_sens
 REAL(KIND=rlg),dimension(:,:,:),allocatable   :: sitac_sens
#endif
 character(len=3)                 :: modeln,typvarsens

!****************************************************************************
 write(*,*)'vous lisez les caracteristiques de la gamme de contaminant'
 write(*,*)'dans le fichier : ',TRIM(ADJUSTL(ADJUSTR(name_fileconta)))
 open(68,file='donconta/'//TRIM(ADJUSTL(ADJUSTR(name_fileconta))))
 read(68,*)
 read(68,*)
! les especes dissoutes comprennent ici les especes dissoutes liees
!   des ligands (ou substrats) organiques et inorganiques
!   (SANS COMPTER L'ESPECE LIBRE pour organique ou l ION LIBRE pour les metaux)
! il y a les especes dissoutes en equilibre (partage avec MOCO ou partage global)
! et les especes dissoutes qui ne subissent pas de partage
 read(68,*)nambid,nesp_diss_ne
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_diss_eq
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_part_eq
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_part_ci
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,nesp_part_ne
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 read(68,*)nambid,l_dom_nl
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif

read(68,*)
read(68,*)
read(68,*)nambid,unite_conta
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'l unite de masse des contaminants est :',   &
                 TRIM(ADJUSTL(ADJUSTR(unite_conta)))
                 
!  determination du facteur de conversion
!   besoin si on utilise MOCO seulement
!    car les calculs se font en nmole/L (mole/m3)
! ========================================
 conversunit=1.d00
#ifdef key_moco
 pos1=index(unite_conta,'mole')
 pos2=index(unite_conta,'g')
 if(pos1/=0)then
    conversunit=1.d+00
 else if(pos2/=0)then
    conversunit=1.d+00/pdmolec
    pos1=pos2
 else
     write(*,*)'ATTENTION'
     write(*,*)'l unite indiquee pour le contaminant'
     write(*,*)'n est exprime ni en gramme, ni en mole'
     write(*,*)'bien note "g" ou "mole" ou "nmole" ou "kg" ..'
     stop
 endif
 if(pos1>1)then
   unitc=unite_conta(pos1-1:pos1-1)
   pos2=index(unite_conta,'micro')
   if(unitc=='n')then
      conversunit=conversunit*1.d-03
   else if (unitc==''.or.pos2/=0)then
      conversunit=conversunit*1.d+00
   else if (unitc=='m')then
      conversunit=conversunit*1.d+03
   else if (unitc=='k')then
      conversunit=conversunit*1.d+09
   endif
 endif
 write(*,*)'l unite de masse de ce contaminant etant :',   &
                 TRIM(ADJUSTL(ADJUSTR(unite_conta)))
 write(*,*)'le facteur de conversion pour les calculs en nmole/L =',conversunit   

 read(68,*)nambid,l_group_espdmoc
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
 nesp_diss_moco=nesp_diss_eq
 if(l_group_espdmoc)then
     nesp_diss=nesp_diss_ne+1
 else
     nesp_diss=nesp_diss_ne+nesp_diss_eq
 endif
#else
 read(68,*)
 nesp_diss=nesp_diss_ne+nesp_diss_eq
#endif
read(68,*)
read(68,*)
read(68,*)nambid,l_valdiscret
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'vous avez choisi de specifier les parametres :'
if(l_valdiscret)then
  write(*,*)'de faon discrete '
  write(*,*)'le nombre de valeurs donnees est variable selon les parametres'
else
  write(*,*)'par une valeur min et un pas '
  write(*,*)'pour calcul en progression lineaire ou arithmetique  '
endif
! nombre max de valeur differente  par parametre
read(68,*)nambid,nscalculmax
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(68,*)
read(68,*)
read(68,*)
read(68,*)

nespt=nesp_diss+nesp_part_eq+nesp_part_ci+nesp_part_ne
! si echange cationique : 1 variable en plus du metal sur une phase echangeur
#ifdef key_moco
if(l_echgcat)then
  iesp_echgcat=nespt+1
  nespt=nespt+1
endif
! if(l_thiolpart)then
!  iesp_thiol_mono=nespt+1
!  iesp_thiol_bi=nespt+2
!  nespt=nespt+2
! endif
#endif
!   nombre de variables totales (dissoute libre + especes)
nvar=nespt+1


! 7 parametres caracteristiques physicochimiques du contaminant actuellement*
! pourrait changer
npar_conta=7
allocate(paracontasens(npar_conta,nscalculmax))
#ifdef key_moco
allocate(nscalcul(npar_conta+3*nesp_part_ci+nesp_part_ne))
#else
allocate(nscalcul(npar_conta+nesp_diss+nesp_part_eq+3*nesp_part_ci+nesp_part_ne))
#endif
if(l_valdiscret)then
  do iv=1,npar_conta
    read(68,*)nambid,nscalcul(iv),(paracontasens(iv,i),i=1,nscalcul(iv))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  enddo
          
else 
! typvarsens='LIN' pour progresion lineaire
  do iv=1,npar_conta
    read(68,*)nambid,nscalcul(iv),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    if(typvarsens=='LIN')then
!        progression lineaire c(i)=c(1)+n*pas
      do i=1,nscalcul(iv)
            paracontasens(iv,i)=pmin+(i-1)*pas
      enddo
    else
!         progression arithmetique c(i)=c(1)*pas^n'
      do i=1,nscalcul(iv)
            paracontasens(iv,i)=pmin*pas**(i-1)
      enddo
    endif
  enddo
endif
read(68,*)
read(68,*)
read(68,*)

 allocate(name_esp(nvar))
 allocate(isub_esp(nespt))
 allocate(name_sub_esp(nespt))
 allocate(parapartsens(nesp_part_eq+nesp_diss,nscalculmax))
 allocate(paracinsens(3,nvar,nscalculmax))
 allocate(nscalcin(3*nvar))
         
!!!!!!!!!!!!!!! especes dissoutes autres que libre
!!!!!!!!! ET NON LIEES A UN SUBSTRAT ET NON EN EQUILIBRE
!=================================================================
 do iesp=1,nesp_diss_ne
    read(68,*)namelu,nambid
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(nambid)))
    name_sub_esp(iesp)=''
    write(*,*)'nom de l espece dissoute sans partage numero :',iesp,' = ', &
                             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))) 
                     
#if ! defined key_moco
    xpart_esp(iesp)=0.
    nscalcul(npar_conta+iesp)=1
    if(l_valdiscret)then
!      cinetiques (hydrolyse, photolyse, biodegradation du premier ordre)
       do icin=1,3
         read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),    &
               (paracinsens(icin,iesp,i),i=1,nscalcin((icin-1)*nvar+iesp))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       enddo
    else 
       do icin=1,3
         read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         if(typvarsens=='LIN')then
           do i=1,nscalcin((icin-1)*nvar+iesp)
             paracinsens(icin,iesp,i)=pmin+(i-1)*pas
           enddo
         else 
           do i=1,nscalcin((icin-1)*nvar+iesp)
             paracinsens(icin,iesp,i)=pmin*pas**(i-1)
           enddo
         endif
       enddo
    endif
#endif
 enddo
 read(68,*)nambid
 read(68,*)nambid
 read(68,*)nambid
 read(68,*)nambid
!!!!!!!!!!!!!!! especes dissoutes complexes et en partage a l equilibre
!=================================================================
#ifdef key_moco
! partage calcule par resolution des equations en equilibre thermodynamique (MOCO)
!  pas  d etude de sensibilite sur ces parametres
!::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!  lecture de toutes les especes dissoutes liees aux ligands mineraux et organiques
!  regroupement ou pas dans une seule variable
allocate(nom_espdmoco(nesp_diss_moco))
allocate(iespd_moco(nesp_diss_moco))
allocate(xequ(nesp_diss_moco))
allocate(nom_lig_esp(nesp_diss_moco))
allocate(ichare(nesp_diss_moco))
allocate(xfactl(nesp_diss_moco))
allocate(xfacth_esp(nesp_diss_moco))
allocate(ilig_esp(nesp_diss_moco))
do iesp=1,nesp_diss_moco
   read(68,*)nambid,nom_espdmoco(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,nom_lig_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,unite_xequ,xx,xequ(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  ixx=nint(xx)
   if(ixx==10)then
          xequ(iesp)=10**xequ(iesp)
   endif
   read(68,*)nambid,ichare(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,xfactl(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,xfacth_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   if(iesp==1)then
      nlig=1
   else if(nom_lig_esp(iesp) .ne. nom_lig_esp(iesp-1))then
     nlig=nlig+1     
   endif 
   ilig_esp(iesp)=nlig
enddo
if(l_group_espdmoc.and.nesp_diss_moco.ne.0)then
  iesp=nesp_diss_ne+1
  iespd_moco(1)=iesp
  name_esp(iesp)=TRIM(ADJUSTL(ADJUSTR(name_conta)))//'_lig_moco'
  name_sub_esp(iesp)='ligand_moco'
  write(*,*)'nom de l espece dissoute numero :',iesp,' = ', &
                             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
  write(*,*)'nom du "substrat" de l espece diss numero :',iesp, &
                      ' = ',TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
                      
else
  do iesp=nesp_diss_ne+1,nesp_diss
    name_esp(iesp)=nom_espdmoco(iesp-nesp_diss_ne)
    name_sub_esp(iesp)=nom_lig_esp(iesp-nesp_diss_ne)
    write(*,*)'nom de l espece dissoute numero :',iesp,' = ', &
                             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
    write(*,*)'nom du "substrat" de l espece diss numero :',iesp, &
                      ' = ',TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
                      
    iespd_moco(iesp-nesp_diss_ne)=iesp                    
  enddo           
endif
#else
 do iesp=nesp_diss_ne+1,nesp_diss
   read(68,*)nambid,name_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(68,*)nambid,name_sub_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   write(*,*)'nom de l espece dissoute numero',iesp,' = ',   &
        TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
   write(*,*)'nom du "substrat" de l espece diss numero',iesp,' = ',   &
         TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
   read(68,*)nambid,unite_xequ,xx
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   ixx=nint(xx)
   if(l_valdiscret)then
     read(68,*)nambid,nscalcul(npar_conta+iesp),(parapartsens(iesp,i),  &
               i=1,nscalcul(npar_conta+iesp))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
!   cinetiques (hydrolyse, photolyse, biodegradation du premier ordre)
     do icin=1,3
       read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),    &
               (paracinsens(icin,iesp,i),i=1,nscalcin((icin-1)*nvar+iesp))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     enddo
   else 
     read(68,*)nambid,nscalcul(npar_conta+iesp),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     if(typvarsens=='LIN')then
       do i=1,nscalcul(npar_conta+iesp)
         parapartsens(iesp,i)=pmin+(i-1)*pas
       enddo
     else 
       do i=1,nscalcul(npar_conta+iesp)
         parapartsens(iesp,i)=pmin*pas**(i-1)
       enddo
     endif
     do icin=1,3
       read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(typvarsens=='LIN')then
         do i=1,nscalcin((icin-1)*nvar+iesp)
           paracinsens(icin,iesp,i)=pmin+(i-1)*pas
         enddo
       else 
         do i=1,nscalcin((icin-1)*nvar+iesp)
           paracinsens(icin,iesp,i)=pmin*pas**(i-1)
         enddo
       endif
     enddo
   endif
   nn=nscalcul(npar_conta+iesp)
   pos1=index(unite_xequ,'mL/g')
   pos2=index(unite_xequ,'ml/g')
   pos3=index(unite_xequ,'L/kg')
   pos4=index(unite_xequ,'l/kg')
   if(pos1/=0. .or. pos2/=0. .or. pos3/=0. .or. pos4/=0.)then
      if(ixx==10)then
         write(*,*)'coefs de partage donne en log10(mL/g)'
         parapartsens(iesp,1:nn)= 10**(parapartsens(iesp,1:nn))/1000
      else
         write(*,*)'coefs de partage donne en mL/g'
         parapartsens(iesp,1:nn)= parapartsens(iesp,1:nn)/1000 
      endif
  else
      pos5=index(unite_xequ,'L/g')
      pos6=index(unite_xequ,'l/g')
      pos7=index(unite_xequ,'m3/kg')
      pos8=index(unite_xequ,'m3/Kg')
      if(pos5/=0. .or. pos6/=0. .or. pos7/=0. .or. pos8/=0.)then
         if(ixx==10)then
           write(*,*)'coefs de partage donne en log10(L/g)'
           parapartsens(iesp,1:nn)= 10**(parapartsens(iesp,1:nn))
         else
           write(*,*)'coefs de partage donne en L/g'
           parapartsens(iesp,1:nn)= parapartsens(iesp,1:nn)
         endif
      else
         write(*,*)'ATTENTION A L UNITE du coefs de partage ',xpart_esp(iesp)
         write(*,*)'il est utilise tel quel '
      endif
  endif
enddo 
#endif       
read(68,*)
read(68,*)
read(68,*)
read(68,*)
read(68,*)
read(68,*)
read(68,*)
         
!!!!!!!!!!! variables particulaires partage  l'EQUILIBRE
!!! ATTENTION PAS PLUS DE 4 avec les dissoutes POUR FAIRE ANALYSE DE SENSIBILITE
!=================================================================
#ifdef key_moco
!   substrat particulaire ou phase :   surface specifique ssp (m2/g)
!      cte intrinseque xequa1 et 2 ;
!      nombre de sites de surface pour chaque substrat ou phase  : nsit
!      par site  : nombre de sites actifs sitac (moles/g)
nphasp=nesp_part_eq
if(nphasp>0)then
  allocate(nom_phase(nphasp))
  allocate(iespp_moco(nphasp))
  allocate(xequa1(nsitmoco_max,nphasp))
  allocate(xequa2(nsitmoco_max,nphasp))
  allocate(xequms(nsitmoco_max,nphasp))
  allocate(ssp(nphasp))
  allocate(sitac(nsitmoco_max,nphasp))
  allocate(ityp_sit(nsitmoco_max,nphasp))
  allocate(nsit(nphasp))
  allocate(idchars(nsitmoco_max,nphasp,2))
  allocate(idcharm(nsitmoco_max,nphasp))
  allocate(idchar2m(nphasp))
  allocate(ika1(nsitmoco_max,nphasp))
  
  allocate(ssp_sens(nphasp,nscalculmax))
  allocate(sitac_sens(nsitmoco_max,nphasp,nscalculmax))
  allocate(xequa1_sens(nsitmoco_max,nphasp,nscalculmax))
  allocate(xequa2_sens(nsitmoco_max,nphasp,nscalculmax))
  allocate(xequms_sens(nsitmoco_max,nphasp,nscalculmax))
  allocate(nscalmoco1(nphasp))
  allocate(nscalmoco2(nphasp,nsitmoco_max))
endif
l_dom_nl=.false.
js=0
nparcal_aprs= npar_conta
#else
if(l_dom_nl)THEN
   ALLOCATE(n_dom_nl(nespt))
   allocate(f_dom_nl(nespt,2))
   allocate(xpartnl(nespt,2))
   allocate(xsorptnl(nespt,2))
endif
nparcal_aprs= npar_conta+nesp_diss+nesp_part_eq
#endif

do iesp=nesp_diss+1,nesp_diss+nesp_part_eq
  read(68,*)nambid,name_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,name_sub_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  write(*,*)'nom de l espece particulaire LIN numero',iesp,' = ',name_esp(iesp)
  write(*,*)'nom du "substrat" de l espece part numero',iesp,' = ',name_sub_esp(iesp)

#ifdef key_moco
!  parametres qui seraient  faire varier : ssp,sitac,xequms de isit=1
  if(l_moco_op)then
     js=1
     nom_phase(js)='MESt'
     read(68,*)nambid
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     if(l_valdiscret)then
       read(68,*)nambid,nscalmoco1(1),(ssp_sens(js,i),i=1,nscalmoco1(1))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     else
       read(68,*)nambid,nscalmoco1(1),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(typvarsens=='LIN')then
         do i=1,nscalmoco1(1)
           ssp_sens(js,i)=pmin+(i-1)*pas
         enddo
       else 
         do i=1,nscalmoco1(1)
           ssp_sens(js,i)=pmin*pas**(i-1)
         enddo
       endif
     endif      
     nsit(js)=1
  else
    js=js+1
    nom_phase(js)=name_sub_esp(iesp)
     read(68,*)nambid,nsit(js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    if(l_valdiscret)then
       read(68,*)nambid,nscalmoco1(js),(ssp_sens(js,i),i=1,nscalmoco1(js))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    else
       read(68,*)nambid,nscalmoco1(js),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(typvarsens=='LIN')then
         do i=1,nscalmoco1(js)
           ssp_sens(js,i)=pmin+(i-1)*pas
         enddo
       else 
         do i=1,nscalmoco1(js)
           ssp_sens(js,i)=pmin*pas**(i-1)
         enddo
       endif
    endif      
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    write(*,*)
    write(*,*)'PHASE :',nom_phase(js)       
    write(*,*)'nombre de site sur cette phase :',nsit(js) 
  endif
  read(68,*)
  do isit=1,nsit(js)
     read(68,*)nambid,ityp_sit(isit,js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     if(l_valdiscret)then
        read(68,*)nambid,nk(1),(sitac_sens(isit,js,i),i=1,nk(1))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
        sitac_sens(isit,js,:)=sitac_sens(isit,js,:)*1.d-6
       if(ityp_sit(isit,js)==1)then
         ! meme nombre de valeurs pour chaque constante 
          read(68,*)nambid,idchars(isit,js,1),nk(2),(xequa1_sens(isit,js,i),i=1,nk(2))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,idchars(isit,js,2),nk(3),(xequa2_sens(isit,js,i),i=1,nk(3))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,idcharm(isit,js),nk(4),(xequms_sens(isit,js,i),i=1,nk(4))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          nscalmoco2(js,isit)=max(nk(1),nk(2),nk(3),nk(4))
          sitac_sens(isit,js,nk(1)+1:nscalmoco2(js,isit))=sitac_sens(isit,js,nk(1))
          xequa1_sens(isit,js,nk(2)+1:nscalmoco2(js,isit))=xequa1_sens(isit,js,nk(2))
          xequa2_sens(isit,js,nk(3)+1:nscalmoco2(js,isit))=xequa2_sens(isit,js,nk(3))
          xequms_sens(isit,js,nk(4)+1:nscalmoco2(js,isit))=xequms_sens(isit,js,nk(4))
          ika1(isit,js)=1
       else if(ityp_sit(isit,js)==2)then
          ika1(isit,js)=0
          xequa1_sens(isit,js,:)=0.
          read(68,*)nambid,idchars(isit,js,2),nk(2),(xequa2_sens(isit,js,i),i=1,nk(2))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          read(68,*)nambid,idcharm(isit,js),nk(3),(xequms_sens(isit,js,i),i=1,nk(3))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          nscalmoco2(js,isit)=max(nk(1),nk(2),nk(3))
          sitac_sens(isit,js,nk(1)+1:nscalmoco2(js,isit))=sitac_sens(isit,js,nk(1))
          xequa2_sens(isit,js,nk(2)+1:nscalmoco2(js,isit))=xequa2_sens(isit,js,nk(2))
          xequms_sens(isit,js,nk(3)+1:nscalmoco2(js,isit))=xequms_sens(isit,js,nk(3))
       endif
     else
       read(68,*)nambid,nk(4),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(typvarsens=='LIN')then
         do i=1,nk(4)
           sitac_sens(isit,js,i)=pmin+(i-1)*pas
         enddo
       else 
         do i=1,nk(4)
           sitac_sens(isit,js,i)=pmin*pas**(i-1)
         enddo
       endif
       sitac_sens(isit,js,:)=sitac_sens(isit,js,:)*1.d-6
       if(ityp_sit(isit,js)==1)then
          read(68,*)nambid,idchars(isit,js,1),nk(1),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          if(typvarsens=='LIN')then
            do i=1,nk(1)
              xequa1_sens(isit,js,i)=pmin+(i-1)*pas
            enddo
          else 
            do i=1,nk(1)
              xequa1_sens(isit,js,i)=pmin*pas**(i-1)
            enddo
          endif
          read(68,*)nambid,idchars(isit,js,2),nk(2),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          if(typvarsens=='LIN')then
            do i=1,nk(2)
              xequa2_sens(isit,js,i)=pmin+(i-1)*pas
            enddo
          else 
            do i=1,nk(2)
              xequa2_sens(isit,js,i)=pmin*pas**(i-1)
            enddo
          endif
          read(68,*)nambid,idcharm(isit,js),nk(3),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          if(typvarsens=='LIN')then
            do i=1,nk(3)
              xequms_sens(isit,js,i)=pmin+(i-1)*pas
            enddo
          else 
            do i=1,nk(3)
              xequms_sens(isit,js,i)=pmin*pas**(i-1)
            enddo
          endif
          ika1(isit,js)=1
          nscalmoco2(js,isit)=max(nk(1),nk(2),nk(3),nk(4))
          xequa1_sens(isit,js,nk(1)+1:nscalmoco2(js,isit))=xequa1_sens(isit,js,nk(1))
          xequa2_sens(isit,js,nk(2)+1:nscalmoco2(js,isit))=xequa2_sens(isit,js,nk(2))
          xequms_sens(isit,js,nk(3)+1:nscalmoco2(js,isit))=xequms_sens(isit,js,nk(3))
          sitac_sens(isit,js,nk(4)+1:nscalmoco2(js,isit))=sitac_sens(isit,js,nk(4))
       else if(ityp_sit(isit,js)==2)then
          ika1(isit,js)=0
          read(68,*)nambid,idchars(isit,js,2),nk(2),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          if(typvarsens=='LIN')then
            do i=1,nk(2)
              xequa2_sens(isit,js,i)=pmin+(i-1)*pas
            enddo
          else 
            do i=1,nk(2)
              xequa2_sens(isit,js,i)=pmin*pas**(i-1)
            enddo
          endif
          read(68,*)nambid,idcharm(isit,js),nk(3),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          if(typvarsens=='LIN')then
            do i=1,nk(3)
              xequms_sens(isit,js,i)=pmin+(i-1)*pas
            enddo
          else 
            do i=1,nk(3)
              xequms_sens(isit,js,i)=pmin*pas**(i-1)
            enddo
          endif
          nscalmoco2(js,isit)=max(nk(2),nk(3),nk(4))
          xequa2_sens(isit,js,nk(2)+1:nscalmoco2(js,isit))=xequa2_sens(isit,js,nk(2))
          xequms_sens(isit,js,nk(3)+1:nscalmoco2(js,isit))=xequms_sens(isit,js,nk(3))
          sitac_sens(isit,js,nk(4)+1:nscalmoco2(js,isit))=sitac_sens(isit,js,nk(4))
       endif
     endif
  enddo
  iespp_moco(js)=iesp  
#else
  read(68,*)nambid,unite_xequ,xx
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  ixx=int(xx)
  if(l_valdiscret)then
     read(68,*)nambid,nscalcul(npar_conta+iesp),(parapartsens(iesp,i),i=1,nscalcul(npar_conta+iesp))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)
! pas de sensibilite pour domaine non lineaire
     if(l_dom_nl)then
       read(68,*)nambid,n_dom_nl(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(n_dom_nl(iesp).ne.0)then
          read(68,*)nambid,l_langmuir
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          if((l_langmuir).and.(n_dom_nl(iesp).gt.1.or.nesp_part_eq.gt.1))then
             write(*,*)'ATTENTION ::  si on choisit le modele DMM '
             write(*,*)'il ne peut y avoir qu UNE SEULE espece '
             write(*,*)'particulaire a l equilibre '
             write(*,*)' avec UN SEUL domaine non lineaire'
             stop
          endif
         do inl=1,n_dom_nl(iesp)
            read(68,*)nambid,f_dom_nl(iesp,inl)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
            read(68,*)nambid,iupartnl,xpartnl(iesp,inl)         
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
            read(68,*)nambid,xsorptnl(iesp,inl)         
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
            if(iupartnl.eq.10)then
               xpartnl(iesp,inl)=10**xpartnl(iesp,inl)
            endif
         enddo
       endif
     endif
   else 
     read(68,*)nambid,nscalcul(npar_conta+iesp),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)
     if(typvarsens=='LIN')then
       do i=1,nscalcul(npar_conta+iesp)
         parapartsens(iesp,i)=pmin+(i-1)*pas
       enddo
     else 
       do i=1,nscalcul(npar_conta+iesp)
         parapartsens(iesp,i)=pmin*pas**(i-1)
       enddo
     endif
! pas de sensibilite pour domaine non lineaire
!domaine non lineaire
     if(l_dom_nl)then
       read(68,*)nambid,n_dom_nl(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(n_dom_nl(iesp).ne.0)then
          read(68,*)nambid,l_langmuir
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
          if((l_langmuir).and.(n_dom_nl(iesp).gt.1.or.nesp_part_eq.gt.1))then
             write(*,*)'ATTENTION ::  si on choisit le modele DMM '
             write(*,*)'il ne peut y avoir qu UNE SEULE espece '
             write(*,*)'particulaire a l equilibre '
             write(*,*)' avec UN SEUL domaine non lineaire'
             stop
          endif
          do inl=1,n_dom_nl(iesp)
            read(68,*)nambid,f_dom_nl(iesp,inl)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
            read(68,*)nambid,iupartnl,xpartnl(iesp,inl)         
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
            read(68,*)nambid,xsorptnl(iesp,inl)         
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
            if(iupartnl.eq.10)then
               xpartnl(iesp,inl)=10**xpartnl(iesp,inl)
            endif
          enddo
       endif
     endif
   endif
   nn=nscalcul(npar_conta+iesp)
   pos1=index(unite_xequ,'mL/g')
   pos2=index(unite_xequ,'ml/g')
   pos3=index(unite_xequ,'L/kg')
   pos4=index(unite_xequ,'l/kg')
   if(pos1/=0. .or. pos2/=0. .or. pos3/=0. .or. pos4/=0.)then
      if(ixx==10)then
         write(*,*)'coefs de partage donne en log10(mL/g)'
         parapartsens(iesp,1:nn)= 10**(parapartsens(iesp,1:nn))/1000
      else
         write(*,*)'coefs de partage donne en mL/g'
         parapartsens(iesp,1:nn)= parapartsens(iesp,1:nn)/1000 
      endif
  else
      pos5=index(unite_xequ,'L/g')
      pos6=index(unite_xequ,'l/g')
      pos7=index(unite_xequ,'m3/kg')
      pos8=index(unite_xequ,'m3/Kg')
      if(pos5/=0. .or. pos6/=0. .or. pos7/=0. .or. pos8/=0.)then
         if(ixx==10)then
           write(*,*)'coefs de partage donne en log10(L/g)'
           parapartsens(iesp,1:nn)= 10**(parapartsens(iesp,1:nn))
         else
           write(*,*)'coefs de partage donne en L/g'
           parapartsens(iesp,1:nn)= parapartsens(iesp,1:nn)
         endif
      else
         write(*,*)'ATTENTION A L UNITE du coefs de partage ',xpart_esp(iesp)
         write(*,*)'il est utilise tel quel '
      endif
  endif
  if(l_valdiscret)then
!   cinetiques (hydrolyse, photolyse, biodegradation du premier ordre)
     do icin=1,3
       read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),    &
               (paracinsens(icin,iesp,i),i=1,nscalcin((icin-1)*nvar+iesp))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     enddo
   else 
     do icin=1,3
       read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(typvarsens=='LIN')then
         do i=1,nscalcin((icin-1)*nvar+iesp)
           paracinsens(icin,iesp,i)=pmin+(i-1)*pas
         enddo
       else 
         do i=1,nscalcin((icin-1)*nvar+iesp)
           paracinsens(icin,iesp,i)=pmin*pas**(i-1)
         enddo
       endif
     enddo
   endif
#endif
enddo        
read(68,*)
read(68,*)
read(68,*)

!!!!!!!!!! variables particulaires avec sorption EN CINETIQUE
!!! 2 max pour etude de sensibilite
!=================================================================
allocate(iesp_assoc(nespt))
nparcal_avt=nparcal_aprs
if(nesp_part_ci>0)then
    allocate(paraespcisens(3,nesp_part_ci,nscalculmax))
    allocate(ichoix_ceqci(nesp_part_ci))
    nparcal_aprs=nparcal_avt+3*nesp_part_ci
else
    nparcal_aprs=nparcal_avt
endif
do inl=1,nesp_part_ci
   iesp=nesp_diss+nesp_part_eq+inl
   read(68,*)nambid,name_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   write(*,*)'nom de l espece particulaire Neq numero',iesp,' = ',   &
                     TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
   read(68,*)namelu,nambid
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   name_esp_assoc=TRIM(ADJUSTL(ADJUSTR(nambid)))
   write(*,*)'nom de l espece associe : ',   &
                       TRIM(ADJUSTL(ADJUSTR(name_esp_assoc)))
   do il=1,nesp_part_eq
      iespl=nesp_diss+il
      if(TRIM(ADJUSTL(ADJUSTR(name_esp(iespl)))).eq.TRIM(ADJUSTL(ADJUSTR(name_esp_assoc))))then
         iesp_assoc(iesp)=iespl
      endif
   enddo
!!!!   finit, cte_vit,ceq_ci (ceq_ci donne par kg de particules)
   read(68,*)nambid,choix_ceqci
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   if(choix_ceqci=='M/kg')then
      ichoix_ceqci(inl)=0
   else if(choix_ceqci=='f/C0')then
      ichoix_ceqci(inl)=1
   elseif(choix_ceqci=='Ceq2')then
      ichoix_ceqci(inl)=2
       ! dans ce cas, on divise par 2 la constante de partage de l'espece associee
       !  pour avoir une conc  l'quilibre /2 et il y aura un transfert progressif
       !  de l'une vers l'autre jusqu' atteindre la conc total= 2*conc equilibre 
      parapartsens(iesp_assoc(iesp),1:nn)= parapartsens(iesp_assoc(iesp),1:nn)*0.5
   endif
   if(l_valdiscret)then
     do ii=1,3
       read(68,*)nambid,nscalcul(nparcal_avt+(ii-1)*nesp_part_ci+inl),   &
                 (paraespcisens(ii,inl,i),i=1,nscalcul(nparcal_avt+(ii-1)*nesp_part_ci+inl))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     enddo       
   else 
     do ii=1,3
       read(68,*)nambid,nscalcul(nparcal_avt+(ii-1)*nesp_part_ci+inl),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(typvarsens=='LIN')then
         do i=1,nscalcul(nparcal_avt+(ii-1)*nesp_part_ci+inl)
           paraespcisens(ii,inl,i)=pmin+(i-1)*pas
         enddo
       else 
         do i=1,nscalcul(nparcal_avt+(ii-1)*nesp_part_ci+inl)
           paraespcisens(ii,inl,i)=pmin*pas**(i-1)
         enddo
       endif
     enddo
   endif
   paracinsens(:,iesp,:)=paracinsens(:,iesp_assoc(iesp),:)
enddo        
       
#ifdef key_moco
if(l_moco_op)then
    if(nesp_part_eq==0.and. .not.l_echgcat)then
      write(*,*)'ATTENTION : problme car si on a choisi d utiliser MOCO'
      write(*,*)'il faut qu il y ait au moins une espece particulaire'
      write(*,*)' en equilibre'
      stop
!    else if(nesp_part_eq==0.and. .not.l_thiolpart)then
!      write(*,*)'ATTENTION : problme car si on a choisi d utiliser MOCO'
!      write(*,*)'et sites thiols particulaires il faut qu il y ait au moins '
!      write(*,*)'une espece particulaire en equilibre'
!      stop
    else if(nesp_part_eq>1)then
      write(*,*)'ATTENTION : problme car si on a choisi d utiliser MOCO'
      write(*,*)'en mode operationnel, il ne faut pas qu il y ait plus'
      write(*,*)' d"une espece particulaire en equilibre'
    endif  
endif  
!  calcul du nombre indice pour chaque substrat en fonction du 
!                 nombre de substrat et du nombre de sites pas substrat 
!======================================================================
if(nphasp.ne.0)then
  allocate(nsubsi(nphasp))
  nsubsi(1)=0
  do js=2,nphasp
    nsubsi(js)=nsubsi(js-1)+nsit(js-1)
  enddo
  nsubsit=nsubsi(nphasp)+nsit(nphasp)
endif
#endif

read(68,*)
read(68,*)
read(68,*)
nespt_echeq= nesp_diss+nesp_part_eq       

!!!!!!!!!!!! variables particulaires SANS sorption / desorption (NON ECHANGeable)
!!             max 2 pour l etude de sensibilite
!=================================================================
allocate(ityp_part(nespt))
nparcal_avt=nparcal_aprs
if(nesp_part_ne>0)then
    allocate(paraespnesens(nesp_part_ne,nscalculmax))
    nparcal_aprs=nparcal_avt+nesp_part_ne
else
    nparcal_aprs=nparcal_avt
endif
do ine=1,nesp_part_ne
  iesp=nesp_diss+nesp_part_eq+nesp_part_ci+ine
  read(68,*)nambid,name_esp(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,ityp_part(iesp)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  write(*,*)'nom de l espece particulaire Neq numero',iesp,' = ',   &
               TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
  write(*,*)'numero du type de particule associe ',ityp_part(iesp)
  write(name_sub_esp(iesp),*)ityp_part(iesp)
  name_sub_esp(iesp)='NON ECHG SUR PART n'//TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp))))
  if(l_valdiscret)then
     read(68,*)nambid,nscalcul(nparcal_avt+ine),(paraespnesens(ine,i),i=1,nscalcul(nparcal_avt+ine))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
!   cinetiques (hydrolyse, photolyse, biodegradation du premier ordre)
#if ! defined key_moco
     do icin=1,3
       read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),    &
               (paracinsens(icin,iesp,i),i=1,nscalcin((icin-1)*nvar+iesp))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     enddo
#endif
  else 
     read(68,*)nambid,nscalcul(nparcal_avt+ine),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     if(typvarsens=='LIN')then
         do i=1,nscalcul(nparcal_avt+ine)
           paraespnesens(ine,i)=pmin+(i-1)*pas
         enddo
     else 
         do i=1,nscalcul(nparcal_avt+ine)
           paraespnesens(ine,i)=pmin*pas**(i-1)
         enddo
     endif
#if ! defined key_moco
!!! cinetiques
     do icin=1,3
       read(68,*)nambid,nscalcin((icin-1)*nvar+iesp),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
       if(typvarsens=='LIN')then
           do i=1,nscalcin((icin-1)*nvar+iesp)
             paracinsens(icin,iesp,i)=pmin+(i-1)*pas
           enddo
       else 
           do i=1,nscalcin((icin-1)*nvar+iesp)
             paracinsens(icin,iesp,i)=pmin*pas**(i-1)
           enddo
       endif
     enddo
#endif
   endif
enddo 
        
!!!!!!!!!!!!! variable dissoute libre
!=================================================================
read(68,*)
read(68,*)
read(68,*)
#ifdef key_moco
read(68,*)nambid,name_esp(nvar),icharlib
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
#else
read(68,*)nambid,name_esp(nvar)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(l_valdiscret)then
!   cinetiques (hydrolyse, photolyse, biodegradation du premier ordre)
   do icin=1,3
     read(68,*)nambid,nscalcin((icin-1)*nvar+nvar),    &
               (paracinsens(icin,nvar,i),i=1,nscalcin((icin-1)*nvar+nvar))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   enddo
else 
   do icin=1,3
      read(68,*)nambid,nscalcin((icin-1)*nvar+nvar),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
      if(typvarsens=='LIN')then
        do i=1,nscalcin((icin-1)*nvar+nvar)
             paracinsens(icin,nvar,i)=pmin+(i-1)*pas
        enddo
      else 
        do i=1,nscalcin((icin-1)*nvar+nvar)
             paracinsens(icin,nvar,i)=pmin*pas**(i-1)
        enddo
      endif
   enddo
endif
#endif
read(68,*)
read(68,*)
read(68,*)

!!!!!!!!!!!!!
!!!!!!!!!!!!!   parametres pour la volatilisation
!=================================================================
read(68,*)nambid,l_volat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(l_volat)then
  read(68,*)nambid,namelu
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  do iesp=1,nvar
    if(TRIM(ADJUSTL(ADJUSTR(namelu)))==TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))))then
      iesp_volat=iesp
      exit
    endif
  enddo
  write(*,*)
  write(*,*)'l espece qui se volatilise est l espece numero :',iesp_volat
  read(68,*)nambid,l_volkl_dif
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! l_volkl_dif : choix de la formule pour coef de transfert phase liquide
!              par diffusion turbulente 
!              true pour Churchill ou false pour O'Connor 
  read(68,*)nambid,l_volkl_sal
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! l_volkl_sal : choix de la prise en compte de l'effet de sel (true si oui)
!              par formule de Wen  pour coef de transfert phase liquide
  read(68,*)nambid,ich_volkl_wind
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! ich_volkl_wind : choix de la formule pour coef de transfert phase liquide
!              par turbulence engendree par le vent 
!              1 pour Schwartzenbach 
!              2 pour Wanninkhof 
!              3 pour Nightingale 
  read(68,*)nambid,l_volkl_cor
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! l_volkl_cor : choix de la proprit pour correction du coefficient  
!               de transfert phase liquide
!               par nombre de Schmidt (true) ou pas massse molaire (false) 
  read(68,*)nambid,cf_expvol_liq
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! cf_expvol_liq : exposant du rapport des proprits pour phase liquide 
  read(68,*)nambid,l_volkg_cor
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! l_volkg_cor : choix de la proprit pour correction du coefficient 
!               de transfert phase gazeuse
!               par diffusivite (true) ou pas massse molaire (false) 
  read(68,*)nambid,cf_expvol_gas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! cf_expvol_gas  : exposant du rapport des proprits pour phase gazeuse
       
else
!  pas de volatilisation ; on ne lit pas les paramtres
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
   read(68,*)
endif
massmol_h2o=18.d00
massmol_co2=44.d00
massmol_o2=32.d00
cf_difwat_co2=1.77d-9
cf_difwat_o2=2.3d-9
cf_difair_h2o=0.25d-4
cst_gas_univ=8.314d00  

               
!!!!!!!!! autres ractions non spcifiques et gnriques
!!!!!!!!!   de TRANSFERT D'UNE ESPECE  L'AUTRE 
!!!======================================================
ire=0
#if ! defined key_moco
 do iesp=1,nvar
  do icin=1,3
    do i=1,nscalcin((icin-1)*nvar+iesp)
       if(paracinsens(icin,iesp,i).ne.0.)ire=ire+1
    enddo      
  enddo      
 enddo
#endif      
nb_reac0=ire
read(68,*)
read(68,*)      
read(68,*)      
read(68,*)nambid,nb_reac_plus
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
nb_reac=ire+nb_reac_plus

allocate(name_reac(nb_reac))
allocate(l_arrh(nb_reac))
allocate(ityp_arrh(nb_reac))
allocate(teta_arrh(nb_reac))
allocate(tempref_arrh(nb_reac))
allocate(xeta_sigma_arrh(nb_reac))
allocate(nb_var_re(nb_reac))
allocate(name_var_re(nb_reac,2))
allocate(irkm_var_re(nb_reac,2))
allocate(coef_stochio(nb_reac,2))
allocate(expo_var(nb_reac,2))
allocate(nb_flim1(nb_reac))
allocate(nb_flim2(nb_reac))

allocate(paraciresens(nb_reac,nscalculmax))
allocate(nscalre(nb_reac))


!!!!!!!!!   introduction des reactions de photolyse, biodeg et hydrolyse 
!!!!!!!!!   du premier ordre  dans ce cadre
!! ======================================================================
#if ! defined key_moco
ire=0
do iesp=1,nvar
  do icin=1,3
    l_cinreac1=.false.
    do i=1,nscalcin((icin-1)*nvar+iesp)
        if(paracinsens(icin,iesp,i).ne.0.)l_cinreac1=.true.
    enddo
    if(l_cinreac1)then
        ire=ire+1
        write(nambid,"(i1)")iesp
        if(icin==1)then
           name_reac(ire)='HYDROLYSE DE L ESPECE '//nambid
        else if (icin==2)then
           name_reac(ire)='BIODEGRADATION DE L ESPECE '//nambid
        else
           name_reac(ire)='PHOTOLYSE DE L ESPECE '//nambid
        endif
        paraciresens(ire,:)=paracinsens(icin,iesp,:)
        nscalre(ire)=nscalcin((icin-1)*nvar+iesp)
        l_arrh(ire)=.false.
        nb_var_re(ire)=1
        name_var_re(ire,1)=name_esp(iesp)
        irkm_var_re(ire,1)=iesp
        coef_stochio(ire,1)=-1.
        expo_var(ire,1)=1
        nb_flim1(ire)=0
        nb_flim2(ire)=0
    endif
  enddo     
enddo     
#endif
!!!!!!!!!   autres reactions generiques
!!       5 reactions max dont la cintique varie
!!        pour l etude de sensibilite (y compris hydroyse, photolyse, biodeg)
!! ======================================================================
do ire=nb_reac0+1,nb_reac
  read(68,*)nambid
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  name_reac(ire)=TRIM(ADJUSTL(ADJUSTR(nambid)))
  if(l_valdiscret)then
     read(68,*)nambid,nscalre(ire),(paraciresens(ire,i),i=1,nscalre(ire))
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  else 
     read(68,*)nambid,nscalre(ire),typvarsens,pmin,pas
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     if(typvarsens=='LIN')then
         do i=1,nscalre(ire)
           paraciresens(ire,i)=pmin+(i-1)*pas
         enddo
     else 
         do i=1,nscalre(ire)
           paraciresens(ire,i)=pmin*pas**(i-1)
         enddo
     endif
  endif
! loi d arrhenius
  read(68,*)nambid,l_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,ityp_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,teta_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,tempref_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,xeta_sigma_arrh(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! variables reactives
  read(68,*)nambid,nb_var_re(ire)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  do it=1,nb_var_re( ire)
    read(68,*)nambid, namelu
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
    name_var_re(ire,it)=TRIM(ADJUSTL(ADJUSTR(namelu)))
    l_var_sim=.false.
    do iv=1,nvar
       if(TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,it)))).eq.TRIM(ADJUSTL(ADJUSTR(name_esp(iv))))) then
              irkm_var_re(ire,it)=iv
              l_var_sim=.true.
        endif
    enddo
    if(.not.l_var_sim) then
!          si l_var_sim=.false.
           write(*,*)'ATTENTION'
           write(*,*)' la variable ',name_var_re(ire,it)
           write(*,*)' active dans la reaction numero ;',ire
           write(*,*)' N EXISTE PAS dans les especes du modele '
           stop
     endif
     read(68,*)nambid,coef_stochio(ire,it)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     read(68,*)nambid,expo_var(ire,it)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  enddo
! fonctions limitantes
  read(68,*)nambid,nfunct_limit
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  nb_flim1(:)=0
  nb_flim2(:)=0
  if(nfunct_limit.gt.0) then
      do iflim=1,nfunct_limit
         read(68,*)nambid
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         namvar_flim=TRIM(ADJUSTL(ADJUSTR(nambid)))
         read(68,*)nambid,ityp_flim
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         read(68,*)nambid,cte_flim
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
         if(ityp_flim.eq.1) then
           nb_flim1(ire)=nb_flim1(ire)+1
           nfl1=nb_flim1(ire)
           cte_flim1(ire,nfl1)=cte_flim
           l_var_sim=.false.
           do iv=1,nvar
              if(namvar_flim.eq.name_esp(iv)) then
                  irkm_flim1(ire,nfl1)=iv
                  l_var_sim=.true.
              else if(namvar_flim.eq.'sal'.or.namvar_flim.eq.'salinite')then
                  irkm_flim1(ire,nfl1)=-1
                  l_var_sim=.true.
              else if(namvar_flim.eq.'MES')then
                  irkm_flim1(ire,nfl1)=-2
                  l_var_sim=.true.
              endif
           enddo
         else 
           nb_flim2(ire)=nb_flim2(ire)+1
           nfl2=nb_flim2(ire)
           cte_flim2(ire,nfl2)=cte_flim
           l_var_sim=.false.
           do iv=1,nvar
              if(namvar_flim.eq.name_esp(iv)) then
                  irkm_flim2(ire,nfl2)=iv
                  l_var_sim=.true.
              else if(namvar_flim.eq.'sal'.or.namvar_flim.eq.'salinite')then
                  irkm_flim2(ire,nfl2)=-1
                  l_var_sim=.true.
              else if(namvar_flim.eq.'MES')then
                  irkm_flim2(ire,nfl2)=-2
                  l_var_sim=.true.
              endif
            enddo
          endif
       enddo
       if(.not.l_var_sim) then
! l_var_sim=.false.
               write(*,*)'ATTENTION'
               write(*,*)' la variable limitante',namvar_flim
               write(*,*)' indiquee dans le fonction limitante'
               write(*,*)' numero ',iflim,' de la reaction numero ;',ire
               write(*,*)' N EXISTE PAS dans les variables du modele '
               stop
        endif
  endif
enddo
!!!!! pour MOCO : lecture des element pour l'echange cationique
!!!!!                et pour l'initalisation des inconnues
ncat=0
!nthiolp=0
#ifdef key_moco

!  lecture des estimes initiaux
read(68,*)
read(68,*)
read(68,*)
read(68,*)
read(68,*)
read(68,*)nambid,ninc
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
allocate(xinit(ninc))
do i=1,ninc
   read(68,*)nambid,xinit(i)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
enddo   
      
!   lecture du cation competiteur et des constantes d'equilibre
!   d'echange cationique et de complexation 
!  meme si on n'en tient pas compte, on le lit pour avoir un seul fichier
if(l_competcat)then
    write(*,*)'competition avec cations pris en compte'
else
    write(*,*)'pas de competition avec cations'
endif
if(l_echgcat)then
    ncat=1
    write(*,*)'echange cationique pris en compte'
else
    write(*,*)'pas d echange cationique'
endif
allocate(idcharc(nsitmoco_max,nphasp))
allocate(xequcs(nsitmoco_max,nphasp))
idcharc(:,:)=0
xequcs(:,:)=0.
if(l_competcat .or. l_echgcat)then
  read(68,*)
  read(68,*)
  read(68,*)
  read(68,*)
  read(68,*)nambid,nom_cat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,icharcat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,xequcat
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,xequmet
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,cec
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(68,*)nambid,nambid
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  name_sub_echcompcat=TRIM(ADJUSTL(ADJUSTR(nambid)))
  if(l_echgcat)name_esp(iesp_echgcat)=  &
   'echg cation '//TRIM(ADJUSTL(ADJUSTR(nom_cat)))//'sur '//TRIM(ADJUSTL(ADJUSTR(nambid)))
  do js=1,nphasp
     read(68,*)
     do  isit=1,nsit(js)
        read(68,*)nambid,idcharc(isit,js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
        read(68,*)nambid,xequcs(isit,js)
#ifdef MODTEST
   write(*,*)'lecture conta  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
     enddo      
  enddo 
endif
!
!   lecture des thiols particulaires et des constantes correspondantes
!   pour complexation du mercure par exemple
!if(l_thiolpart)then
!  write(*,*)'complexation avec des sites thiols particulaires'
!  nthiolp=2
!  read(68,*)
!  read(68,*)
!  read(68,*)
!  read(68,*)
! ! nom de la phase associe aux sites thiols
!  read(68,*)nambid,nambid
!  name_sub_thiol=TRIM(ADJUSTL(ADJUSTR(nambid)))
!  name_esp(iesp_thiol_mono)=  &
!   'thiol_mono'//'_sur_'//TRIM(ADJUSTL(ADJUSTR(nambid)))
!  name_sub_esp(iesp_thiol_mono)=name_sub_thiol
!  name_esp(iesp_thiol_bi)=  &
!   'thiol_bi'//'_sur_'//TRIM(ADJUSTL(ADJUSTR(nambid)))
!  name_sub_esp(iesp_thiol_bi)=name_sub_thiol
! ! nombre de sites totaux en thiols particulaires (mol/g)
!  read(68,*)nambid,cthiolpart
! ! conversion en nmole/g
!  cthiolpart=cthiolpart*1.d+09
!  
! ! constante de complexation Kah pour fonction thiol particulaire
!  read(68,*)nambid,xx,xkathiolp
!  ixx=nint(xx)
!  if(ixx==10)xkathiolp=10**xkathiolp
!  write(*,*)'Cte equilibre reaction Thiol particulaire =',xkathiolp
! ! constante de complexation pour site thiol -Hg monodentate
!  read(68,*)nambid,xx,xequRSHg
!  ixx=nint(xx)
!  if(ixx==10)xequRSHg=10**xequRSHg
!  write(*,*)'Cte complexation  Thiol  -Hg monodentate =',xequRSHg
! ! constante de complexation pour site thiol -Hg bidentate
!  read(68,*)nambid,xx,xequR2SHg
!  ixx=nint(xx)
!  if(ixx==10)xequR2SHg=10**xequR2SHg
!  write(*,*)'Cte complexation  Thiol  -Hg bidentate =',xequR2SHg
!else
!    write(*,*)'pas de complexation avec des sites thiols particulaires'!
!endif
!
! verification de la charge du metal
 if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cd' .or.  &
    TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cadmium')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Cd a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Co' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cobalt')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Co a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cs' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Cesium')then
     if(icharlib.ne.1)then
       icharlib=1
       write(*,*)'ATTENTION : la charge de l"ion Cs a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Hg' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Mercure')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Hg a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Pb' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Plomb')then
     if(icharlib.ne.2)then
       icharlib=2
       write(*,*)'ATTENTION : la charge de l"ion Pb a t modifie'
     endif
 else if(TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Ag' .or.  &
          TRIM(ADJUSTL(ADJUSTR(name_conta)))=='Argent')then
     if(icharlib.ne.1)then
       icharlib=1
       write(*,*)'ATTENTION : la charge de l"ion Ag a t modifie'
     endif
 endif
#endif      

!!!! BOUCLE SUR TOUS LES SCENARIOS
!!=================================
ncalcul=1
! parametres physicochimiques
do ip=1,npar_conta
  ncalcul=ncalcul*nscalcul(ip)
enddo
#ifdef key_moco
! ssp
do js=1,nphasp
   ncalcul=ncalcul*nscalmoco1(js)
   do isit=1,nsit(js)
     !! ka1,ka2,km..
       ncalcul=ncalcul*nscalmoco2(js,isit)  
   enddo
   if((js==1.and.nsit(js)>2) .or. (js>1.and.nsit(js)>1) .or. js>2)then
     write(*,*)'ATTENTION : pour l etude de sensibilite avec MOCO'
     write(*,*)'vous ne pouvez pas avoir plus de 2 substrats partculaires'
     write(*,*)'ni plus de 2 sites sur le premier substrat'
     write(*,*)'ni plus de 1 site sur le second substrat'
     write(*,*)'la simulation est stoppee'
     stop
   endif
enddo
#else
! coef de partages si pas MOCO
ncalcul_part=0
do iesp=nesp_diss_ne+1,nesp_diss+nesp_part_eq
  ncalcul=ncalcul*nscalcul(npar_conta+iesp) 
  ncalcul_part=ncalcul_part+1
enddo
#endif

! especes particulaires desorbables en cinetique
  do iesp=1,nesp_part_ci
    ncalcul=ncalcul*nscalcul(npar_conta+nespt+iesp)    & 
                   *nscalcul(npar_conta+nesp_part_ci+iesp)    & 
                   *nscalcul(npar_conta+2*nesp_part_ci+iesp)     
  enddo
! especes particulaires non echangeables
  do iesp=1,nesp_part_ne
    ncalcul=ncalcul*nscalcul(npar_conta+3*nesp_part_ci+iesp)     
  enddo
! cinetiques max des reactions generiques
  nb_reac_var=0
  do ire=1,nb_reac
    ncalcul=ncalcul*nscalre(ire)
    if(nscalre(ire)>1)then
       nb_reac_var=nb_reac_var+1
    endif  
  enddo
  if(nb_reac_var>0)then
    ALLOCATE(in_reac_var(nb_reac_var))
    nb_reac_var=0
    do ire=1,nb_reac
      if(nscalre(ire)>1)then
         nb_reac_var=nb_reac_var+1
         in_reac_var(nb_reac_var)=ire 
      endif  
    enddo
  endif
  
  if(nb_reac_var>5)then
    write(*,*)'ATTENTION : vous faitesvarier la cinetique'
    write(*,*)'de plus de 5 reactions generiques supplementaires'
    write(*,*)'ce n est pas permis !!'
    write(*,*)'limiter le nombre  5  .. merci'
   stop
  endif
write(*,*)'NOMBRE TOTAL DE SCENARIOS :', ncalcul
allocate(pdmolecv(ncalcul))
allocate(xnb_schmidtv(ncalcul))
allocate(diffusivitev(ncalcul))
allocate(henryv(ncalcul))
allocate(henry_adimv(ncalcul))
allocate(coefH_staudingerv(ncalcul))
allocate(cte_saltv(ncalcul))
#ifdef key_moco
allocate(sspv(nphasp,ncalcul))
allocate(sitacv(nsitmoco_max,nphasp,ncalcul))
allocate(xequa1v(nsitmoco_max,nphasp,ncalcul))
allocate(xequa2v(nsitmoco_max,nphasp,ncalcul))
allocate(xequmsv(nsitmoco_max,nphasp,ncalcul))
#else
allocate(xpart_espv(nespt,ncalcul))
#endif
allocate(finitv(nespt,ncalcul))
if(nesp_part_ci>0)then
   allocate(cte_vitv(nesp_part_ci,ncalcul))
   allocate(ceq_civ(nesp_part_ci,ncalcul))   
endif
allocate(cin_max_rev(nb_reac,ncalcul))

ical=0
do ip1=1,nscalcul(1)
 do ip2=1,nscalcul(2)
  do ip3=1,nscalcul(3)
   do ip4=1,nscalcul(4)
    do ip5=1,nscalcul(5)
     do ip6=1,nscalcul(6)
      do ip7=1,nscalcul(7)
#ifdef key_moco
       nparcal_avt=npar_conta
       nparcal_aprs=nesp_diss+nesp_part_eq
       if(nphasp==0)then
         nfois01=1
         nfois02=1
       else
         nfois01=nscalmoco1(1)
         nfois02=nscalmoco2(1,1)
       endif
       ! premiere phase
       do ips1=1,nfois01
         do ips3=1,nfois02
          if(nphasp>0 .and.nsit(1).gt.1)then
             nfois1=nscalmoco2(1,nsit(1))
          else
             nfois1=1
          endif
          do ips4=1,nfois1
          ! seconde phase
            if(nphasp>1)then
              nfois2=nscalmoco1(2)
              nfois3=nscalmoco2(nphasp,1)
            else
              nfois2=1
              nfois3=1
            endif
            do ips5=1,nfois2
             do ips6=1,nfois3
                        
#else
       nparcal_avt=npar_conta+nesp_diss+nesp_part_eq
       nparcal_aprs=nesp_diss+nesp_part_eq
       do ips1=1,nscalcul(npar_conta+1)
        if(nesp_diss+nesp_part_eq >1)then
          nfois1=nscalcul(npar_conta+2)
        else
          nfois1=1
        endif
        do ips2=1,nfois1
         if(nesp_diss+nesp_part_eq >2)then
            nfois2=nscalcul(npar_conta+3)
         else
            nfois2=1
         endif
         do ips3=1,nfois2
          if(nesp_diss+nesp_part_eq >3)then
            nfois3=nscalcul(npar_conta+4)
          else
            nfois3=1
          endif
          do ips4=1,nfois3
           if(nesp_diss+nesp_part_eq >4)then
                 write(*,*)'attention, plus de 4 variables dissoutes+part en equilibre'
                 write(*,*)'trop pour l etude de sensibilite'
                 stop
           endif
#endif
           if(nesp_part_ci >0)then
             nfoisc0=nscalcul(nparcal_avt+1)
           else
             nfoisc0=1
           endif
           do ipc1=1,nfoisc0
            if(nesp_part_ci >1)then
              nfoisc1=nscalcul(nparcal_avt+2)
            else
              nfoisc1=1
            endif
            do ipc2=1,nfoisc1
             if(nesp_part_ci ==0)then
               nfoisn0=1
             else
               nfoisn0=nscalcul(nparcal_avt+nesp_part_ci+1)
             endif
             do ipe1=1,nfoisn0
              if(nesp_part_ne >1)then
                nfoisn1=nscalcul(nparcal_avt+nesp_part_ci+2)
              else
                nfoisn1=1
              endif
              do ipe2=1,nfoisn1
               if(nb_reac==0)then
                 nfoisr0=1
               else
                 nfoisr0=nscalre(1)
               endif
               do ir1=1,nfoisr0
                if(nb_reac >1)then
                  nfoisr1=nscalre(2)
                else
                 nfoisr1=1
                endif
                do ir2=1,nfoisr1
                 if(nb_reac >2)then
                   nfoisr2=nscalre(3)
                 else
                  nfoisr2=1
                 endif
                 do ir3=1,nfoisr2
                  if(nb_reac >3)then
                    nfoisr3=nscalre(4)
                  else
                    nfoisr3=1
                  endif
                  do ir4=1,nfoisr3
                   if(nb_reac >4)then
                     nfoisr4=nscalre(5)
                   else
                     nfoisr4=1
                   endif
                   do ir5=1,nfoisr4
              
                    ical=ical+1
                    pdmolecv(ical)=paracontasens(1,ip1)
                    xnb_schmidtv(ical)=paracontasens(2,ip2)
                    diffusivitev(ical)=paracontasens(3,ip3)
                    henryv(ical)=paracontasens(4,ip4)
                    henry_adimv(ical)=paracontasens(5,ip5)
                    coefH_staudingerv(ical)=paracontasens(6,ip6)
                    cte_saltv(ical)=paracontasens(7,ip7)
#ifdef key_moco
                    if(nphasp>0)then
                      sspv(1,ical)=ssp_sens(1,ips1)
                      sitacv(1,1,ical)=sitac_sens(1,1,ips3)
                      xequa1v(1,1,ical)=xequa1_sens(1,1,ips3)
                      xequa2v(1,1,ical)=xequa2_sens(1,1,ips3)
                      xequmsv(1,1,ical)=xequms_sens(1,1,ips3)
                      if(nsit(1).eq.2)then
                       sitacv(nsit(1),1,ical)=sitac_sens(nsit(1),1,ips4)
                       xequa1v(nsit(1),1,ical)=xequa1_sens(nsit(1),1,ips4)
                       xequa2v(nsit(1),1,ical)=xequa2_sens(nsit(1),1,ips4)
                       xequmsv(nsit(1),1,ical)=xequms_sens(nsit(1),1,ips4)
                      endif
                      if(nphasp==2)then
                       sspv(nphasp,ical)=ssp_sens(nphasp,ips5)
                       sitacv(1,nphasp,ical)=sitac_sens(1,nphasp,ips6)
                       xequa1v(1,nphasp,ical)=xequa1_sens(1,nphasp,ips6)
                       xequa2v(1,nphasp,ical)=xequa2_sens(1,nphasp,ips6)
                       xequmsv(1,nphasp,ical)=xequms_sens(1,nphasp,ips6)                    
                      endif
                    endif
#else
                    xpart_espv(1,ical)=parapartsens(1,ips1)
                    if(nesp_diss+nesp_part_eq >1)xpart_espv(2,ical)=parapartsens(2,ips2)
                    if(nesp_diss+nesp_part_eq >2)xpart_espv(3,ical)=parapartsens(3,ips3)
                    if(nesp_diss+nesp_part_eq >3)xpart_espv(4,ical)=parapartsens(4,ips4)
#endif  
                  
!!!!   finit, cte_vit,ceq_ci (ceq_ci donne par kg de particules)
                    if(nesp_part_ci >0)then
                      finitv(nparcal_aprs+1,ical)=paraespcisens(1,1,ipc1)
                      cte_vitv(1,ical)=paraespcisens(2,1,ipc1)/86400._rlg
                      ceq_civ(1,ical)=paraespcisens(3,1,ipc1)
                    else if(nesp_part_ci >1)then
                        finitv(nparcal_aprs+2,ical)=paraespcisens(2,1,ipc2)
                        cte_vitv(2,ical)=paraespcisens(2,2,ipc2)/86400._rlg
                        ceq_civ(2,ical)=paraespcisens(3,2,ipc2)
                    endif
!!! finitv  NE         
                    if(nesp_part_ne >0)then
                      finitv(nparcal_aprs+nesp_part_ci+1,ical)=paraespnesens(1,ipe1)
                      if(nesp_part_ne >1)finitv(nparcal_aprs+nesp_part_ci+2,ical)=paraespnesens(2,ipe2)
                    endif
!! echange cationique
#ifdef key_moco
                    if(l_echgcat)finitv(nespt,ical)=0.
#endif
!!reactions
                    cin_max_rev(:,ical)=paraciresens(:,1)/86400.
                    if(nb_reac_var >0)cin_max_rev(in_reac_var(1),ical)=paraciresens(in_reac_var(1),ir1)/86400.
                    if(nb_reac_var >1)cin_max_rev(in_reac_var(2),ical)=paraciresens(in_reac_var(2),ir2)/86400.
                    if(nb_reac_var >2)cin_max_rev(in_reac_var(3),ical)=paraciresens(in_reac_var(3),ir3)/86400.
                    if(nb_reac_var >3)cin_max_rev(in_reac_var(4),ical)=paraciresens(in_reac_var(4),ir4)/86400.
                    if(nb_reac_var >4)cin_max_rev(in_reac_var(5),ical)=paraciresens(in_reac_var(5),ir5)/86400.
                   enddo
                  enddo
                 enddo
                enddo
               enddo
              enddo
             enddo
            enddo
           enddo
#ifdef key_moco
           enddo
#endif
          enddo
         enddo
        enddo
       enddo
      enddo
     enddo
    enddo
   enddo
  enddo
 enddo
enddo
     
  END SUBROUTINE lect_contavar


 END MODULE

