MODULE lectur_milieu
   !!======================================================================
   !!                   ***   lecture des variables du milieu  ***
   !!======================================================================
   !!======================================================================
   !! * Modules used
USE parametres
USE com_morgan
#ifdef key_moco
  USE com_moco
#endif
USE com_varmilieu

IMPLICIT NONE
PRIVATE

   !! * Accessibility
PUBLIC lect_varmilieu     ! routine called by moco_morgan.F90
PUBLIC lect_varmilieusens       ! routine called by moco_morgan.F90

   !! * Shared module variables

   !! * Private variables

 CONTAINS
                  SUBROUTINE lect_varmilieu
   !!       lecture des variables du milieu fixees
   !!======================================================================
   !! * Modules used

   !! * Local declarations
 integer                          :: ip,il,isub,isb,ine,ici,i,is,iesp,iss,pos
 integer,dimension(:),allocatable :: ichar_sub
 real(kind=rlg)                   :: ff
 real(kind=rlg),dimension(:),allocatable     :: f_espNE_in,f_espci_in,csubd
 character(len=lchain)            :: fic_varmil,nambid,unite_temps
 character(len=lchain),dimension(:),allocatable            :: name_subd
 logical                          :: l_ok

write(*,*)' ******************************************'
write(*,*)'nom du fichier de donnees FIXES du milieu =',name_file_varmilfix
write(*,*)' ******************************************'
open(687,file='varmilieu/'//name_file_varmilfix)
read(687,*)
read(687,*)
        
write(*,*)' **************************************************'
read(687,*)nambid,echel_temps
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'echelle de temps considr (jours) ',echel_temps
echel_temps=echel_temps*86400
read(687,*)nambid,dt,unite_temps
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(dt.eq.0)then
     dt=86400
else
  if(unite_temps(1:3)=='jou')then
       dt=dt*86400.
  else if(unite_temps(1:3)=='heu')then
       dt=dt*3600.
  else if(unite_temps(1:3)=='min')then
       dt=dt*60.
  else if(unite_temps(1:3)=='sec')then
       dt=dt
  endif
endif
write(*,*)'pas de temps choisi (en jour)=',dt/86400 

! pour ecriture de chaque scenario en fonction du temps : pas de temps d ecriture 
read(687,*)nambid,dt_ecr,unite_temps
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(unite_temps(1:3)=='jou')then
       dt_ecr=dt_ecr*86400.
else if(unite_temps(1:3)=='heu')then
       dt_ecr=dt_ecr*3600.
else if(unite_temps(1:3)=='min')then
       dt_ecr=dt_ecr*60.
else if(unite_temps(1:3)=='sec')then
       dt_ecr=dt_ecr
endif
write(*,*)'pas de temps pour ecriture resultats (seconde)',dt_ecr

! nombre de fichiers d ecriture des resultats pour tous les scenarios  des instants donnes
!  en plus de l'instant initial t0+dt
read(687,*)nambid,necr_scenario
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
dt_ecr_scen=echel_temps/necr_scenario

read(687,*)
read(687,*)nambid,c_conta_tot0
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'conc. totale contaminant dans eau = ',c_conta_tot0
write(*,*)'exprime en : ',unite_conta,'/m3'
read(687,*)nambid,c_conta_air
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
! conversion en nM
c_conta_tot0=c_conta_tot0*conversunit
c_conta_air=c_conta_air*conversunit

write(*,*)'conc. totale contaminant dans air = ',c_conta_air
write(*,*)'exprime en : ',unite_conta,'/m3'
read(687,*)nambid        
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,temperaC
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
temperaK=temperaC+273.15
write(*,*)'temperature du milieu (C) ?= ',temperaC
read(687,*)nambid,uc
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'courant moyen (m/s) ? =',uc
read(687,*)nambid,zc
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'profondeur moyenne (m)= ? ',zc
read(687,*)nambid,ventc
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'vitesse du vent  10m (m/s) =? ',ventc
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,salinite
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'salinite =? ',salinite
read(687,*)nambid,valeur_ph
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'pH = ',valeur_ph
#ifdef key_moco
if(l_competcat .or. l_echgcat)then
   read(687,*)nambid,ccat
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
else
   read(687,*)
endif
#else
read(687,*)
#endif  
read(687,*)nambid
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,c_MESt
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'MES totales =? ',c_MESt
read(687,*)nambid,npart
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
write(*,*)'nombre de type de particules? ',npart
read(687,*)nambid
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif

allocate(fpart(npart))
allocate(vdepo(npart))
allocate(cpart(npart))
ff=0.
do ip=1,npart
  read(687,*)nambid,fpart(ip)          
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(687,*)nambid,vdepo(ip)          
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  write(*,*)'fraction du type',ip,' et vitesse depot: ',fpart(ip),vdepo(ip)
  ff=ff+fpart(ip)
  cpart(ip)=fpart(ip)*c_MESt
enddo
if(ff.ne.1.)then
    write(*,*)'ATTENTION '
    write(*,*)'La somme des proportions de chaque type '
    write(*,*)'de particules est diffrente de 1'
    write(*,*)'voir fichier de donnees du milieu'
    stop
endif
read(687,*)
        

write(*,*)' ******************************************'
write(*,*)'concentrations de chaque ligand DISSOUS'
write(*,*)'mme si l une d entre elles va varier ensuite'
write(*,*)' ******************************************'

read(687,*)
read(687,*)
read(687,*)nambid,nsubd
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif

allocate(name_subd(nsubd))
allocate(csubd(nsubd))
#ifdef key_moco
ALLOCATE(ichar_sub(nsubd))
ALLOCATE(xfacth_subd(nsubd))
#endif

isub=0
do il=1,nsubd
  isub=isub+1
#ifdef key_moco
  read(687,*)nambid,name_subd(isub),ichar_sub(isub),xfacth_subd(isub)
#else
  read(687,*)nambid,name_subd(isub)
#endif
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(687,*)nambid,csubd(isub)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif

  write(*,*)'concentration (g/l) de ',name_subd(isub),csubd(isub)
enddo
#ifdef key_moco
!  reperage des ligands associs aux especes dissoutes de MOCO 
!   ===================================================================
  allocate(isub_lig(nlig))
  allocate(icharl(nlig))
  allocate(xfacth_som(nesp_diss_moco))
  do i=1,nesp_diss_moco
    l_ok=.false.
    nambid=nom_lig_esp(i)
    if(nambid(1:3)=='Chl' .or. nambid(1:2)=='Cl')then
        write(*,*)'ligand dissous MOCO  ',TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))),' n ',i
        write(*,*)'donne par la salinite '
        l_ok=.true.
        isub_lig(ilig_esp(i))=-1
        icharl(ilig_esp(i))=1
        xfacth_som(i)=-xfacth_esp(i)
        ilisal=ilig_esp(i)     !   Reperage du rangement du ligand Salinite
    else if(nambid(1:2)=='OH')then
        write(*,*)'ligand dissous MOCO  ',TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))),' n ',i
        write(*,*)'donne par le pH '
        l_ok=.true.
        isub_lig(ilig_esp(i))=-10
        icharl(ilig_esp(i))=1
        xfacth_som(i)=xfactl(i)-xfacth_esp(i)
        iliph=ilig_esp(i)       !   Reperage du rangement du ligand pH
    else
      do iss=1,nsubd
        if(TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))).eq.TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))))then
          isub_lig(ilig_esp(i))=iss
          write(*,*)'ligand dissous MOCO  ',TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))),' n ',i
          write(*,*)'donne par le substrat ',TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))),' n ',iss 
          l_ok=.true.
          icharl(ilig_esp(i))=ichar_sub(iss)
          xfacth_som(i)=xfactl(i)*xfacth_subd(iss)-xfacth_esp(i)
          pos=index(nambid,'hiol_diss')
          if(pos/=0)ilithiold=ilig_esp(i)      ! Reperage du rangement du ligand Thiols dissous (RS-))
          pos=index(nambid,'hiol_part')
          if(pos/=0)ilithiolp=ilig_esp(i)      ! Reperage du rangement du ligand Thiols particulaire considere comme dissous (RSH))
          pos=index(nambid,'CO3')
          if(pos/=0)ilico3=ilig_esp(i)          ! Reperage du rangement du ligand CO3 (carbonate)
          pos=index(nambid,'ulfur')
          if(pos/=0)ilisulf=ilig_esp(i)          ! Reperage du rangement du ligand HS- (sulfur) 
          pos=index(nambid,'Lcarb')
          if(pos/=0)ilimodcarb=ilig_esp(i)       ! Reperage du rangement du ligand Lcarb (MOD carboxylique) 
          pos=index(nambid,'Lphen')
          if(pos/=0)ilimodphen=ilig_esp(i)       ! Reperage du rangement du ligand Lphen (MOD phenolique) 
          exit
        endif
      enddo 
    endif
    if(.not.l_ok)then
      write(*,*)'pas de substrat dissous defini correspondant au ligand ',nom_lig_esp(i),' n ',i
      write(*,*)'revoir le fichier de donnees des variables du milieu'
      stop
    endif
  enddo
#else
do i=1,nesp_diss
  l_ok=.false.
  do iss=1,nsubd
    if(TRIM(ADJUSTL(ADJUSTR(name_sub_esp(i)))).eq.TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))))then
        isub_esp(i)=iss
        write(*,*)'espece  ',TRIM(ADJUSTL(ADJUSTR(name_esp(i)))),' n ',i,   &
                 ' / associ au substrat ',TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))),  &
                 ' n ',iss 
         l_ok=.true.        
    endif
  enddo 
  if(.not.l_ok)then
    write(*,*)'pas de substrat dissous defini correspondant a l espece',name_esp(i),' n ',i
    write(*,*)'revoir le fichier de donnees des variables du milieu'
    stop
  endif
enddo
#endif
read(687,*)
read(687,*)
write(*,*)' ******************************************'
write(*,*)'concentrations de chaque substrat particulaire'
write(*,*)' ******************************************'
read(687,*)nambid,nsubp
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
nsub=nsubd+nsubp
allocate(ipart_sub(nsub))
allocate(fpart_sub(nsub))
allocate(fmest_sub(nsub))
allocate(name_sub(nsub))
allocate(csub(nsub))
csub(1:nsubd)=csubd(:)
ipart_sub(:)=0
name_sub(1:nsubd)=name_subd(:)
deallocate(csubd)
deallocate(name_subd)
do isb=1,nsubp
   isub=isub+1
   read(687,*)nambid,name_sub(isub)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(687,*)nambid,ipart_sub(isub)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(687,*)nambid,fpart_sub(isub)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   write(*,*)'fraction/type MES associe  ',name_sub(isub),fpart_sub(isub)
   fmest_sub(isub)=fpart_sub(isub)*fpart(ipart_sub(isub))
   write(*,*)'fraction/MES totales  ',fmest_sub(isub)
   csub(isub)=fmest_sub(isub)*c_MESt
enddo
        
!  reperage des substrats associs a chacune des especes 
! verficiation si on les a tous meme pour les ligand dissous inorganiques
!   ===================================================================
    do i=nesp_diss+1,nespt
       l_ok=.false.
       do is=1,nsubp
         isub=nsubd+is
         if(name_sub_esp(i).eq.name_sub(isub))then
           isub_esp(i)=isub
           write(*,*)'espece  ',TRIM(ADJUSTL(ADJUSTR(name_esp(i)))),' n ',i, &
              ' associ au substrat ',TRIM(ADJUSTL(ADJUSTR(name_sub(isub)))), ' n ',isub 
          else if(i>nesp_diss+nesp_part_eq+nesp_part_ci   &
             .and.i<nesp_diss+nesp_part_eq+nesp_part_ci+nesp_part_ne+1)then
           l_ok=.true.
          endif
          l_ok=.true.
       enddo 
       if(.not.l_ok)then
          write(*,*)'pas de substrat particulaire defini correspondant  l espece',name_esp(i),' n ',i
          write(*,*)'revoir le fichier de donnees des variables du milieu'
         stop
        endif
    enddo

    do i=1,ncalcul
      do ici=1,nesp_part_ci
        iesp=nesp_diss+nesp_part_eq+ici
        isub_esp(iesp)=isub_esp(iesp_assoc(iesp))
     ! si true : ceq_ci a ete donne en fraction de la concentration initiale totale
        if(ichoix_ceqci(ici)==1)then
          ceq_civ(ici,i)=ceq_civ(ici,i)*c_conta_tot0
        endif
      enddo
    enddo

    
#ifdef key_moco
!  reperage des substrats associs aux phases particulaires  de MOCO 
!   ===================================================================
  if(nphasp.ne.0)then
    allocate(isub_phase(nphasp))
    if(l_moco_op)then
!     mode operationnel : une seule phase = MESt
      isub_phase(1)=0
      if(l_echgcat .or.l_competcat)isub_echcompcat=1
!      if(l_thiolpart)isub_thiolpart=1
    else
      do i=1,nphasp
        l_ok=.false.
        do is=1,nsubp
          isub=nsubd+is
          if(nom_phase(i).eq.name_sub(isub))then
            isub_phase(i)=isub
            write(*,*)'phase particulaire MOCO  ',nom_phase(i),' n ',i, &
                   ' / donne par le substrat ',name_sub(isub),' n ',isub 
            l_ok=.true.
          endif
        enddo 
        if(.not.l_ok)then
          write(*,*)'pas de substrat particulaire defini '
          write(*,*)'correspondant a la phase de complexation',nom_phase(i),' n ',i
          write(*,*)'revoir le fichier de donnees des variables du milieu'
          stop
        endif
        if(l_echgcat .or.l_competcat)then
          l_ok=.false.
          do is=1,nsubp
            isub=nsubd+is
            if(name_sub(isub).eq.name_sub_echcompcat)then
              isub_echcompcat=isub
              write(*,*)'phase echangeur de cation MOCO  ',name_sub_echcompcat, &
              ' / donne par le substrat ',name_sub(isub),' n ',isub 
              l_ok=.true.
            endif
          enddo 
          if(.not.l_ok)then
            write(*,*)'pas de substrat particulaire defini '
            write(*,*)'correspondant a la phase echangeur de cation',name_sub_echcompcat
            write(*,*)'revoir le fichier de donnees des variables du milieu'
            stop
          endif
        endif
!        if(l_thiolpart)then
!          l_ok=.false.
!          do is=1,nsubp
!            isub=nsubd+is
!            if(name_sub(isub).eq.name_sub_thiol)then
!              isub_thiolpart=isub
!              write(*,*)'phase avec site THIOL particulaire  ',  &
!                        TRIM(ADJUSTL(ADJUSTR(name_sub_thiol))), &
!              ' / donne par le substrat ',TRIM(ADJUSTL(ADJUSTR(name_sub(isub)))),' n ',isub 
!              l_ok=.true.
!            endif
!          enddo 
!          if(.not.l_ok)then
!            write(*,*)'pas de substrat particulaire defini '
!            write(*,*)'correspondant a la phase avec site thiol particulaire',name_sub_thiol
!            write(*,*)'revoir le fichier de donnees des variables du milieu'
!            stop
!          endif
!        endif
      enddo
    endif
  else
 ! pas d especes particulaires en equilibre de sorption
    if(l_echgcat .or. l_competcat)then
       l_ok=.false.
       do is=1,nsubp
          isub=nsubd+is
          if(name_sub(isub).eq.name_sub_echcompcat)then
              isub_echcompcat=isub
              write(*,*)'phase echangeur de cation MOCO  ',name_sub_echcompcat, &
              ' / donne par le substrat ',name_sub(isub),' n ',isub 
              l_ok=.true.
          endif
        enddo 
        if(.not.l_ok)then
            write(*,*)'pas de substrat particulaire defini '
            write(*,*)'correspondant a la phase echangeur de cation',name_sub_echcompcat
            write(*,*)'revoir le fichier de donnees des variables du milieu'
            stop
        endif
    endif
!    if(l_thiolpart)then
!       l_ok=.false.
!       do is=1,nsubp
!            isub=nsubd+is
!            if(name_sub(isub).eq.name_sub_thiol)then
!              isub_thiolpart=isub
!              write(*,*)'phase avec site THIOL particulaire  ',  &
!                        TRIM(ADJUSTL(ADJUSTR(name_sub_thiol))), &
!              ' / donne par le substrat ',TRIM(ADJUSTL(ADJUSTR(name_sub(isub)))),' n ',isub 
!              l_ok=.true.
!            endif
!        enddo 
!        if(.not.l_ok)then
!            write(*,*)'pas de substrat particulaire defini '
!            write(*,*)'correspondant a la phase avec site thiol particulaire',name_sub_thiol
!            write(*,*)'revoir le fichier de donnees des variables du milieu'
!            stop
!         endif
!     endif
  endif
#endif
      
       
!!!!!!!!  donnees sur les volumes et les flux
!!!!!!!!  -----------------------------------------------
allocate(c_sub_in(nsubd))
allocate(fpart_in(npart))
allocate(flux_part_in(npart))
allocate(flux_sub_in(nsub))
read(687,*)
read(687,*)
read(687,*)nambid,vol_eau        
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,surf_eau        
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,flux_eau_inout
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
!read(687,*)nambid,(c_sub_in(is),is=1,nsubd)
!read(687,*)nambid,cMESt_in
!read(687,*)nambid,(fpart_in(ip),ip=1,npart)
!!!!!! conversion de /an a /seconde 
flux_eau_inout=flux_eau_inout/86400._RLG/365._RLG 
! cMESt_in et fpart_in pas lu = c_MESt (valeur initiale)
cMESt_in=c_MESt
fpart_in=fpart

flux_MESt_in=flux_eau_inout*cMESt_in
flux_part_in(:)=flux_eau_inout*fpart_in(:)*cMESt_in 
! c_sub_in=csub initial=csub(1:nsubd)
!flux_sub_in(1:nsubd)= flux_eau_inout*c_sub_in(1:nsubd)
flux_sub_in(1:nsubd)= flux_eau_inout*csub(1:nsubd)
flux_sub_in(nsubd+1:nsubd+nsubp)=fpart_sub(nsubd+1:nsubd+nsubp)  &
       *flux_part_in(ipart_sub(nsubd+1:nsubd+nsubp)) 
read(687,*)nambid,conta_tot_in  
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
conta_tot_in=conta_tot_in**conversunit      
ff=0.
if(nesp_part_ne>0)then
   allocate(f_espNE_in(nesp_part_ne))
   allocate(flux_espne_in(nesp_part_ne))
   read(687,*)nambid,(f_espNE_in(ine),ine=1,nesp_part_ne)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   do ine=1,nesp_part_ne        
      flux_espne_in(ine)=flux_eau_inout*conta_tot_in*f_espNE_in(ine)
      ff=ff+f_espNE_in(ine)
   enddo   
else
   read(687,*)
endif        
if(nesp_part_ci>0)then
   allocate(f_espci_in(nesp_part_ci))
   allocate(flux_espci_in(nesp_part_ci))
   read(687,*)nambid,(f_espci_in(ine),ine=1,nesp_part_ci)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   do ici=1,nesp_part_ci        
          flux_espci_in(ici)=flux_eau_inout*conta_tot_in*f_espci_in(ici) 
          ff=ff+f_espci_in(ici)
   enddo 
else
   read(687,*)
endif        
flux_espech_in=flux_eau_inout*conta_tot_in*(1-ff) 
  
! un seul scenario pour les variables du milieu
! allocation et initialisation
     
   allocate(csub_v(nsub,1))
   allocate(cesp(nvar,ncalcul))
   allocate(pcent_cesp(nvar,ncalcul))
   allocate(cpart_v(npart,1))
   allocate(fpart_v(npart,1))
   allocate(var_milieu(9,1))
   
!! initialisation
!!================
   cesp(:,:)=0.
   
   csub_v(:,1)=csub(:)
!! Especes particulaires non echangeable ou pas  l'quilibre
   cesp(nesp_diss+nesp_part_eq+1:nespt,:)=  &
                 finitv(nesp_diss+nesp_part_eq+1:nespt,:)*c_conta_tot0
   cpart_v(:,1)=cpart(:)
   fpart_v(:,1)=cpart(:)/c_MESt
   var_milieu(1,1)=c_MESt
   var_milieu(2,1)=temperaC
   var_milieu(3,1)=salinite
   var_milieu(4,1)=uc
   var_milieu(5,1)=ventc
   var_milieu(6,1)=zc
   var_milieu(7,1)=c_conta_air
   var_milieu(8,1)=c_conta_tot0
   var_milieu(9,1)=valeur_ph
   
   END SUBROUTINE lect_varmilieu

!****************************************************************************
                SUBROUTINE lect_varmilieusens
         
   !! possibilite de faire plusieurs calculs en faisant varier 
   !!  une variable du milieu ou un substrat
   !!  ------------------------------------------------------------------------
   !! * Modules used
   
   !! * Arguments

   !! * Local declarations
 integer                          :: ip,il,isub,isb,ine,ici,ipart_sens,nsubvar
 integer                          :: is,iss,ncalculc,ical,nscalculmax,i,pos
 integer                          :: is1,is2,is3,is4,is5,is6,is7,is8,is9,isp,isu1
 integer                          :: iss1,iss2,iss3,isu2,isu3,nb_varmilp1
 integer,dimension(0:20)          :: nscalcul
 integer,dimension(20)            :: ichvarsens
 integer,dimension(3)             :: isubvar
 integer,dimension(:),allocatable :: ichar_sub
 real(kind=rlg)                   :: ff
 real(kind=rlg),dimension(:),allocatable     :: f_espNE_in,f_espci_in
 character(len=lchain)            :: nambid,unite_temps
 character(len=lchain),dimension(:),allocatable    :: name_subd
 logical                          :: l_ok
 REAL(KIND=rlg),dimension(20)     :: valmin,pas_sens
 REAL(KIND=rlg),dimension(:),allocatable     :: c_conta_air_sens
 REAL(KIND=rlg),dimension(:),allocatable     :: tempeC_sens,uc_sens,ventc_sens,sal_sens
 REAL(KIND=rlg),dimension(:),allocatable     :: zc_sens,fpart1_sens,cmestot_sens
 REAL(KIND=rlg),dimension(:,:),allocatable     :: csub_sens,foc_sens,csubd_sens
!! variable pH en plus
 REAL(KIND=rlg),dimension(:),allocatable     :: val_ph_sens

!!!!!!  ------------------------------------------------------------------------

!   lecture dans un fichier
!////////////////////////////
write(*,*)' ******************************************'
write(*,*)'nom du fichier de donnees du milieu  lire =',name_file_varmilsens
write(*,*)' ******************************************'
open(687,file='varmilieu/'//name_file_varmilsens)
read(687,*)
read(687,*)
        
write(*,*)' **************************************************'
read(687,*)nambid,echel_temps
write(*,*)'echelle de temps considr (jours) ',echel_temps
echel_temps=echel_temps*86400
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,dt,unite_temps
if(dt.eq.0)then
     dt=86400
else
  if(unite_temps(1:3)=='jou')then
       dt=dt*86400.
  else if(unite_temps(1:3)=='heu')then
       dt=dt*3600.
  else if(unite_temps(1:3)=='min')then
       dt=dt*60.
  else if(unite_temps(1:3)=='sec')then
       dt=dt
  endif
endif
write(*,*)'pas de temps choisi (en jour)=',dt/86400 
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,dt_ecr,unite_temps
if(unite_temps(1:3)=='jou')then
       dt_ecr=dt_ecr*86400.
else if(unite_temps(1:3)=='heu')then
       dt_ecr=dt_ecr*3600.
else if(unite_temps(1:3)=='min')then
       dt_ecr=dt_ecr*60.
else if(unite_temps(1:3)=='sec')then
       dt_ecr=dt_ecr
endif
write(*,*)'pas de temps pour ecriture resultats (seconde)',dt_ecr

! nombre de fichiers d ecriture des resultats pour tous les scenarios  des instants donnes
!  en plus de l'instant initial t0+dt
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,necr_scenario
dt_ecr_scen=echel_temps/necr_scenario

#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalculmax

allocate(c_conta_tot0_sens(nscalculmax))
allocate(c_conta_air_sens(nscalculmax))
allocate(tempeC_sens(nscalculmax))
allocate(uc_sens(nscalculmax))
allocate(ventc_sens(nscalculmax))
allocate(sal_sens(nscalculmax))
allocate(zc_sens(nscalculmax))
allocate(fpart1_sens(nscalculmax))
allocate(cmestot_sens(nscalculmax))
!! variable pH en plus
   allocate(val_ph_sens(nscalculmax))

#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
! LECTURE DE LA CONCENTRATION TOTALE EN CONTAMINANT
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(8),ichvarsens(8)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(8)==0)then
   read(687,*)nambid,(c_conta_tot0_sens(i),i=1,nscalcul(8))
else
   read(687,*)nambid,valmin(8),pas_sens(8)
endif

! LECTURE DE LA CONCENTRATION DANS L'AIR DU CONTAMINANT 
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(7),ichvarsens(7)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(7)==0)then
   read(687,*)nambid,(c_conta_air_sens(i),i=1,nscalcul(7))
else
   read(687,*)nambid,valmin(7),pas_sens(7)
endif

! conversion des concentrations du contaminant en nM pour les calculs
! ======
!c_conta_tot0_sens(:)=c_conta_tot0_sens(:)*conversunit
!c_conta_air_sens(:)=c_conta_air_sens(:)*conversunit

! LECTURE DE LA TEMPERATURE
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(2),ichvarsens(2)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(2)==0)then
   read(687,*)nambid,(tempeC_sens(i),i=1,nscalcul(2))
else
   read(687,*)nambid,valmin(2),pas_sens(2)
endif

! LECTURE DU COURANT HORIZONTAL
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(4),ichvarsens(4)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(4)==0)then
   read(687,*)nambid,(uc_sens(i),i=1,nscalcul(4))
else
   read(687,*)nambid,valmin(4),pas_sens(4)
endif

! LECTURE DE LA PROFONDEUR MOYENNE
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(6),ichvarsens(6)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(6)==0)then
   read(687,*)nambid,(zc_sens(i),i=1,nscalcul(6))
else
   read(687,*)nambid,valmin(6),pas_sens(6)
endif

! LECTURE DE LA VITESSE DU VENT
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(5),ichvarsens(5)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(5)==0)then
   read(687,*)nambid,(ventc_sens(i),i=1,nscalcul(5))
else
   read(687,*)nambid,valmin(5),pas_sens(5)
endif

! LECTURE DE LA SALINITE
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(3),ichvarsens(3)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(3)==0)then
   read(687,*)nambid,(sal_sens(i),i=1,nscalcul(3))
else
   read(687,*)nambid,valmin(3),pas_sens(3)
endif
nb_varmilp1=10
! LECTURE DU pH
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(9),ichvarsens(9)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(9)==0)then
   read(687,*)nambid,(val_ph_sens(i),i=1,nscalcul(9))
else
   read(687,*)nambid,valmin(9),pas_sens(9)
endif
   
! LECTURE DU CATION METALLIQUE (mole/L) SI MOCO ET SI BESOIN
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
#ifdef key_moco
if(l_competcat .or. l_echgcat)then
   read(687,*)nambid,ccat
else
   read(687,*)
endif
#else
read(687,*)
#endif  
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif

! LECTURE DES TYPES DE PARTICULES
read(687,*)nambid
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid

! LECTURE DE LA CONCENTRATION TOTALE EN MES
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(1),ichvarsens(1)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(1)==0)then
   read(687,*)nambid,(cmestot_sens(i),i=1,nscalcul(1))
else
   read(687,*)nambid,valmin(1),pas_sens(1)
endif

! LECTURE DU NOMBRE DE TYPES, DES FRACTIONS ET DES VITESSES DE DEPOT
! UNE SEULE FRACTION VARIE 
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,npart
ALLOCATE(fpart(npart))
ALLOCATE(vdepo(npart))
ALLOCATE(cpart(npart))

#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,vdepo(:)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,fpart(:)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,ipart_sens
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nscalcul(nb_varmilp1),ichvarsens(nb_varmilp1)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
if(ichvarsens(nb_varmilp1)==0)then
    read(687,*)nambid,(fpart1_sens(i),i=1,nscalcul(nb_varmilp1))
else
    read(687,*)nambid,valmin(nb_varmilp1),pas_sens(nb_varmilp1)
endif
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid

! LECTURE DU NOMBRE DE LIGANDS DISSOUS
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nsubd
ALLOCATE(name_subd(nsubd))
#ifdef key_moco
ALLOCATE(ichar_sub(nsubd))
ALLOCATE(xfacth_subd(nsubd))
#endif
ALLOCATE(csubd_sens(nscalculmax,nsubd))

isub=0
do il=1,nsubd
  isub=isub+1
  is=nb_varmilp1+isub
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
#ifdef key_moco
  read(687,*)nambid,name_subd(isub),ichar_sub(isub),xfacth_subd(isub)
#else
  read(687,*)nambid,name_subd(isub)
#endif
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(687,*)nambid,nscalcul(is),ichvarsens(is)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  if(ichvarsens(is)==0)then
    read(687,*)nambid,(csubd_sens(i,isub),i=1,nscalcul(is))
  else
    read(687,*)nambid,valmin(is),pas_sens(is)
  endif
enddo
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)
read(687,*)

!!!!!!!!!  reperage des ligands dissous associs a chacune des especes dissoutes 
#ifdef key_moco
!!!!!!!!!!  reperage des ligands associs aux especes dissoutes de MOCO 
  allocate(isub_lig(nlig))
  allocate(icharl(nlig))
  allocate(xfacth_som(nesp_diss_moco))
  do i=1,nesp_diss_moco
    l_ok=.false.
    nambid=nom_lig_esp(i)
    if(nambid(1:3)=='Chl' .or. nambid(1:2)=='Cl')then
        write(*,*)'ligand dissous MOCO  ',TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))),' n ',i
        write(*,*)'donne par la salinite '
        l_ok=.true.
        isub_lig(ilig_esp(i))=-1
        icharl(ilig_esp(i))=1
        xfacth_som(i)=-xfacth_esp(i)
        ilisal=ilig_esp(i)     !   Reperage du rangement du ligand Salinite
    else if(nambid(1:2)=='OH')then
        write(*,*)'ligand dissous MOCO  ',TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))),' n ',i
        write(*,*)'donne par le pH '
        l_ok=.true.
        isub_lig(ilig_esp(i))=-10
        icharl(ilig_esp(i))=1
        xfacth_som(i)=xfactl(i)-xfacth_esp(i)
        iliph=ilig_esp(i)       !   Reperage du rangement du ligand pH
    else
      do iss=1,nsubd
        if(TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))).eq.TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))))then
          isub_lig(ilig_esp(i))=iss
          write(*,*)'ligand dissous MOCO  ',TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(i)))),' n ',i
          write(*,*)'donne par le substrat ',TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))),' n ',iss 
          l_ok=.true.
          icharl(ilig_esp(i))=ichar_sub(iss)
          xfacth_som(i)=xfactl(i)*xfacth_subd(iss)-xfacth_esp(i)
          pos=index(nambid,'hiol_diss')
          if(pos/=0)ilithiold=ilig_esp(i)      ! Reperage du rangement du ligand Thiols dissous (RS-))
          pos=index(nambid,'hiol_part')
          if(pos/=0)ilithiolp=ilig_esp(i)      ! Reperage du rangement du ligand Thiols particulaire considere comme dissous (RSH))
          pos=index(nambid,'CO3')
          if(pos/=0)ilico3=ilig_esp(i)          ! Reperage du rangement du ligand CO3 (carbonate)
          pos=index(nambid,'ulfur')
          if(pos/=0)ilisulf=ilig_esp(i)          ! Reperage du rangement du ligand HS- (sulfur) 
          pos=index(nambid,'Lcarb')
          if(pos/=0)ilimodcarb=ilig_esp(i)       ! Reperage du rangement du ligand Lcarb (MOD carboxylique) 
          pos=index(nambid,'Lphen')
          if(pos/=0)ilimodphen=ilig_esp(i)       ! Reperage du rangement du ligand Lphen (MOD phenolique) 
          exit
        endif
      enddo 
    endif
    if(.not.l_ok)then
      write(*,*)'pas de substrat dissous defini correspondant au ligand ',nom_lig_esp(i),' n ',i
      write(*,*)'revoir le fichier de donnees des variables du milieu'
      stop
    endif
  enddo
#else
do i=1,nesp_diss
  l_ok=.false.
  do iss=1,nsubd
    if(TRIM(ADJUSTL(ADJUSTR(name_sub_esp(i)))).eq.TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))))then
        isub_esp(i)=iss
        write(*,*)'espece  ',TRIM(ADJUSTL(ADJUSTR(name_esp(i)))),' n ',i,   &
                 ' / associ au substrat ',TRIM(ADJUSTL(ADJUSTR(name_subd(iss)))),  &
                 ' n ',iss 
         l_ok=.true.        
    endif
  enddo 
  if(.not.l_ok)then
    write(*,*)'pas de substrat dissous defini correspondant a l espece',name_esp(i),' n ',i
    write(*,*)'revoir le fichier de donnees des variables du milieu'
    stop
  endif
enddo
#endif

! LECTURE DU NOMBRE DE LIGANDS PARTICULAIRES (SITES)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,nsubp
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
nsub=nsubd+nsubp

ALLOCATE(ipart_sub(nsub))
ALLOCATE(fpart_sub(nsub))
ALLOCATE(fmest_sub(nsub))
ALLOCATE(name_sub(nsub))
ALLOCATE(foc_sens(nscalculmax,nsub))
ALLOCATE(csub_sens(nscalculmax,nsub))
name_sub(1:nsubd)=name_subd(:)
csub_sens(:,1:nsubd)=csubd_sens(:,:)
deallocate(name_subd)
deallocate(csubd_sens)

do isb=1,nsubp
  isub=isub+1
  is=nb_varmilp1+isub
  read(687,*)nambid,name_sub(isub)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(687,*)nambid,ipart_sub(isub)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  read(687,*)nambid,nscalcul(is),ichvarsens(is)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
  if(ichvarsens(is)==0)then
     read(687,*)nambid,(foc_sens(i,isub),i=1,nscalcul(is))
  else
     read(687,*)nambid,valmin(is),pas_sens(is)
  endif
enddo
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
        
#ifdef key_moco
!!!!!!!!!  reperage des substrats associs aux phases particulaires  de MOCO 
  ALLOCATE(isub_phase(nphasp))
  do i=1,nphasp
    l_ok=.false.
    do iss=1,nsubp
      isub=nsubd+iss
      if(nom_phase(i).eq.name_sub(isub))then
        isub_phase(i)=isub
        write(*,*)'phase particulaire MOCO  ',TRIM(ADJUSTL(ADJUSTR(nom_phase(i)))),' n ',i,  &
              ' / donne par le substrat ',TRIM(ADJUSTL(ADJUSTR(name_sub(isub)))),' n ',isub 
         l_ok=.true.
      endif
      if(l_moco_op)then
! une seule phase "operationnelle' particule globale=MES
        isub_phase(1)=0
         l_ok=.true.
      endif
    enddo 
    if(.not.l_ok)then
      write(*,*)'pas de substrat particulaire defini'
      write(*,*)' correspondant a la phase de complexation',nom_phase(i),' n ',i
      write(*,*)'revoir le fichier de donnees des variables du milieu'
      stop
    endif
  enddo
  if(l_echgcat .or.l_competcat)then
     l_ok=.false.
     do is=1,nsubp
        isub=nsubd+is
        if(name_sub(isub).eq.name_sub_echcompcat)then
            isub_echcompcat=isub
            write(*,*)'phase echangeur de cation MOCO  ',  &
            TRIM(ADJUSTL(ADJUSTR(name_sub_echcompcat))), &
              ' / donne par le substrat ', &
              TRIM(ADJUSTL(ADJUSTR(name_sub(isub)))),' n ',isub 
             l_ok=.true.
        endif
     enddo 
     if(.not.l_ok)then
          write(*,*)'pas de substrat particulaire defini '
          write(*,*)'correspondant a la phase echangeur de cation',name_sub_echcompcat
          write(*,*)'revoir le fichier de donnees des variables du milieu'
          stop
     endif
  endif
!  if(l_thiolpart)then
!     l_ok=.false.
!     do is=1,nsubp
!       isub=nsubd+is
!       if(name_sub(isub).eq.name_sub_thiol)then
!              isub_thiolpart=isub
!              write(*,*)'phase avec site THIOL particulaire  ',  &
!                        TRIM(ADJUSTL(ADJUSTR(name_sub_thiol))), &
!              ' / donne par le substrat ',TRIM(ADJUSTL(ADJUSTR(name_sub(isub)))),' n ',isub 
!              l_ok=.true.
!       endif
!     enddo 
!     if(.not.l_ok)then
!            write(*,*)'pas de substrat particulaire defini '
!            write(*,*)'correspondant a la phase avec site thiol particulaire',name_sub_thiol
!            write(*,*)'revoir le fichier de donnees des variables du milieu'
!            stop
!     endif
!   endif
#endif
!!!!!!!!  reperage des substrats associs a chacune des especes 
    do i=nesp_diss+1,nespt
       l_ok=.false.
       do iss=1,nsubp
         isub=nsubd+iss
         if(name_sub_esp(i).eq.name_sub(isub))then
           isub_esp(i)=isub
           write(*,*)'espece  ',TRIM(ADJUSTL(ADJUSTR(name_esp(i)))),' n ',i, &
              ' associ au substrat ',TRIM(ADJUSTL(ADJUSTR(name_sub(isub)))), ' n ',isub 
           l_ok=.true.
          else if(i>nesp_diss+nesp_part_eq+nesp_part_ci   &
             .and.i<nesp_diss+nesp_part_eq+nesp_part_ci+nesp_part_ne+1)then
           l_ok=.true.
         endif
       enddo 
       if(.not.l_ok)then
          write(*,*)'pas de substrat particulaire defini correspondant  l espece ',name_esp(i),' n ',i
          write(*,*)'revoir le fichier de donnees des variables du milieu'
         stop
        endif
    enddo
    

! 3 substrats max qui peuvent varier en meme temps
nsubvar=0
isubvar(:)=0
do isub=1,nsub
  is=nb_varmilp1+isub
  if(nscalcul(is)>1)then
    nsubvar=nsubvar+1
    if(nsubvar.gt.3)then
          write(*,*)'pour l etude de sensibilite,'
          write(*,*)' pas plus de 3 substrats (dissous+particulaire) '
          write(*,*)' pouvant varier en meme temps '
          stop
    endif
    isubvar(nsubvar)=isub
  endif
enddo

!  DONNEES SUR LES FLUX
ALLOCATE(c_sub_in(nsubd))
ALLOCATE(fpart_in(npart))
ALLOCATE(flux_part_in(npart))
ALLOCATE(flux_sub_in(nsub))
read(687,*)
read(687,*)
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,vol_eau        
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,surf_eau        
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,flux_eau_inout

! les valeurs de MESt et de concentrations en substrats seront egaux aux valeurs initiales testes

!!!!!! conversion de /an a /seconde 
flux_eau_inout=flux_eau_inout/86400._RLG/365._RLG     
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
read(687,*)nambid,conta_tot_in
conta_tot_in=conta_tot_in**conversunit              
ff=0.
if(nesp_part_ne>0)then
   ALLOCATE(f_espNE_in(nesp_part_ne))
   ALLOCATE(flux_espne_in(nesp_part_ne))
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(687,*)nambid,(f_espNE_in(ine),ine=1,nesp_part_ne)
   do ine=1,nesp_part_ne        
      flux_espne_in(ine)=flux_eau_inout*conta_tot_in*f_espNE_in(ine)
      ff=ff+f_espNE_in(ine)
   enddo   
else
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(687,*)
endif        
if(nesp_part_ci>0)then
   ALLOCATE(f_espci_in(nesp_part_ci))
   ALLOCATE(flux_espci_in(nesp_part_ci))
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(687,*)nambid,(f_espci_in(ine),ine=1,nesp_part_ci)
   do ici=1,nesp_part_ci        
          flux_espci_in(ici)=flux_eau_inout*conta_tot_in*f_espci_in(ici) 
          ff=ff+f_espci_in(ici)
   enddo 
else
#ifdef MODTEST
   write(*,*)'lecture milieu  :',TRIM(ADJUSTL(ADJUSTR(nambid)))
#endif
   read(687,*)
endif        
flux_espech_in=flux_eau_inout*conta_tot_in*(1-ff) 
          
! si plusieurs calculs calcul des valeurs pour chaque scenario
!  ------------------------------------------------------------------------
!
! nombre total de calculs
ical=0
ncalcul=nscalcul(1)*nscalcul(2)*nscalcul(3)*nscalcul(4)*nscalcul(5)*nscalcul(6)*nscalcul(7)  &
        *nscalcul(8)*nscalcul(9)
ncalcul=ncalcul*nscalcul(nb_varmilp1)
if(nsub.ge.1)ncalcul=ncalcul*nscalcul(nb_varmilp1+1)
if(nsub.ge.2)ncalcul=ncalcul*nscalcul(nb_varmilp1+2)
if(nsub.ge.3)ncalcul=ncalcul*nscalcul(nb_varmilp1+3)
ALLOCATE(var_milieu(9,ncalcul))
ALLOCATE(c_conta_tot_init(ncalcul))
ALLOCATE(fpart_v(npart,ncalcul))
ALLOCATE(cpart_v(npart,ncalcul))
ALLOCATE(csub_v(nsub,ncalcul))
ALLOCATE(cesp(nvar,ncalcul))
ALLOCATE(pcent_cesp(nvar,ncalcul))
!! initialisation
!!================
   cesp(:,:)=0.
   
nscalcul(0)=1
! variables du milieu
DO is1=1,nscalcul(1)
  if(ichvarsens(1)==1)then
    cmestot_sens(is1)=valmin(1)+(is1-1)*pas_sens(1)
  else if(ichvarsens(1)==2)then
    cmestot_sens(is1)=valmin(1)*pas_sens(1)**(is1-1)
  endif
  DO is2=1,nscalcul(2)
    if(ichvarsens(2)==1)then
       tempeC_sens(is2)=valmin(2)+(is2-1)*pas_sens(2)
     else if(ichvarsens(2)==2)then
       tempeC_sens(is2)=valmin(2)*pas_sens(2)**(is2-1)
     endif
     DO is3=1,nscalcul(3)
       if(ichvarsens(3)==1)then
         sal_sens(is3)=valmin(3)+(is3-1)*pas_sens(3)
       else if(ichvarsens(3)==2)then
         sal_sens(is3)=valmin(3)*pas_sens(3)**(is3-1)
       endif
     DO is4=1,nscalcul(4)
       if(ichvarsens(4)==1)then
         uc_sens(is4)=valmin(4)+(is4-1)*pas_sens(4)
       else if(ichvarsens(4)==2)then
         uc_sens(is4)=valmin(4)*pas_sens(4)**(is4-1)
       endif
       DO is5=1,nscalcul(5)
         if(ichvarsens(5)==1)then
           ventc_sens(is5)=valmin(5)+(is5-1)*pas_sens(5)
         else if(ichvarsens(5)==2)then
           ventc_sens(is5)=valmin(5)*pas_sens(5)**(is5-1)
         endif
         DO is6=1,nscalcul(6)
           if(ichvarsens(6)==1)then
             zc_sens(is6)=valmin(6)+(is6-1)*pas_sens(6)
           else if(ichvarsens(6)==2)then
             zc_sens(is6)=valmin(6)*pas_sens(6)**(is6-1)
           endif
           DO is7=1,nscalcul(7)
             if(ichvarsens(7)==1)then
               c_conta_air_sens(is7)=valmin(7)+(is7-1)*pas_sens(7)
             else if(ichvarsens(7)==2)then
               c_conta_air_sens(is7)=valmin(7)*pas_sens(7)**(is7-1)
             endif
             DO is8=1,nscalcul(8)
               if(ichvarsens(8)==1)then
                 c_conta_tot0_sens(is8)=valmin(8)+(is8-1)*pas_sens(8)
               else if(ichvarsens(8)==2)then
                 c_conta_tot0_sens(is8)=valmin(8)*pas_sens(8)**(is8-1)
               endif
              DO is9=1,nscalcul(9)
               if(ichvarsens(9)==1)then
                 val_ph_sens(is9)=valmin(9)+(is9-1)*pas_sens(9)
               else if(ichvarsens(9)==2)then
                 val_ph_sens(is9)=valmin(9)*pas_sens(9)**(is9-1)
               endif
               DO isp=1,nscalcul(nb_varmilp1)
                 if(ichvarsens(nb_varmilp1)==1)then
                   fpart1_sens(isp)=valmin(nb_varmilp1)+(isp-1)*pas_sens(nb_varmilp1)
                 else if(ichvarsens(nb_varmilp1)==2)then
                   fpart1_sens(isp)=valmin(nb_varmilp1)*pas_sens(nb_varmilp1)**(isp-1) 
                 endif
                 iss1=isubvar(1)
                 if(iss1==0)iss1=-10
                 DO isu1=1,nscalcul(nb_varmilp1+iss1)
                   if(iss1.ne.-10)then
                     if(iss1.le.nsubd)then
                       if(ichvarsens(nb_varmilp1+iss1)==1)then
                         csub_sens(isu1,iss1)=valmin(nb_varmilp1+iss1)+(isu1-1)*pas_sens(nb_varmilp1+iss1)
                       else if(ichvarsens(nb_varmilp1+iss1)==2)then
                         csub_sens(isu1,iss1)=valmin(nb_varmilp1+iss1)*pas_sens(nb_varmilp1+iss1)**(isu1-1)
                       endif
                     else
                       if(ichvarsens(nb_varmilp1+iss1)==1)then
                         foc_sens(isu1,iss1)=valmin(nb_varmilp1+iss1)+(isu1-1)*pas_sens(nb_varmilp1+iss1)
                       else if(ichvarsens(nb_varmilp1+iss1)==2)then
                         foc_sens(isu1,iss1)=valmin(nb_varmilp1+iss1)*pas_sens(nb_varmilp1+iss1)**(isu1-1)
                       endif
                     endif
                   endif
                   if(nsubvar.gt.1)then
                     iss2=isubvar(2)
                   else
                     iss2=-10
                   endif
                   DO isu2=1,nscalcul(nb_varmilp1+iss2)
                       if(iss2.ne.-10)then
                         if(iss2.le.nsubd)then
                         if(ichvarsens(nb_varmilp1+iss2)==1)then
                           csub_sens(isu2,iss2)=valmin(nb_varmilp1+iss2)+(isu2-1)*pas_sens(nb_varmilp1+iss2)
                         else if(ichvarsens(nb_varmilp1+iss2)==2)then
                           csub_sens(isu2,iss2)=valmin(nb_varmilp1+iss2)*pas_sens(nb_varmilp1+iss2)**(isu2-1)
                         endif
                       else
                         if(ichvarsens(nb_varmilp1+iss2)==1)then
                           foc_sens(isu2,iss2)=valmin(nb_varmilp1+iss2)+(isu2-1)*pas_sens(nb_varmilp1+iss2)
                         else if(ichvarsens(nb_varmilp1+iss2)==2)then
                           foc_sens(isu2,iss2)=valmin(nb_varmilp1+iss2)*pas_sens(nb_varmilp1+iss2)**(isu2-1)
                         endif
                       endif
                     endif
                     if(nsubvar.gt.2)then
                         iss3=isubvar(3)
                     else
                         iss3=-10
                     endif
                     DO isu3=1,nscalcul(nb_varmilp1+iss3)
                       if(iss3.ne.-10)then
                           if(iss3.le.nsubd)then
                             if(ichvarsens(nb_varmilp1+iss3)==1)then
                                 csub_sens(isu3,iss3)=valmin(nb_varmilp1+iss3)+(isu3-1)*pas_sens(nb_varmilp1+iss3)
                             else if(ichvarsens(nb_varmilp1+iss3)==2)then
                                 csub_sens(isu3,iss3)=valmin(nb_varmilp1+iss3)*pas_sens(nb_varmilp1+iss3)**(isu3-1)
                             endif
                           else
                             if(ichvarsens(nb_varmilp1+iss3)==1)then
                                 foc_sens(isu3,iss3)=valmin(nb_varmilp1+iss3)+(isu3-1)*pas_sens(nb_varmilp1+iss3)
                             else if(ichvarsens(nb_varmilp1+iss3)==2)then
                                 foc_sens(isu3,iss3)=valmin(nb_varmilp1+iss3)*pas_sens(nb_varmilp1+iss3)**(isu3-1)
                             endif
                           endif
                        endif
! mise en memoire des valeurs pour chaque scenario                          
                        ical=ical+1
                        var_milieu(1,ical)=cmestot_sens(is1)
                        var_milieu(2,ical)=tempeC_sens(is2)
                        var_milieu(3,ical)=sal_sens(is3)
                        var_milieu(4,ical)=uc_sens(is4)
                        var_milieu(5,ical)=ventc_sens(is5)
                        var_milieu(6,ical)=zc_sens(is6)
                        var_milieu(7,ical)=c_conta_air_sens(is7)*conversunit
                        var_milieu(8,ical)=c_conta_tot0_sens(is8)*conversunit
                        c_conta_tot_init(ical)=var_milieu(8,ical)
                        var_milieu(9,ical)=val_ph_sens(is9)
                        if(npart==1)then
                           fpart_v(1,ical)=1.
                        else if(npart==2)then
                           fpart_v(ipart_sens,ical)=fpart1_sens(isp)
                           if(ipart_sens==1)then 
                             fpart_v(2,ical)=1.-fpart1_sens(isp)
                           else
                             fpart_v(1,ical)=1.-fpart1_sens(isp)
                           endif 
                        else if(npart==3)then
                          if(ipart_sens==2)then
                              fpart_v(1,ical)=fpart(1)
                              fpart_v(ipart_sens,ical)=fpart1_sens(isp)*(1-fpart(1))
                              ff=fpart_v(ipart_sens,ical)+fpart_v(1,ical)
                              fpart_v(3,ical)=max(1-ff,0.)
                          else if(ipart_sens==1)then     
                              fpart_v(3,ical)=fpart(3)
                              fpart_v(ipart_sens,ical)=fpart1_sens(isp)*(1-fpart(3))
                              ff=fpart_v(ipart_sens,ical)+fpart_v(3,ical)
                              fpart_v(2,ical)=max(1-ff,0.)
                          else if(ipart_sens==3)then     
                              fpart_v(2,ical)=fpart(2)
                              fpart_v(ipart_sens,ical)=fpart1_sens(isp)*(1-fpart(2))
                              ff=fpart_v(ipart_sens,ical)+fpart_v(2,ical)
                              fpart_v(1,ical)=max(1-ff,0.)
                          endif
                        endif
                        cpart_v(:,ical)=fpart_v(:,ical)*var_milieu(1,ical)
                        do isub=1,nsubd
                           if(isubvar(1)==isub)then
                              csub_v(isub,ical)=csub_sens(isu1,isub)
                           else if (isubvar(2)==isub)then
                              csub_v(isub,ical)=csub_sens(isu2,isub)
                           else if (isubvar(3)==isub)then
                              csub_v(isub,ical)=csub_sens(isu3,isub)
                           else
                              csub_v(isub,ical)=csub_sens(1,isub)
                           endif
                         enddo
                         do isub=nsubd+1,nsub
                           if(isubvar(1)==isub)then
                              csub_v(isub,ical)=foc_sens(isu1,isub)*cpart_v(ipart_sub(isub),ical)
                           else if (isubvar(2)==isub)then
                              csub_v(isub,ical)=foc_sens(isu2,isub)*cpart_v(ipart_sub(isub),ical)
                           else if (isubvar(3)==isub)then
                              csub_v(isub,ical)=foc_sens(isu3,isub)*cpart_v(ipart_sub(isub),ical)
                           else
                              csub_v(isub,ical)=foc_sens(1,isub)*cpart_v(ipart_sub(isub),ical)
                           endif
                         enddo

! Especes particulaires non echangeable ou pas  l'quilibre
                         cesp(nesp_diss+nesp_part_eq+1:nespt,ical)=finit(nesp_diss+nesp_part_eq+1:nespt)*var_milieu(8,ical)
! Flux entrant
                         flux_MESt_in=flux_eau_inout*cMESt_in
                         flux_part_in(:)=flux_eau_inout*fpart_v(:,ical)*var_milieu(1,ical) 
                         flux_sub_in(1:nsub)= flux_eau_inout*csub_v(1:nsub,ical)
                        ENDDO
                      ENDDO
                    ENDDO
                  ENDDO
                ENDDO
               ENDDO
             ENDDO
           ENDDO
         ENDDO
       ENDDO
    ENDDO
  ENDDO   
ENDDO   
close(687)
ncalculc=ical
if(ncalculc.ne.ncalcul)then
        write(*,*)'pas le meme nombre de scenario ??'
        write(*,*)'ncalcul=',ncalcul
        write(*,*)'ncalculc=',ncalculc
        stop
   endif
WRITE(*,*)'NOMBRE TOTAL DE SCENARIOS = ',ncalcul

close(687)
  
   END SUBROUTINE lect_varmilieusens
!****************************************************************************
 END MODULE
