 MODULE resultat

   !!======================================================================
   !!                   ***  MODULE  RESULTATs  ***
   !!======================================================================
   !! * Modules used
USE parametres
USE com_morgan
USE com_varmilieu
#ifdef key_moco
USE com_moco
#endif

IMPLICIT NONE
PRIVATE

   !! * Accessibility
PUBLIC init_ficres     ! routine called by moco_morgan.F90
PUBLIC ecri_result_scen   ! routine called by moco_morgan.F90
PUBLIC ecri_result_temps   ! routine called by moco_morgan.F90

   !! * Shared module variables
real(kind=rlg),dimension(:,:),allocatable   :: cesp_converti
real(kind=rlg),dimension(:,:),allocatable   :: var_milieu_converti
real(kind=rlg),dimension(:),allocatable     :: c_conta_tot_converti

   !! * Private variables

 CONTAINS

!!======================================================================
!
                SUBROUTINE init_ficres(npas)
!&E---------------------------------------------------------------------
!         ouverture et ecriture des premiers commentaires       
!              dans le fichier des resultats (format ASCII)
!!!!                 separateur=','
!&E---------------------------------------------------------------------
   !! * Modules used
   
   !! Arguments
integer,intent(in)                          :: npas

   !! * Local declarations
! ****************************************************************************
character(len=lchain)              ::  nomspp,name_ficres2
character(len=lchain)              ::  name_ficres,name,name_ficres1
character(len=lchain),dimension(5) ::  nomspv
character(len=3000)                ::  nomsaecrir
character(len=lchain)              ::  namelu
character(len=4)                   ::  nomfic
integer                            ::  ire,ific,nfic,ifi,i,ip,is,iesp,ii,ilig,pos1,pos2
integer                            ::  inl,ivfl,ivkl,ivql,iveq,nn,iv,ic,iespmoc
integer                            ::  lnam,lnom,lnomsub,lnome,lnome1,js,isit
integer                            ::  ncol_60,ncol_61
integer,dimension(:),allocatable   ::  ifich1,ifich2
      
write(*,*)' ******************************************'
write(*,*)'nom du fichier resultat =',name_file_res
write(*,*)' ******************************************'
name_ficres=TRIM(ADJUSTL(ADJUSTR(name_file_res)))
lnam=index(name_ficres,'  ')-1

! fichier compte rendu
name_ficres1='resultat/'//name_ficres(1:lnam)//'_com'
open(60,file=name_ficres1)

ific=60
  write(ific,*)name_conta
  write(ific,*)'nombre d especes dissoutes ;',nesp_diss
  write(ific,*)'nombre de particules ;',npart
  write(ific,*)'nbre especes part. EQU  ;',nesp_part_eq
  if(l_dom_nl)write(ific,*)'prise en compte de domaine non linaires ' 
    write(ific,*)'nbre especes part. cinetic ;',nesp_part_ci
    write(ific,*)'nbre especes part. Non Echangeable ;',nesp_part_ne
    do ip=1,npart
      write(ific,*)' type de MES: fraction/total;',fpart(ip),';vitesse de depot :;',vdepo(ip)
    enddo
    do is=1,nsub
      write(ific,*)'nom du substrat:;',TRIM(ADJUSTL(ADJUSTR(name_sub(is)))),  &
                    ';associe au type de MES n;',ipart_sub(is)
    enddo
    write(ific,*)'nombre de tests ;',ncalcul
    write(ific,*)'nombre de pas de temps ;',npas
! ecriture des informations sur les flux entrant et sortant
    write(ific,*)'Donnees FLUX'
    write(ific,*)'volume d eau (m3) ; ',vol_eau
    write(ific,*)'surface (m2) ; ',surf_eau
    write(ific,*)'flux d eau entrant-sortant;',flux_eau_inout
    if(.not.l_mode1c)then
      write(ific,*)'conc. substrats dissous entrant;'
      do i=1,nsubd
        write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_sub(i)))),';',c_sub_in(i)
      enddo 
      write(ific,*)'MES dans eau entrant;',cMESt_in
      write(ific,*)'type particule;fraction in; flux in'
      do i=1,npart
        write(ific,*)i,';',fpart_in(i),';',flux_part_in(i)
      enddo
    endif 
    write(ific,*)'conc totale cont. dans eau entrant;',conta_tot_in
    do i=1,nesp_part_ne
        write(ific,*)'Flux de NON echangeable ;',i,';',flux_espne_in(i)
    enddo               
    do i=1,nesp_part_ci
        write(ific,*)'Flux espece sorb. cinetic ;',i,';',flux_espci_in(i)
    enddo                             
    nomsaecrir=''
    lnome=1
    iesp=1
       
!   sensibilite aux conditions du milieu
!   ************************************
    if(l_mode1c)then
      write(ific,*)
      write(ific,*)'SENSIBILITE AUX CONDITIONS DU MILIEU'
      write(ific,*)'poids moleculaire : ;',pdmolec
      write(ific,*)'Nbre de Schmidt : ;',xnb_schmidt
      write(ific,*)'Cte de Henry : ;',henry
      write(ific,*)'Cte de Henry adimens : ;',henry_adim
      write(ific,*)'Diffusivite dans air : ;',diffusivite
      write(ific,*)'Coef Staudinger : ;',coefH_staudinger
      write(ific,*)'Cte salting out : ;',cte_salt
      write(ific,*)
      if(nesp_diss_ne>0)then
        write(ific,*)'especes dissoutes "libre" en plus'
        do iesp=1,nesp_diss_ne
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp))))
        enddo
      else
        write(ific,*)'pas d especes dissoutes "libre" en plus'
      endif  
      write(ific,*)
      write(ific,*)'especes dissoutes a l equilibre'
      write(ific,*)'nom espece;substrat associe;coef partage;'
      do iesp=nesp_diss_ne+1,nesp_diss
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp)))),';',xpart_esp(iesp)
      enddo  
      write(ific,*)
      write(ific,*)'especes particulaires a l equilibre '
      write(ific,*)'nom espece;substrat associe;coef partage;'
      do iesp=nesp_diss+1,nesp_diss+nesp_part_eq
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
               TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp)))),';',xpart_esp(iesp)
      enddo  
      if(.not.l_dom_nl)then
        write(ific,*)'PAS de domaine NON LINEAIRE '          
      else
        write(ific,*)'domaines NON LINEAIRES a l equilibre '
        write(ific,*)'nom espece;modele;fraction;KL ou KF;','Qmax ou facteur d affinite'
        do iesp=nesp_diss+1,nesp_diss+nesp_part_eq
          if(l_langmuir)then
            write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),  &
                ';DMM Langmuir;',f_dom_nl(iesp,1),   &
                ';',xpartnl(iesp,1),';',xsorptnl(iesp,1)
          else
            do inl=1,n_dom_nl(iesp)
              write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),  &
                   ';DRM Freundlich;',f_dom_nl(iesp,inl),&
                           ';',xpartnl(iesp,inl),';',xsorptnl(iesp,inl)
            enddo
          endif
        enddo  
      endif
      write(ific,*)
      ii= nesp_diss+nesp_part_eq
      if(nesp_part_ci.eq.0)then
        write(ific,*)'PAS d espece avec sorption traitee en cinetique '          
      else
        write(ific,*)'domaines de sorption LINEAIRES traites en cinetique'
        write(ific,*)'nom espece;espece EQ associee;fraction initiale'
      endif
      do iesp=ii+1,ii+nesp_part_ci
        write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
             TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),';',finit(iesp)
      enddo  
      write(ific,*)'Cte de vitesse;conc. a l equilibre '
      do iesp=ii+1,ii+nesp_part_ci
        write(ific,*)cte_vit(iesp-ii),';',ceq_ci(iesp-ii)
      enddo  
      ii= nesp_diss+nesp_part_eq+nesp_part_ci
      write(ific,*)
      if(nesp_part_ne.eq.0)then
        write(ific,*)'PAS de fractions part. non echangeable '          
      else
        write(ific,*)'fractions part. NON ECHANGEABLE'
        write(ific,*)'nom espece;type part associe;fraction initiale'
      endif
      do iesp=ii+1,ii+nesp_part_ne
        write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                     ityp_part(iesp),';',finit(iesp)
      enddo  

! ecriture des reactions
      write(ific,*)
      if(nb_reac.eq.0)then
        write(ific,*)'PAS de reactions en plus de la sorption'
      else
        write(ific,*)'REACTIONS (en plus de la soprtion)'
      endif
      do ire=1,nb_reac
        write(ific,*)name_reac(ire)
        if(nb_var_re(ire).gt.1)then
          write(ific,*)'entre;',TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,1)))),  &
               '; et ;',TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,2))))
        else
          write(ific,*)'affecte;',TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,1))))
        endif             
        write(ific,*)'cinetic max ;',cin_max_re(ire)
      enddo
#ifdef key_moco
!!!!!!!  ecriture des donnees pour MOCO
        write(ific,*)
        write(ific,*)'calcul avec MOCO'
        write(ific,*)'nombre d especes dissoutes prises en compte ;',nesp_diss_moco
        if(.not.l_moco_op) then
          write(ific,*)'nombre de phases prises en compte     ;',nphasp
        endif
        write(ific,*)
        write(ific,*)'espece dissoute formee avec le ligand :;Ke;charge;nL;nHl'
        do iespmoc=1,nesp_diss_moco
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(iespmoc)))),&
          ';',xequ(iespmoc),'; ',ichare(iespmoc),';',xfactl(iespmoc),&
          ';',xfacth_esp(iespmoc)
        enddo
        write(ific,*)
        write(ific,*)'pour chaque phase:;nombre de type de site;',&
                     'surface specifique   ;'
        do js=1,nphasp
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),';',nsit(js),&
                        ';',ssp(js)
        enddo
        write(ific,*)'phase;n site;type de site;csit (mole/m2);',&
                          'Cte equilibre Ka1;dcharg1;Ka2;dcharg2;Km(Si-M);dcharm'
        do js=1,nphasp
          do isit=1,nsit(js) 
            if(ityp_sit(isit,js)==1)then
              write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),';',isit,';',&
                  ityp_sit(isit,js),';',sitac(isit,js),';',xequa1(isit,js),';',&
                   idchars(isit,js,1),';',xequa2(isit,js),';',&
                   idchars(isit,js,2),';',xequms(isit,js),';', idcharm(isit,js)
            else if(ityp_sit(isit,js)==2)then
              write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),';',isit,';',&
                   ityp_sit(isit,js),';', sitac(isit,js),';',zero,';',&
                   zero,';',xequa2(isit,js),';',idchars(isit,js,2),';',&
                   xequms(isit,js),';',idcharm(isit,js)
            endif
          enddo
        enddo
        
      write(ific,*)            
      if(l_echgcat)then
            write(ific,*)'Echange avec cations pris en compte'
            write(ific,*)'nom du cation ;',nom_cat
            write(ific,*)'charge du cation ;',icharcat
            write(ific,*)'Cte equilibre  Kcat ;',xequcat
            write(ific,*)'Cte equilibre  Kmc ;',xequmet
            write(ific,*)'concentration du cation ;',ccat
      else
          write(ific,*)'pas d echange avec cations  '
      endif
      write(ific,*)            
      if(l_competcat)then
         write(ific,*)'competition avec cations pris en compte'
         write(ific,*)'nom du cation ;',nom_cat
         write(ific,*)'charge du cation ;',icharcat
         write(ific,*)'concentration du cation; ',ccat
         write(ific,*)'phase;nsite;vari. charge;Cte equilibre Kcom Si-M;'
         js=isub_echcompcat
         do isit=1,nsit(js) 
           write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),';',&
                          isit,';',idcharc(isit,js),';',xequcs(isit,js)
         enddo
      else
          write(ific,*)'pas de competition avec cations  '
      endif
!      if(l_thiolpart)then
!         write(ific,*)'complexation avec sites thiols particulaire'
!         write(ific,*)'concentration total thiol particulaire (mole/g)=',cthiolpart
!         write(ific,*)'substrat correspondant',name_sub_thiol
!         write(ific,*)'constante d equilibre Kahp',xkathiolp
!         write(ific,*)'constante de complexation monodentate',xequRSHg
!         write(ific,*)'constante de complexation bidentate',xequR2SHg
!      endif
#endif
       write(ific,*)
       if(l_volat)then
         write(ific,*)'l espece ',TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_volat)))), &
                       ' se volatilise'
       else
         write(*,*)'pas de volatilisation'
       endif

!  ecriture de toutes les variables du milieu pour chaque scenario
      nomsaecrir='temps(jour);MES;Temperature;salinite;courant;vent;profondeur;Cont_air;Cont_eau_initial;pH'
      lnom=89
      do iv=1,nsub
         nomsaecrir=nomsaecrir(1:lnom)//';'//name_sub(iv)
         lnomsub=index(name_sub(iv),'  ')-1
         lnom=lnom+lnomsub+1
      enddo
        
! ecriture d un commentaire pour les unites
      write(ific,*)
      write(ific,*)'LES UNITES POUR LES ESPECES ET LES CONCENTRATIONS EN CONTAMINANT'
      write(ific,*)'SONT CELLES ;CHOISIES PAR ;L UTILISATEUR :;',unite_conta,';/m3'
#ifdef key_moco
      write(ific,*)'LES CONCENTRATIONS ;DES LIGANDS ;DISSOUS ;SONT ; EN mole/L '
      write(ific,*)'LES FLUX (pour MOCO) SONT EXPRIMES EN nmole/L (cumules au cours du temps)' 
#endif
      
    else
!   sensibilite au contaminant
!   ***************************
      write(ific,*)
      write(ific,*)' SENSIBILITE AU CONTAMINANT'
      allocate(cparamv(10,ncalcul))
      do i=1,nsub
        write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_sub(i)))),';',csub(i)           
      enddo
      write(ific,*)'MES : ;',c_MESt
      write(ific,*)'Temperature : ;',temperaC
      write(ific,*)'Salinite : ;',salinite
      write(ific,*)'Courant : ;',uc
      write(ific,*)'vent : ;',ventc
      write(ific,*)'Profondeur : ;',zc
      write(ific,*)'Conc. dans air : ;',c_conta_air
      write(ific,*)'Conc. dans eau : ;',c_conta_tot0
      nparv=0
! reperage des parametres qui varient
      if(pdmolecv(1).ne.pdmolecv(ncalcul))then
        write(ific,*)'poids moleculaire : ;variable'
        nparv=nparv+1
        nomspv(nparv)='poids_moleculaire;'
        cparamv(nparv,1:ncalcul)=pdmolecv(1:ncalcul)
      else
        write(ific,*)'poids moleculaire : ;',pdmolecv(1)
      endif
      if(xnb_schmidtv(1).ne.xnb_schmidtv(ncalcul))then
        write(ific,*)'Nbre de Schmidt : ;variable'
        nparv=nparv+1
        nomspv(nparv)='Nbre_Schmidt;'
        cparamv(nparv,1:ncalcul)=xnb_schmidtv(1:ncalcul)
      else
        write(ific,*)'Nbre de Schmidt : ;',xnb_schmidtv(1)
      endif
      if(henryv(1).ne.henryv(ncalcul))then
        write(ific,*)'Cte de Henry : ;variable'
        nparv=nparv+1
        nomspv(nparv)='Cte_Henry;'
        cparamv(nparv,1:ncalcul)=henryv(1:ncalcul)
      else
        write(ific,*)'Cte de Henry : ;',henryv(1)
      endif
      if(henry_adimv(1).ne.henry_adimv(ncalcul))then
        write(ific,*)'Cte de Henry adimens :;variable'
        nparv=nparv+1
        nomspv(nparv)='Cte_Henry_adimens;'
        cparamv(nparv,1:ncalcul)=henry_adimv(1:ncalcul)
      else
        write(ific,*)'Cte de Henry adimens : ;',henry_adimv(1)
      endif
      if(diffusivitev(1).ne.diffusivitev(ncalcul))then
        write(ific,*)'Diffusivite dans air :;variable'
        nparv=nparv+1
        nomspv(nparv)='Diffusivite_air;'
        cparamv(nparv,1:ncalcul)=diffusivitev(1:ncalcul)
      else
        write(ific,*)'Diffusivite dans air : ;',diffusivitev(1)
      endif
      if(coefH_staudingerv(1).ne.coefH_staudingerv(ncalcul))then
        write(ific,*)'Coef Staudinger :;variable'
        nparv=nparv+1
        nomspv(nparv)='Coef_Staudinger;'
        cparamv(nparv,1:ncalcul)=coefH_staudingerv(1:ncalcul)
      else
        write(ific,*)'Coef Staudinger : ;',coefH_staudingerv(1)
      endif
      if(cte_saltv(1).ne.cte_saltv(ncalcul))then
        write(ific,*)'Cte salting out :;variable'
        nparv=nparv+1
        nomspv(nparv)='Cte_salting_out;'
        cparamv(nparv,1:ncalcul)=cte_saltv(1:ncalcul)
      else
        write(ific,*)'Cte salting out : ;',cte_saltv(1)
      endif
! reactions  
      write(ific,*)
      write(ific,*)'REACTIONS (autres que sorption) '       
      do ire=1,nb_reac
        write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_reac(ire))))
        if(nb_var_re(ire).gt.1)then
          write(ific,*)'entre;',TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,1)))),  &
              '; et ;',TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,2))))
        else
          write(ific,*)'affecte;',TRIM(ADJUSTL(ADJUSTR(name_var_re(ire,1))))
        endif
        if(cin_max_rev(ire,1).ne.cin_max_rev(ire,ncalcul))then
          write(ific,*)'cinetic max ; variable'
          nparv=nparv+1
          nomspv(nparv)=TRIM(ADJUSTL(ADJUSTR(name_reac(ire))))//';'
          cparamv(nparv,1:ncalcul)=cin_max_rev(ire,1:ncalcul)
        else
          write(ific,*)'cinetic max ;',cin_max_rev(ire,1)
        endif
      enddo
!  sorption
      write(ific,*)
      write(ific,*)'SORPTION '       
      write(ific,*)'especes dissoutes a l equilibre'
      write(ific,*)'nom espece;substrat associe;coef partage;'
#ifdef key_moco
      do iesp=1,nesp_diss_moco
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_espdmoco(iesp)))),';',  &
             TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(iesp)))),';',xequ(iesp)
      enddo
#else
      do iesp=nesp_diss_ne+1,nesp_diss
        if(xpart_espv(iesp,1).ne.xpart_espv(iesp,ncalcul))then
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                 TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp)))),'; VARIABLE'
          nparv=nparv+1
          nomspv(nparv)='Coef_partage'//name_esp(iesp)//';'
          cparamv(nparv,1:ncalcul)=xpart_espv(iesp,1:ncalcul)
        else
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
             TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp)))),';',xpart_espv(iesp,1)
        endif
      enddo
#endif  
      write(ific,*)
      write(ific,*)'especes particulaires a l equilibre '
#ifdef key_moco
!!!!!!!  ecriture des donnees pour MOCO
        write(ific,*)'calcul avec MOCO'
        write(ific,*)'nombre d especes dissoutes prises en compte ;',nesp_diss_moco
        if(.not.l_moco_op) then
          write(ific,*)'nombre de phases prises en compte     ;',nphasp
        endif
        write(ific,*)
        write(ific,*)'espece dissoute formee avec le ligand :;Ke;charge;nL;nHl'
        do iespmoc=1,nesp_diss_moco
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_lig_esp(iespmoc)))),&
          ';',xequ(iespmoc),'; ',ichare(iespmoc),';',xfactl(iespmoc),&
          ';',xfacth_esp(iespmoc)
        enddo
        write(ific,*)
        pos1=index(name_conta,'Hg')
        pos2=index(name_conta,'mercure')
        if(pos1/=0.or.pos2/=0)then
             write(ific,*)'phase;nsite;type de site;%site  '
        else
             write(ific,*)'phase;n site;type de site;%site'
        endif
        do js=1,nphasp
          do isit=1,nsit(js) 
            write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),';',&
                         isit,';',ityp_sit(isit,js)
          enddo
        enddo
      do js=1,nphasp
        if(sspv(js,1).ne.sspv(js,ncalcul))then
          write(ific,*)'SURFACE SPECIFIQUE DU SUBSTRAT ;',&
                TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),'; VARIABLE'
          nparv=nparv+1
          nomspv(nparv)='surface specifique '//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';'
          cparamv(nparv,1:ncalcul)=sspv(js,1:ncalcul)
        else
          write(ific,*)'SURFACE SPECIFIQUE DU SUBSTRAT ;',&
                     TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),';',sspv(js,1)
        endif
        do isit=1,nsit(js)
          if(sitacv(isit,js,1).ne.sitacv(isit,js,ncalcul))then
            write(ific,*)'conc SITES ACTIFS DU SUBSTRAT ;',&
           TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),'; DU SITE ',isit,'; VARIABLE'
            nparv=nparv+1
            nomspv(nparv)='surface specifique '//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';'
            cparamv(nparv,1:ncalcul)=sitacv(isit,js,1:ncalcul)
          else
            write(ific,*)'conc SITES ACTIFS DU SUBSTRAT ;',&
                 TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),'; DU SITE ',isit,';',sitacv(isit,js,1)
          endif
          if(xequa2v(isit,js,1).ne.xequa2v(isit,js,ncalcul))then
            write(ific,*)'CTE EQUILIBRE Ka2 DU SUBSTRAT ;',&
                 TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),'; DU SITE ',isit,';VARIABLE'
            nparv=nparv+1
            nomspv(nparv)='Ka2 de '//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';'
            cparamv(nparv,1:ncalcul)=xequa2v(isit,js,1:ncalcul)
          else
            write(ific,*)'Ka2 de ;'//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';',xequa2v(isit,js,1)
          endif
          if(xequmsv(isit,js,1).ne.xequmsv(isit,js,ncalcul))then
            write(ific,*)'CTE EQUILIBRE Km DU SUBSTRAT ;', &
                    TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),'; DU SITE ',isit,';VARIABLE'
            nparv=nparv+1
            nomspv(nparv)='Km de '//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';'
            cparamv(nparv,1:ncalcul)=xequmsv(isit,js,1:ncalcul)
          else
            write(ific,*)'Km de;'//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';',xequmsv(isit,js,1)
          endif
          if(ityp_sit(isit,js)==1)then
            if(xequa1v(isit,js,1).ne.xequa1v(isit,js,ncalcul))then
              write(ific,*)'CTE EQUILIBRE Ka1 DU SUBSTRAT;', &
                  TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),'; DU SITE ',isit,';VARIABLE'
              nparv=nparv+1
              nomspv(nparv)='Ka1 de'//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';'
              cparamv(nparv,1:ncalcul)=xequa1v(isit,js,1:ncalcul)
            else
              write(ific,*)'Ka1 de;'//TRIM(ADJUSTL(ADJUSTR(nom_phase(js))))//';',xequa1v(isit,js,1)
            endif
          endif
        enddo
      enddo
      write(ific,*)
      if(l_echgcat)then
            write(ific,*)'Echange avec cations pris en compte'
            write(ific,*)'nom du cation ;',nom_cat
            write(ific,*)'charge du cation ;',icharcat
            write(ific,*)'Cte equilibre  Kcat ;',xequcat
            write(ific,*)'Cte equilibre  Kmc ;',xequmet
            write(ific,*)'concentration du cation; ',ccat
      else
          write(ific,*)'pas d echange avec cations  '
      endif
      write(ific,*)
      if(l_competcat)then
         write(ific,*)'competition avec cations pris en compte'
         write(ific,*)'nom du cation ;',nom_cat
         write(ific,*)'charge du cation; ',icharcat
         write(ific,*)'concentration du cation; ',ccat
         write(ific,*)'phase;nsite;vari. charge;Cte equilibre Kcom Si-M;'
         do js=1,nphasp
           do isit=1,nsit(js) 
             write(ific,*)TRIM(ADJUSTL(ADJUSTR(nom_phase(js)))),&
                 ';',isit,';',idcharc(isit,js),';',xequcs(isit,js)
           enddo
         enddo
      else
          write(ific,*)'pas de competition avec cations  '
      endif
!      if(l_thiolpart)then
!         write(ific,*)'complexation avec sites thiols particulaire'
!         write(ific,*)'concentration total thiol particulaire (mole/g)=',cthiolpart
!         write(ific,*)'substrat correspondant',name_sub_thiol
!         write(ific,*)'constante d equilibre Kahp',xkathiolp
!         write(ific,*)'constante de complexation monodentate',xequRSHg
!         write(ific,*)'constante de complexation bidentate',xequR2SHg
!      endif
#else
      write(ific,*)'nom espece;substrat associe;coef partage;'
      do iesp=nesp_diss+1,nesp_diss+nesp_part_eq
        if(xpart_espv(iesp,1).ne.xpart_espv(iesp,ncalcul))then
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                 TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp)))),'; VARIABLE'
          nparv=nparv+1
          nomspv(nparv)='Coef_partage'//name_esp(iesp)//';'
          cparamv(nparv,1:ncalcul)=xpart_espv(iesp,1:ncalcul)
        else
          write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
               TRIM(ADJUSTL(ADJUSTR(name_sub_esp(iesp)))),';',xpart_espv(iesp,1)
        endif
      enddo  
#endif  

      write(ific,*)
      if(.not.l_dom_nl)then
        write(ific,*)'PAS de domaine de sorption NON LINEAIRE '          
      else
        write(ific,*)'domaines de sorption NON LINEAIRES a l equilibre '
        write(ific,*)'nom espece;modele;KL ou KF;fraction;','Qmax ou facteur d affinite'
        do iesp=nesp_diss+1,nesp_diss+nesp_part_eq
          do inl=1,n_dom_nl(iesp)
            if(l_langmuir)then
               name=';DMM Langmuir;'
            else
               name=';DRM Freundlich;'
            endif
            write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),  &
                      TRIM(ADJUSTL(ADJUSTR(name))),f_dom_nl(iesp,inl),  &
                     ';',xpartnl(iesp,inl),';',xsorptnl(iesp,inl)
          enddo
        enddo  
      endif
      write(ific,*)
      ii= nesp_diss+nesp_part_eq
      if(nesp_part_ci.eq.0)then
        write(ific,*)'PAS d espece traite en cinetique '          
      else
        write(ific,*)'domaines LINEAIRES traite en cinetique'
        write(ific,*)'nom espece;espece EQ associee;fraction initiale;Cte de vitesse, conc equilibre '
      endif
      write(ific,*)
      do iesp=ii+1,ii+nesp_part_ci
        if(cte_vitv(iesp-ii,1).ne.cte_vitv(iesp-ii,ncalcul))then
           nparv=nparv+1
           nomspv(nparv)='Cte de vitesse '//name_esp(iesp)//';'
           cparamv(nparv,1:ncalcul)=cte_vitv(iesp-ii,1:ncalcul)
           ivql=1
         else
           ivql=0
         endif
         if(ceq_civ(iesp-ii,1).ne.ceq_civ(iesp-ii,ncalcul))then
           nparv=nparv+1
           nomspv(nparv)='C_equilibre Cci '//name_esp(iesp)//';'
           cparamv(nparv,1:ncalcul)=ceq_civ(iesp-ii,1:ncalcul)
           iveq=1
         else
           iveq=0
         endif
         if(finitv(iesp,1).ne.finitv(iesp,ncalcul))then
           nparv=nparv+1
           nomspv(nparv)='fraction init '//name_esp(iesp)//';'
           cparamv(nparv,1:ncalcul)=finitv(iesp,1:ncalcul)
           ivfl=1
         else
           ivfl=0
         endif
         if(iveq.eq.0)then
            if(ivfl.eq.0.and.ivql.eq.0)then
              write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                  TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),     &
                finitv(iesp,1), ';',cte_vitv(iesp-ii,1),';',ceq_civ(iesp-ii,1)
            else if(ivfl.eq.0.and.ivql.eq.1)then
               write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),   &
                   TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),        &
                  finitv(iesp,1),';Cte vit variable;',ceq_civ(iesp-ii,1)
            else if(ivkl.eq.1.and.ivql.eq.0)then
               write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),   &
                    TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),        &
                  '; finit variable;',cte_vitv(iesp-ii,1),';',ceq_civ(iesp-ii,1)
            else if(ivkl.eq.1.and.ivql.eq.1)then
               write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),   &
                    TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),        &
                  ';finit variable;Cte vitesse variable'';',ceq_civ(iesp-ii,1)
            endif
         else
            if(ivfl.eq.0.and.ivql.eq.0)then
               write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                   TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),     &
                  finitv(iesp,1), ';',cte_vitv(iesp-ii,1),';C_equi_ci variable'
            else if(ivfl.eq.0.and.ivql.eq.1)then
               write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),   &
                    TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),     &
                    finitv(iesp,1),';Cte vit variable;C_equi_ci variable'
            else if(ivkl.eq.1.and.ivql.eq.0)then
               write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),   &
                    TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),     &
                  '; finit variable;',cte_vitv(iesp-ii,1),';C_equi_ci variable'
            else if(ivkl.eq.1.and.ivql.eq.1)then
                write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),   &
                     TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_assoc(iesp))))),     &
                  ';finit variable;Cte vitesse variable;C_equi_ci variable'
            endif
         endif
      enddo  

      write(ific,*)
      ii= nesp_diss+nesp_part_eq+nesp_part_ci
      if(nesp_part_ne.eq.0)then
         write(ific,*)'PAS de fractions part. non echangeable '          
      else
         write(ific,*)'fractions part. NON ECHANGEABLE'
         write(ific,*)'nom espece;type part associe;fraction initiale'
         do iesp=ii+1,ii+nesp_part_ne
           if(finitv(iesp,1).ne.finitv(iesp,ncalcul))then
              nparv=nparv+1
              nomspv(nparv)='fraction init '//name_esp(iesp)//';'
              cparamv(nparv,1:ncalcul)=finitv(iesp,1:ncalcul)
              write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                   ityp_part(iesp),';variable'
           else
              write(ific,*)TRIM(ADJUSTL(ADJUSTR(name_esp(iesp)))),';',  &
                      ityp_part(iesp),';',finitv(iesp,1)
           endif
         enddo  
       endif
      write(ific,*)
       if(l_volat)then
         write(ific,*)'l espece ',TRIM(ADJUSTL(ADJUSTR(name_esp(iesp_volat)))), &
                       ' se volatilise'
       else
         write(*,*)'pas de volatilisation'
       endif
       nomsaecrir='temps;'
       lnom=6
       do nn=1,nparv
          nomspp=nomspv(nn)
          lnam=index(nomspp,'  ')-1
          nomsaecrir=nomsaecrir(1:lnom)//nomspp(1:lnam)
          lnom=lnom+lnam+1
       enddo
      lnom=index(nomsaecrir,'  ')-2
! ecriture d un commentaire pour les unites
      write(ific,*)
      write(ific,*)'LES UNITES POUR LES ESPECES des CONTAMINANTS'
      write(ific,*)'SONT CELLES CHOISIES PAR L UTILISATEUR :;',unite_conta,';/m3'
#ifdef key_moco
      write(ific,*)'MAIS LES FLUX SONT EXPRIMES EN nmole/L (cumules au cours du temps)' 
#endif

    endif
    lnome=lnom      
    iesp=1
    do iesp=1,nvar
      lnom=index(name_esp(iesp),'  ')-1
      name=name_esp(iesp)
      if(iesp.eq.1)then
           nomsaecrir=nomsaecrir(1:lnome)//';'//name(1:lnom)
      else
           nomsaecrir=nomsaecrir(1:lnome)//';'//name(1:lnom)
      endif
      lnome=lnome+lnom+1
    enddo
    nomsaecrir=nomsaecrir(1:lnome)//';KD_global_(l/g)'
    lnome=lnome+16
    nomsaecrir=nomsaecrir(1:lnome)//';Conc_totale'
    lnome=lnome+13
        
    do iesp=1,nvar-1
      lnom=index(name_esp(iesp),'  ')-1
      name=name_esp(iesp)
      nomsaecrir=nomsaecrir(1:lnome)//';partage_'//name(1:lnom)
      lnome=lnome+lnom+9
    enddo
    do iesp=1,nvar-1
      lnom=index(name_esp(iesp),'  ')-1
      name=name_esp(iesp)
      nomsaecrir=nomsaecrir(1:lnome)//';transf_'//name(1:lnom)
      lnome=lnome+lnom+8
    enddo
    do iesp=1,nvar-1
      lnom=index(name_esp(iesp),'  ')-1
      name=name_esp(iesp)
      nomsaecrir=nomsaecrir(1:lnome)//';depo_'//name(1:lnom)
      lnome=lnome+lnom+6
    enddo
    do iesp=1,nvar-1
      lnom=index(name_esp(iesp),'  ')-1
      name=name_esp(iesp)
      nomsaecrir=nomsaecrir(1:lnome)//';Fl_in_'//name(1:lnom)
      lnome=lnome+lnom+7
    enddo
    do iesp=1,nvar-1
      lnom=index(name_esp(iesp),'  ')-1
      name=name_esp(iesp)
      nomsaecrir=nomsaecrir(1:lnome)//';Fl_out_'//name(1:lnom)
      lnome=lnome+lnom+8
    enddo
     lnom=index(name_esp(nvar),'  ')-1
     name=name_esp(nvar)
     nomsaecrir=nomsaecrir(1:lnome)//';partage_'//name(1:lnom)
     lnome=lnome+lnom+9
     nomsaecrir=nomsaecrir(1:lnome)//';transf_'//name(1:lnom)
     lnome=lnome+lnom+8
     nomsaecrir=nomsaecrir(1:lnome)//';Fl_in_'//name(1:lnom)
     lnome=lnome+lnom+7
     nomsaecrir=nomsaecrir(1:lnome)//';Fl_out_'//name(1:lnom)
     lnome=lnome+lnom+8
     if(l_volat)then
        name=name_esp(iesp_volat)
        nomsaecrir=nomsaecrir(1:lnome)//';volat_'//name(1:lnom)
     endif
     lnome1=lnome+lnom+7
     lnome=lnome+lnom+7

! allocation du tableau des cesp converti en unite utilisateur pour
!   l ecriture des resultats
   allocate(c_conta_tot_converti(ncalcul))
   allocate(cesp_converti(nvar,ncalcul))
   if(l_mode1c)allocate(var_milieu_converti(9,ncalcul))   

! calcul du nombre de colonnes pour les fichiers resultats
   if(l_mode1c)then
     ncol_60=1+9+nsub+nvar+2+(nvar-1)*5+5
   else
     ncol_60=1+nparv+nvar+2+(nvar-1)*5+5
   endif
   write(*,*)'nombre de colonnes pour fichier resultat : ',ncol_60
   write(*,*)'**********************************************************'
   write(ific,*)'nombre de colonnes pour fichier resultat : ',ncol_60
   write(ific,*)'**********************************************************'
   
! 
!  fichiers resultats scenarios (1/scenario) en fonction du temps
ALLOCATE(ifich1(ncalcul))
do ific=1,ncalcul
  ifich1(ific)=60+ific
  if(ific<10)then
     write(nomfic,101)ific
  else if(ific<100)then
     write(nomfic,102)ific
  else if(ific<1000)then
     write(nomfic,103)ific
  else if(ific<10000)then
     write(nomfic,104)ific
  endif
  name_ficres1='resultat/'//TRIM(ADJUSTL(ADJUSTR(name_ficres)))//'_scen_'//TRIM(ADJUSTL(ADJUSTR(nomfic)))
  open(ifich1(ific),file=name_ficres1)
  write(ifich1(ific),*)nomsaecrir
enddo

! fichiers resultats de tous les scenatios  differents instants (1 fichier/instant)
!  si plus d'un scenario
if(ncalcul>1)then
  ALLOCATE(ifich2(necr_scenario+1))
  do ific=1,necr_scenario+1
    ifich2(ific)=260+ific
    if(ific<10)then
       write(nomfic,101)ific
    else if(ific<100)then
       write(nomfic,102)ific
    else if(ific<1000)then
       write(nomfic,103)ific
    else if(ific<10000)then
       write(nomfic,104)ific
    endif
    name_ficres2='resultat/'//TRIM(ADJUSTL(ADJUSTR(name_ficres)))//'_temps_'//TRIM(ADJUSTL(ADJUSTR(nomfic)))
    open(ifich2(ific),file=name_ficres2)
    write(ifich2(ific),*)nomsaecrir
  enddo
endif
  
101  format(i1)
102  format(i2)
103  format(i3)
104  format(i4)

   END SUBROUTINE init_ficres
      
!
! ****************************************************************************
!   ===========================================================      
!   ecriture des resultats dans un fichier format ASCII
!    separateur : ";"
!   un fichier par scenario en fonction du temps
!   ===========================================================  
      SUBROUTINE ecri_result_scen

real(kind=rlg)                     :: tj
integer                            ::  i,ific
      
! conversion des resultats (sauf flux) dans l'unite d'origine de l'utilisateur
!  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
cesp_converti(:,1:ncalcul)=cesp(:,1:ncalcul)/conversunit
c_conta_tot_converti(:)=c_conta_tot(:) /conversunit
     
tj=t/86400
if(l_volat)then
  if(l_mode1c)then
     var_milieu_converti(:,1:ncalcul)=var_milieu(:,1:ncalcul)
     var_milieu_converti(7:8,1:ncalcul)=var_milieu(7:8,1:ncalcul)/conversunit
     do i=1,ncalcul
        ific=60+i
        write(ific,101)tj,var_milieu_converti(:,i),csub_v(:,i),cesp_converti(:,i),    &
            xpartg(i),c_conta_tot_converti(i),smass_part(1:nvar-1,i),     &       
            smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
            smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
            smass_flout(nvar,i),smass_vol(i)
     enddo
  else
     do i=1,ncalcul
        ific=60+i
        write(ific,101)tj,cparamv(1:nparv,i),cesp_converti(:,i),xpartg(i),c_conta_tot(i),&       
            smass_part(1:nvar-1,i),smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
             smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
             smass_flout(nvar,i),smass_vol(i)
     enddo
  endif
else
  if(l_mode1c)then
     var_milieu_converti(:,1:ncalcul)=var_milieu(:,1:ncalcul)
     var_milieu_converti(7:8,1:ncalcul)=var_milieu(7:8,1:ncalcul)/conversunit
     do i=1,ncalcul
        ific=60+i
        write(ific,101)tj,var_milieu_converti(:,i),csub_v(:,i),cesp_converti(:,i),    &
            xpartg(i),c_conta_tot_converti(i),smass_part(1:nvar-1,i),     &       
            smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
            smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
            smass_flout(nvar,i)
     enddo
  else
     do i=1,ncalcul
        ific=60+i
        write(ific,101)tj,cparamv(1:nparv,i),cesp_converti(:,i),xpartg(i),c_conta_tot(i),&       
            smass_part(1:nvar-1,i),smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
             smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
             smass_flout(nvar,i)
     enddo
  endif
endif
  101  format(g20.5,';',500(g10.3,';'))
  201  format(g20.5,';',500(g10.3,';'))
  
   END SUBROUTINE ecri_result_scen
!****************************************************************************
! ****************************************************************************
!   ===========================================================      
!   ecriture des resultats dans un fichier format ASCII
!    separateur : ";"
!    un fichier par instant : ecriture de tous les scenarios les uns aprs les autres
!   ===========================================================  
      SUBROUTINE ecri_result_temps(ific)

real(kind=rlg)                     :: tj
integer                            ::  i,ific
      
! conversion des resultats (sauf flux) dans l'unite d'origine de l'utilisateur
!  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
cesp_converti(:,1:ncalcul)=cesp(:,1:ncalcul)/conversunit
c_conta_tot_converti(:)=c_conta_tot(:) /conversunit
     
tj=t/86400
if(l_volat)then
  if(l_mode1c)then
     var_milieu_converti(:,1:ncalcul)=var_milieu(:,1:ncalcul)
     var_milieu_converti(7:8,1:ncalcul)=var_milieu(7:8,1:ncalcul)/conversunit
     do i=1,ncalcul
        write(ific,101)tj,var_milieu_converti(:,i),csub_v(:,i),cesp_converti(:,i),    &
            xpartg(i),c_conta_tot_converti(i),smass_part(1:nvar-1,i),     &       
            smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
            smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
            smass_flout(nvar,i),smass_vol(i)
     enddo
  else
     do i=1,ncalcul
        write(ific,101)tj,cparamv(1:nparv,i),cesp_converti(:,i),xpartg(i),c_conta_tot(i),&       
            smass_part(1:nvar-1,i),smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
             smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
             smass_flout(nvar,i),smass_vol(i)
     enddo
  endif
else
  if(l_mode1c)then
     var_milieu_converti(:,1:ncalcul)=var_milieu(:,1:ncalcul)
     var_milieu_converti(7:8,1:ncalcul)=var_milieu(7:8,1:ncalcul)/conversunit
     do i=1,ncalcul
        write(ific,101)tj,var_milieu_converti(:,i),csub_v(:,i),cesp_converti(:,i),    &
            xpartg(i),c_conta_tot_converti(i),smass_part(1:nvar-1,i),     &       
            smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
            smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
            smass_flout(nvar,i)
     enddo
  else
     do i=1,ncalcul
        write(ific,101)tj,cparamv(1:nparv,i),cesp_converti(:,i),xpartg(i),c_conta_tot(i),&       
            smass_part(1:nvar-1,i),smass_transf(1:nvar-1,i),smass_depo(1:nvar-1,i),   &
            smass_flin(1:nvar-1,i),smass_flout(1:nvar-1,i),   &
             smass_part(nvar,i),smass_transf(nvar,i),smass_flin(nvar,i),  &
             smass_flout(nvar,i)
     enddo
  endif
endif
  101  format(g20.5,';',500(g10.3,';'))
  201  format(g20.5,';',500(g10.3,';'))
  
   END SUBROUTINE ecri_result_temps
!****************************************************************************
 END MODULE resultat

